/**
 * @license
 * Copyright 2023 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
import*as e from"@tensorflow/tfjs-core";import{env as t,util as n,clone as r,scalar as s,keep as a,tensor as o,stack as i,concat as u,unstack as p,tidy as l,reshape as c,slice as h,io as d,Tensor as m,dispose as f}from"@tensorflow/tfjs-core";function y(e,t){return t.forEach((function(t){Object.keys(t).forEach((function(n){if("default"!==n&&!(n in e)){var r=Object.getOwnPropertyDescriptor(t,n);Object.defineProperty(e,n,r.get?r:{enumerable:!0,get:function(){return t[n]}})}}))})),e}var g,b;t().registerFlag("KEEP_INTERMEDIATE_TENSORS",(()=>!1),(e=>{e&&console.warn("Keep intermediate tensors is ON. This will print the values of all intermediate tensors during model inference. Not all models support this mode. For details, check e2e/benchmarks/ model_config.js. This significantly impacts performance.")})),function(e){e[e.DT_INVALID=0]="DT_INVALID",e[e.DT_FLOAT=1]="DT_FLOAT",e[e.DT_DOUBLE=2]="DT_DOUBLE",e[e.DT_INT32=3]="DT_INT32",e[e.DT_UINT8=4]="DT_UINT8",e[e.DT_INT16=5]="DT_INT16",e[e.DT_INT8=6]="DT_INT8",e[e.DT_STRING=7]="DT_STRING",e[e.DT_COMPLEX64=8]="DT_COMPLEX64",e[e.DT_INT64=9]="DT_INT64",e[e.DT_BOOL=10]="DT_BOOL",e[e.DT_QINT8=11]="DT_QINT8",e[e.DT_QUINT8=12]="DT_QUINT8",e[e.DT_QINT32=13]="DT_QINT32",e[e.DT_BFLOAT16=14]="DT_BFLOAT16",e[e.DT_QINT16=15]="DT_QINT16",e[e.DT_QUINT16=16]="DT_QUINT16",e[e.DT_UINT16=17]="DT_UINT16",e[e.DT_COMPLEX128=18]="DT_COMPLEX128",e[e.DT_HALF=19]="DT_HALF",e[e.DT_RESOURCE=20]="DT_RESOURCE",e[e.DT_VARIANT=21]="DT_VARIANT",e[e.DT_UINT32=22]="DT_UINT32",e[e.DT_UINT64=23]="DT_UINT64",e[e.DT_FLOAT_REF=101]="DT_FLOAT_REF",e[e.DT_DOUBLE_REF=102]="DT_DOUBLE_REF",e[e.DT_INT32_REF=103]="DT_INT32_REF",e[e.DT_UINT8_REF=104]="DT_UINT8_REF",e[e.DT_INT16_REF=105]="DT_INT16_REF",e[e.DT_INT8_REF=106]="DT_INT8_REF",e[e.DT_STRING_REF=107]="DT_STRING_REF",e[e.DT_COMPLEX64_REF=108]="DT_COMPLEX64_REF",e[e.DT_INT64_REF=109]="DT_INT64_REF",e[e.DT_BOOL_REF=110]="DT_BOOL_REF",e[e.DT_QINT8_REF=111]="DT_QINT8_REF",e[e.DT_QUINT8_REF=112]="DT_QUINT8_REF",e[e.DT_QINT32_REF=113]="DT_QINT32_REF",e[e.DT_BFLOAT16_REF=114]="DT_BFLOAT16_REF",e[e.DT_QINT16_REF=115]="DT_QINT16_REF",e[e.DT_QUINT16_REF=116]="DT_QUINT16_REF",e[e.DT_UINT16_REF=117]="DT_UINT16_REF",e[e.DT_COMPLEX128_REF=118]="DT_COMPLEX128_REF",e[e.DT_HALF_REF=119]="DT_HALF_REF",e[e.DT_RESOURCE_REF=120]="DT_RESOURCE_REF",e[e.DT_VARIANT_REF=121]="DT_VARIANT_REF",e[e.DT_UINT32_REF=122]="DT_UINT32_REF",e[e.DT_UINT64_REF=123]="DT_UINT64_REF"}(g||(g={})),function(e){var t;(t=e.CheckpointFormatVersion||(e.CheckpointFormatVersion={}))[t.LEGACY=0]="LEGACY",t[t.V1=1]="V1",t[t.V2=2]="V2"}(b||(b={}));const N={};function x(e,t){const n={tfOpName:e,category:"custom",inputs:[],attrs:[],customExecutor:t};N[e]=n}function w(e){return N[e]}function k(e){delete N[e]}function T(e,t,r,s,a){const o=t.inputParams[e];if(o&&void 0!==o.inputIndexStart){const e=o.inputIndexStart,i=0===o.inputIndexEnd?void 0:void 0===o.inputIndexEnd?e+1:o.inputIndexEnd,u=e<0?t.inputNames.length+e:e;if("tensor"===o.type)return v(t.inputNames[u],r,s,a);if("tensors"===o.type){const n=t.inputs.slice(e,i);return t.inputNames.slice(e,i).filter(((e,t)=>{var r;return"NoOp"!==(null===(r=n[t])||void 0===r?void 0:r.op)})).map((e=>v(e,r,s,a)))}const p=v(t.inputNames[u],r,s,a),l=p.dataSync();return"number"===o.type?l[0]:n.toNestedArray(p.shape,l)}const i=t.attrParams[e];return i&&i.value}function v(e,t,n,r){const[s,a]=I(e,n);if(null!=r){const e=r.getHashTableHandleByName(s);if(null!=e)return e}const o=n.currentContextIds.find((e=>!!t[E(s,e)]));return void 0!==o?t[E(s,o)][a]:void 0}function _(e,t,n){return t[E(e,n.currentContextId)]}function S(e,t){const[n,r,s]=I(e,t);return[E(n,t&&t.currentContextId),r,s]}function E(e,t){return t?`${e}-${t}`:e}function I(e,t){if(""===e)return["",0,void 0];const n=null!=t&&null!=t.parseNodeNameCache;if(n){const n=t.parseNodeNameCache.get(e);if(null!=n)return n}const r=e.split(":");let s;if(1===r.length)s=[e,0,void 0];else{const e=r[0],t=3===r.length?r[1]:void 0;s=[e,Number(r[r.length-1]),t]}return n&&t.parseNodeNameCache.set(e,s),s}function $(e,t,n){let r=T("pad",e,t,n);if("explicit"===r){r=T("explicitPaddings",e,t,n);const s=[[0,0],[0,0],[0,0],[0,0]];for(let e=0;e<4;e++)s[e][0]=r[2*e],s[e][1]=r[2*e+1];return s}return r}function D(e){return e.kept?e:r(e)}var A={__proto__:null,json:[{tfOpName:"Add",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"AddV2",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"AddN",category:"arithmetic",inputs:[{start:0,end:0,name:"tensors",type:"tensors"}]},{tfOpName:"BiasAdd",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"Sub",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"RealDiv",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Div",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"DivNoNan",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"FloorDiv",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Mul",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Maximum",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Minimum",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Pow",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"SquaredDifference",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Mod",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"FloorMod",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}]};var O={__proto__:null,json:[{tfOpName:"Abs",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Acos",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Asin",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Atan",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Atan2",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"y",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Ceil",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ClipByValue",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"clipValueMin",type:"number"},{start:2,name:"clipValueMax",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Complex",category:"basic_math",inputs:[{start:0,name:"real",type:"tensor"},{start:1,name:"imag",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ComplexAbs",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Cos",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Cosh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Elu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Exp",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Floor",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Log",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Imag",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"Tout",name:"outputType",type:"dtype",notSupported:!0}]},{tfOpName:"Neg",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Real",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"Tout",name:"outputType",type:"dtype",notSupported:!0}]},{tfOpName:"Prelu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"alpha",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Relu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Relu6",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Selu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sigmoid",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sin",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sinh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sqrt",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Rsqrt",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Square",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Tan",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Tanh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sign",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Round",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Expm1",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Log1p",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Reciprocal",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Softplus",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Asinh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Acosh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Atanh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Erf",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Prod",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axes",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool",notSupported:!0},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LeakyRelu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"alpha",name:"alpha",type:"number",defaultValue:.2},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"IsNan",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"IsFinite",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"IsInf",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}]};var M={__proto__:null,json:[{tfOpName:"EmptyTensorList",category:"control",inputs:[{start:0,name:"elementShape",type:"shape"},{start:1,name:"maxNumElements",type:"number"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"LoopCond",category:"control",inputs:[{start:0,name:"pred",type:"tensor"}]},{tfOpName:"Switch",category:"control",inputs:[{start:0,name:"data",type:"tensor"},{start:1,name:"pred",type:"tensor"}]},{tfOpName:"Merge",category:"control",inputs:[{start:0,end:0,name:"tensors",type:"tensors"}]},{tfOpName:"Enter",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"frame_name",name:"frameName",type:"string"},{tfName:"is_constant",name:"isConstant",type:"bool"}]},{tfOpName:"Exit",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"NextIteration",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"TensorArrayV3",category:"control",inputs:[{start:0,name:"size",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"element_shape",name:"elementShape",type:"shape"},{tfName:"dynamic_size",name:"dynamicSize",type:"bool"},{tfName:"clear_after_read",name:"clearAfterRead",type:"bool"},{tfName:"identical_element_shapes",name:"identicalElementShapes",type:"bool"},{tfName:"tensor_array_name",name:"name",type:"string"}]},{tfOpName:"TensorArrayWriteV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"index",type:"number"},{start:2,name:"tensor",type:"tensor"},{start:3,name:"flowIn",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"TensorArrayReadV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"index",type:"number"},{start:2,name:"flowIn",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"TensorArrayGatherV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"flowIn",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"element_shape",name:"elementShape",type:"shape"}]},{tfOpName:"TensorArrayScatterV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"tensor",type:"tensor"},{start:3,name:"flowIn",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"TensorArrayConcatV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"flowIn",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"element_shape_except0",name:"elementShapeExcept0",type:"shape",notSupported:!0}]},{tfOpName:"TensorArraySplitV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"tensor",type:"tensor"},{start:2,name:"lengths",type:"number[]"},{start:3,name:"flowIn",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"TensorArraySizeV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"flowIn",type:"number"}]},{tfOpName:"TensorArrayCloseV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"}]},{tfOpName:"StatelessIf",category:"control",inputs:[{start:0,name:"cond",type:"tensor"},{start:1,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"then_branch",name:"thenBranch",type:"func"},{tfName:"else_branch",name:"elseBranch",type:"func"}]},{tfOpName:"If",category:"control",inputs:[{start:0,name:"cond",type:"tensor"},{start:1,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"then_branch",name:"thenBranch",type:"func"},{tfName:"else_branch",name:"elseBranch",type:"func"}]},{tfOpName:"StatelessWhile",category:"control",inputs:[{start:0,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"cond",name:"cond",type:"func"},{tfName:"body",name:"body",type:"func"}]},{tfOpName:"While",category:"control",inputs:[{start:0,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"cond",name:"cond",type:"func"},{tfName:"body",name:"body",type:"func"}]},{tfOpName:"TensorListScatter",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListScatterV2",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"elementShape",type:"shape"},{start:3,name:"numElements",type:"number"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListGather",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListGetItem",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"index",type:"number"},{start:2,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListSetItem",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"index",type:"number"},{start:2,name:"tensor",type:"tensor"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListReserve",category:"control",inputs:[{start:0,name:"elementShape",type:"shape"},{start:1,name:"numElements",type:"number"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListFromTensor",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"},{start:1,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListStack",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"},{tfName:"num_elements",name:"numElements",type:"dtype"}]},{tfOpName:"TensorListSplit",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"},{start:1,name:"elementShape",type:"shape"},{start:2,name:"lengths",type:"number[]"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListConcat",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"}],attrs:[{tfName:"element_shape",name:"elementShape",type:"shape"},{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListConcatV2",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"}],attrs:[{tfName:"element_shape",name:"elementShape",type:"shape"},{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListPopBack",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListPushBack",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"tensor",type:"tensor"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListLength",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"}]},{tfOpName:"TensorListResize",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"size",type:"number"}]}]};var C={__proto__:null,json:[{tfOpName:"AvgPool",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"MaxPool",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[],notSupported:!0},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"MaxPoolWithArgmax",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"include_batch_in_index",name:"includeBatchInIndex",type:"bool"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"AvgPool3D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"MaxPool3D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Conv1D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"stride",name:"stride",type:"number"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NWC"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"dilation",name:"dilation",type:"number",defaultValue:1}]},{tfOpName:"Conv2D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"useCudnnOnGpu",name:"useCudnnOnGpu",type:"bool"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"dilations",name:"dilations",type:"number[]"}]},{tfOpName:"_FusedConv2D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"},{start:2,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"num_args",name:"numArgs",type:"number"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"use_cudnn_on_gpu",name:"useCudnnOnGpu",type:"bool",defaultValue:!0},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"dilations",name:"dilations",type:"number[]",defaultValue:[1,1,1,1]},{tfName:"fused_ops",name:"fusedOps",type:"string[]",defaultValue:[]},{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:1e-4},{tfName:"leakyrelu_alpha",name:"leakyreluAlpha",type:"number",defaultValue:.2}]},{tfOpName:"Conv2DBackpropInput",category:"convolution",inputs:[{start:2,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"},{start:0,name:"outputShape",type:"number[]"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"dilations",name:"dilations",type:"number[]",notSupported:!0}]},{tfOpName:"DepthwiseConv2d",category:"convolution",inputs:[{start:0,name:"input",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"dilations",name:"dilations",type:"number[]"}]},{tfOpName:"DepthwiseConv2dNative",category:"convolution",inputs:[{start:0,name:"input",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"dilations",name:"dilations",type:"number[]"}]},{tfOpName:"FusedDepthwiseConv2dNative",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"},{start:2,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"num_args",name:"numArgs",type:"number"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"dilations",name:"dilations",type:"number[]",defaultValue:[1,1,1,1]},{tfName:"fused_ops",name:"fusedOps",type:"string[]",defaultValue:[]},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]}]},{tfOpName:"Conv3D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"dilations",name:"dilations",type:"number[]"}]},{tfOpName:"Dilation2D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"rates",name:"dilations",type:"number[]"},{tfName:"padding",name:"pad",type:"string"}]}]};var F={__proto__:null,json:[{tfOpName:"Fill",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"},{start:1,name:"value",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"LinSpace",category:"creation",inputs:[{start:0,name:"start",type:"number"},{start:1,name:"stop",type:"number"},{start:2,name:"num",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"OneHot",category:"creation",inputs:[{start:0,name:"indices",type:"tensor"},{start:1,name:"depth",type:"number"},{start:2,name:"onValue",type:"number",defaultValue:1},{start:3,name:"offValue",type:"number",defaultValue:0}],attrs:[{tfName:"axis",name:"axis",type:"number",notSupported:!0},{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"Ones",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"OnesLike",category:"creation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"}]},{tfOpName:"RandomStandardNormal",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"seed",name:"seed",type:"number",defaultValue:0},{tfName:"seed2",name:"seed2",type:"number",defaultValue:0,notSupported:!0},{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"T",name:"T",type:"number",notSupported:!0}]},{tfOpName:"RandomUniform",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"minval",name:"minval",type:"number",defaultValue:0},{tfName:"maxval",name:"maxval",type:"number",defaultValue:1},{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"seed",name:"seed",type:"number",defaultValue:0},{tfName:"seed2",name:"seed2",type:"number",defaultValue:0,notSupported:!0},{tfName:"T",name:"T",type:"number",notSupported:!0}]},{tfOpName:"Range",category:"creation",inputs:[{start:0,name:"start",type:"number"},{start:1,name:"stop",type:"number"},{start:2,name:"step",type:"number",defaultValue:0}],attrs:[{tfName:"Tidx",name:"dtype",type:"dtype"}]},{tfOpName:"TruncatedNormal",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"means",name:"mean",type:"number",defaultValue:0},{tfName:"stddev",name:"stdDev",type:"number",defaultValue:1},{tfName:"seed",name:"seed",type:"number"},{tfName:"seed2",name:"seed2",type:"number",defaultValue:0,notSupported:!0},{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"T",name:"T",type:"number",notSupported:!0}]},{tfOpName:"Zeros",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"ZerosLike",category:"creation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"Multinomial",category:"creation",inputs:[{start:0,name:"logits",type:"tensor"},{start:1,name:"numSamples",type:"number"}],attrs:[{tfName:"seed",name:"seed",type:"number"},{tfName:"seed2",name:"seed2",type:"number"},{tfName:"T",name:"dtype",type:"dtype"},{tfName:"output_dtype",name:"output_dtype",type:"dtype"}]}]};var R={__proto__:null,json:[{tfOpName:"NonMaxSuppressionV2",category:"dynamic",inputs:[{start:0,name:"boxes",type:"tensor"},{start:1,name:"scores",type:"tensor"},{start:2,name:"maxOutputSize",type:"number"},{start:3,name:"iouThreshold",type:"number"}]},{tfOpName:"NonMaxSuppressionV3",category:"dynamic",inputs:[{start:0,name:"boxes",type:"tensor"},{start:1,name:"scores",type:"tensor"},{start:2,name:"maxOutputSize",type:"number"},{start:3,name:"iouThreshold",type:"number"},{start:4,name:"scoreThreshold",type:"number"}]},{tfOpName:"NonMaxSuppressionV4",category:"dynamic",inputs:[{start:0,name:"boxes",type:"tensor"},{start:1,name:"scores",type:"tensor"},{start:2,name:"maxOutputSize",type:"number"},{start:3,name:"iouThreshold",type:"number"},{start:4,name:"scoreThreshold",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"T_threshold",name:"threshold",type:"dtype",notSupported:!0},{tfName:"pad_to_max_output_size",name:"padToMaxOutputSize",type:"bool"}]},{tfOpName:"NonMaxSuppressionV5",category:"dynamic",inputs:[{start:0,name:"boxes",type:"tensor"},{start:1,name:"scores",type:"tensor"},{start:2,name:"maxOutputSize",type:"number"},{start:3,name:"iouThreshold",type:"number"},{start:4,name:"scoreThreshold",type:"number"},{start:5,name:"softNmsSigma",type:"number"}]},{tfOpName:"Where",category:"dynamic",inputs:[{start:0,name:"condition",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ListDiff",category:"dynamic",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"y",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}]};var z={__proto__:null,json:[{tfOpName:"LowerBound",category:"evaluation",inputs:[{start:0,name:"sortedSequence",type:"tensor"},{start:1,name:"values",type:"tensor"}]},{tfOpName:"TopKV2",category:"evaluation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"k",type:"number"}],attrs:[{tfName:"sorted",name:"sorted",type:"bool"}]},{tfOpName:"UpperBound",category:"evaluation",inputs:[{start:0,name:"sortedSequence",type:"tensor"},{start:1,name:"values",type:"tensor"}]},{tfOpName:"Unique",category:"evaluation",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"UniqueV2",category:"evaluation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}]}]};var V={__proto__:null,json:[{tfOpName:"PlaceholderWithDefault",category:"graph",inputs:[{start:0,name:"default",type:"tensor"}],attrs:[{tfName:"shape",name:"shape",type:"shape"},{tfName:"dtype",name:"dtype",type:"dtype"}]},{tfOpName:"Placeholder",category:"graph",attrs:[{tfName:"shape",name:"shape",type:"shape"},{tfName:"dtype",name:"dtype",type:"dtype"}]},{tfOpName:"Const",category:"graph"},{tfOpName:"Identity",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"IdentityN",category:"graph",inputs:[{start:0,end:0,name:"x",type:"tensors"}]},{tfOpName:"Snapshot",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"Rank",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"Size",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"Shape",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"ShapeN",category:"graph",inputs:[{start:0,end:0,name:"x",type:"tensors"}]},{tfOpName:"Print",category:"graph",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"data",type:"tensors"}],attrs:[{tfName:"message",name:"message",type:"string"},{tfName:"first_n",name:"firstN",type:"number",notSupported:!0},{tfName:"summarize",name:"summarize",type:"number",defaultValue:3}]},{tfOpName:"NoOp",category:"graph",inputs:[]},{tfOpName:"StopGradient",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"FakeQuantWithMinMaxVars",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"min",name:"min",type:"number"},{tfName:"max",name:"max",type:"number"}]}]};var L={__proto__:null,json:[{tfOpName:"HashTable",category:"hash_table",inputs:[],attrs:[{tfName:"shared_name",name:"sharedName",type:"string"},{tfName:"use_node_name_sharing",name:"useNodeNameSharing",type:"bool"},{tfName:"key_dtype",name:"keyDType",type:"dtype"},{tfName:"value_dtype",name:"valueDType",type:"dtype"}]},{tfOpName:"HashTableV2",category:"hash_table",inputs:[],attrs:[{tfName:"shared_name",name:"sharedName",type:"string"},{tfName:"use_node_name_sharing",name:"useNodeNameSharing",type:"bool"},{tfName:"key_dtype",name:"keyDType",type:"dtype"},{tfName:"value_dtype",name:"valueDType",type:"dtype"}]},{tfOpName:"LookupTableImport",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"values",type:"tensor"}],attrs:[{tfName:"Tin",name:"tIn",type:"dtype",notSupported:!0},{tfName:"Tout",name:"tOut",type:"dtype",notSupported:!0}]},{tfOpName:"LookupTableImportV2",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"values",type:"tensor"}],attrs:[{tfName:"Tin",name:"tIn",type:"dtype",notSupported:!0},{tfName:"Tout",name:"tOut",type:"dtype",notSupported:!0}]},{tfOpName:"LookupTableFind",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"defaultValue",type:"tensor"}],attrs:[{tfName:"Tin",name:"tIn",type:"dtype",notSupported:!0},{tfName:"Tout",name:"tOut",type:"dtype",notSupported:!0}]},{tfOpName:"LookupTableFindV2",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"defaultValue",type:"tensor"}],attrs:[{tfName:"Tin",name:"tIn",type:"dtype",notSupported:!0},{tfName:"Tout",name:"tOut",type:"dtype",notSupported:!0}]},{tfOpName:"LookupTableSize",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"}]},{tfOpName:"LookupTableSizeV2",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"}]},{tfOpName:"InitializeTable",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"values",type:"tensor"}]},{tfOpName:"InitializeTableV2",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"values",type:"tensor"}]}]};var B={__proto__:null,json:[{tfOpName:"ResizeBilinear",category:"image",inputs:[{start:0,name:"images",type:"tensor"},{start:1,name:"size",type:"number[]"}],attrs:[{tfName:"align_corners",name:"alignCorners",type:"bool"},{tfName:"half_pixel_centers",name:"halfPixelCenters",type:"bool"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ResizeNearestNeighbor",category:"image",inputs:[{start:0,name:"images",type:"tensor"},{start:1,name:"size",type:"number[]"}],attrs:[{tfName:"align_corners",name:"alignCorners",type:"bool"},{tfName:"half_pixel_centers",name:"halfPixelCenters",type:"bool"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"CropAndResize",category:"image",inputs:[{start:0,name:"image",type:"tensor"},{start:1,name:"boxes",type:"tensor"},{start:2,name:"boxInd",type:"tensor"},{start:3,name:"cropSize",type:"number[]"}],attrs:[{tfName:"method",name:"method",type:"string"},{tfName:"extrapolation_value",name:"extrapolationValue",type:"number"}]},{tfOpName:"ImageProjectiveTransformV3",category:"image",inputs:[{start:0,name:"images",type:"tensor"},{start:1,name:"transforms",type:"tensor"},{start:2,name:"outputShape",type:"number[]"},{start:3,name:"fillValue",type:"number"}],attrs:[{tfName:"interpolation",name:"interpolation",type:"string"},{tfName:"fill_mode",name:"fillMode",type:"string"}]}]};var P={__proto__:null,json:[{tfOpName:"Equal",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"NotEqual",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Greater",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"GreaterEqual",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Less",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LessEqual",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LogicalAnd",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LogicalNot",category:"logical",inputs:[{start:0,name:"a",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LogicalOr",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Select",category:"logical",inputs:[{start:0,name:"condition",type:"tensor"},{start:1,name:"a",type:"tensor"},{start:2,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"SelectV2",category:"logical",inputs:[{start:0,name:"condition",type:"tensor"},{start:1,name:"a",type:"tensor"},{start:2,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}]};var K={__proto__:null,json:[{tfOpName:"_FusedMatMul",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"},{start:2,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"num_args",name:"numArgs",type:"number"},{tfName:"fused_ops",name:"fusedOps",type:"string[]",defaultValue:[]},{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:1e-4},{tfName:"transpose_a",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"transpose_b",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"leakyrelu_alpha",name:"leakyreluAlpha",type:"number",defaultValue:.2},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"MatMul",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"transpose_a",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"transpose_b",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"BatchMatMul",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"adj_x",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"adj_y",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"BatchMatMulV2",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"adj_x",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"adj_y",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Transpose",category:"matrices",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"perm",type:"number[]"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Einsum",category:"matrices",inputs:[{start:0,end:0,name:"tensors",type:"tensors"}],attrs:[{tfName:"equation",name:"equation",type:"string"},{tfName:"N",name:"n",type:"number",defaultValue:2},{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"MatrixBandPart",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"numLower",type:"tensor"},{start:1,name:"numUpper",type:"tensor"}]}]};var q={__proto__:null,json:[{tfOpName:"EuclideanNorm",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool",defaultValue:!1}]},{tfOpName:"FusedBatchNorm",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"scale",type:"tensor"},{start:2,name:"offset",type:"tensor"},{start:3,name:"mean",type:"tensor"},{start:4,name:"variance",type:"tensor"}],attrs:[{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:.001},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"FusedBatchNormV2",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"scale",type:"tensor"},{start:2,name:"offset",type:"tensor"},{start:3,name:"mean",type:"tensor"},{start:4,name:"variance",type:"tensor"}],attrs:[{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:.001},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"FusedBatchNormV3",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"scale",type:"tensor"},{start:2,name:"offset",type:"tensor"},{start:3,name:"mean",type:"tensor"},{start:4,name:"variance",type:"tensor"}],attrs:[{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:.001},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"LRN",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"depth_radius",name:"radius",type:"number",defaultValue:5},{tfName:"bias",name:"bias",type:"number",defaultValue:1},{tfName:"alpha",name:"alpha",type:"number",defaultValue:1},{tfName:"beta",name:"beta",type:"number",defaultValue:.5}]},{tfOpName:"Softmax",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"LogSoftmax",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"SparseToDense",category:"normalization",inputs:[{start:0,name:"sparseIndices",type:"tensor"},{start:1,name:"outputShape",type:"number[]"},{start:2,name:"sparseValues",type:"tensor"},{start:3,name:"defaultValue",type:"tensor"}],attrs:[{tfName:"validate_indices",name:"validateIndices",type:"bool",defaultValue:!0,notSupported:!0}]}]};var U={__proto__:null,json:[{tfOpName:"Bincount",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"size",type:"number"},{start:2,name:"weights",type:"tensor"}]},{tfOpName:"DenseBincount",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"size",type:"number"},{start:2,name:"weights",type:"tensor"}],attrs:[{tfName:"binary_output",name:"binaryOutput",type:"bool"}]},{tfOpName:"Max",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Mean",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Min",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Sum",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"All",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Any",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"ArgMax",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}]},{tfOpName:"ArgMin",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}]},{tfOpName:"Prod",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Cumprod",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}],attrs:[{tfName:"exclusive",name:"exclusive",type:"bool"},{tfName:"reverse",name:"reverse",type:"bool"}]},{tfOpName:"Cumsum",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}],attrs:[{tfName:"exclusive",name:"exclusive",type:"bool"},{tfName:"reverse",name:"reverse",type:"bool"}]}]};var W={__proto__:null,json:[{tfOpName:"ConcatV2",category:"slice_join",inputs:[{start:0,end:-1,name:"tensors",type:"tensors"},{start:-1,name:"axis",type:"number"}],attrs:[{tfName:"N",name:"n",type:"number",defaultValue:2}]},{tfOpName:"Concat",category:"slice_join",inputs:[{start:1,end:0,name:"tensors",type:"tensors"},{start:0,name:"axis",type:"number"}],attrs:[{tfName:"N",name:"n",type:"number",defaultValue:2}]},{tfOpName:"GatherV2",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"indices",type:"tensor"},{start:2,name:"axis",type:"number",defaultValue:0}],attrs:[{tfName:"batch_dims",name:"batchDims",type:"number",defaultValue:0}]},{tfOpName:"Gather",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"indices",type:"tensor"}],attrs:[{tfName:"validate_indices",name:"validateIndices",type:"bool",notSupported:!0}]},{tfOpName:"Reverse",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"dims",type:"bool[]"}]},{tfOpName:"ReverseV2",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}]},{tfOpName:"Slice",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"begin",type:"number[]"},{start:2,name:"size",type:"number[]"}]},{tfOpName:"StridedSlice",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"begin",type:"number[]"},{start:2,name:"end",type:"number[]"},{start:3,name:"strides",type:"number[]"}],attrs:[{tfName:"begin_mask",name:"beginMask",type:"number",defaultValue:0},{tfName:"end_mask",name:"endMask",type:"number",defaultValue:0},{tfName:"new_axis_mask",name:"newAxisMask",type:"number",defaultValue:0},{tfName:"ellipsis_mask",name:"ellipsisMask",type:"number",defaultValue:0},{tfName:"shrink_axis_mask",name:"shrinkAxisMask",type:"number",defaultValue:0}]},{tfOpName:"Pack",category:"slice_join",inputs:[{start:0,end:0,name:"tensors",type:"tensors"}],attrs:[{tfName:"axis",name:"axis",type:"number",defaultValue:0}]},{tfOpName:"Unpack",category:"slice_join",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"axis",name:"axis",type:"number",defaultValue:0},{tfName:"num",name:"num",type:"number",defaultValue:0,notSupported:!0}]},{tfOpName:"Tile",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"reps",type:"number[]"}]},{tfOpName:"Split",category:"slice_join",inputs:[{start:0,name:"axis",type:"number",defaultValue:0},{start:1,name:"x",type:"tensor"}],attrs:[{tfName:"num_split",name:"numOrSizeSplits",type:"number",defaultValue:1}]},{tfOpName:"SplitV",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"numOrSizeSplits",type:"number[]"},{start:2,name:"axis",type:"number",defaultValue:0}]},{tfOpName:"ScatterNd",category:"slice_join",inputs:[{start:0,name:"indices",type:"tensor"},{start:1,name:"values",type:"tensor"},{start:2,name:"shape",type:"number[]"}]},{tfOpName:"GatherNd",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"indices",type:"tensor"}]},{tfOpName:"SparseToDense",category:"slice_join",inputs:[{start:0,name:"sparseIndices",type:"tensor"},{start:1,name:"outputShape",type:"number[]"},{start:2,name:"sparseValues",type:"tensor"},{start:3,name:"defaultValue",type:"tensor"}],attrs:[{tfName:"validate_indices",name:"validateIndices",type:"bool",defaultValue:!1,notSupported:!0}]},{tfOpName:"TensorScatterUpdate",category:"slice_join",inputs:[{start:0,name:"tensor",type:"tensor"},{start:1,name:"indices",type:"tensor"},{start:2,name:"values",type:"tensor"}]}]};var j={__proto__:null,json:[{tfOpName:"SparseFillEmptyRows",category:"sparse",inputs:[{start:0,name:"indices",type:"tensor"},{start:1,name:"values",type:"tensor"},{start:2,name:"denseShape",type:"tensor"},{start:3,name:"defaultValue",type:"tensor"}]},{tfOpName:"SparseReshape",category:"sparse",inputs:[{start:0,name:"inputIndices",type:"tensor"},{start:1,name:"inputShape",type:"tensor"},{start:2,name:"newShape",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"SparseSegmentMean",category:"sparse",inputs:[{start:0,name:"data",type:"tensor"},{start:1,name:"indices",type:"tensor"},{start:2,name:"segmentIds",type:"tensor"}]},{tfOpName:"SparseSegmentSum",category:"sparse",inputs:[{start:0,name:"data",type:"tensor"},{start:1,name:"indices",type:"tensor"},{start:2,name:"segmentIds",type:"tensor"}]}]};var H={__proto__:null,json:[{tfOpName:"FFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"IFFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"RFFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"fft_length",type:"number",notSupported:!0}]},{tfOpName:"IRFFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"fft_length",type:"number",notSupported:!0}]}]};var G={__proto__:null,json:[{tfOpName:"StaticRegexReplace",category:"string",inputs:[{start:0,name:"input",type:"tensor"}],attrs:[{tfName:"pattern",name:"pattern",type:"string"},{tfName:"rewrite",name:"rewrite",type:"string"},{tfName:"replace_global",name:"replaceGlobal",type:"bool"}]},{tfOpName:"StringNGrams",category:"string",inputs:[{start:0,name:"data",type:"tensor"},{start:1,name:"dataSplits",type:"tensor"}],attrs:[{tfName:"separator",name:"separator",type:"string"},{tfName:"ngram_widths",name:"nGramWidths",type:"number[]"},{tfName:"left_pad",name:"leftPad",type:"string"},{tfName:"right_pad",name:"rightPad",type:"string"},{tfName:"pad_width",name:"padWidth",type:"number"},{tfName:"preserve_short_sequences",name:"preserveShortSequences",type:"bool"}],outputs:["ngrams","ngrams_splits"]},{tfOpName:"StringSplit",category:"string",inputs:[{start:0,name:"input",type:"tensor"},{start:1,name:"delimiter",type:"tensor"}],attrs:[{tfName:"skip_empty",name:"skipEmpty",type:"bool"}],outputs:["indices","values","shape"]},{tfOpName:"StringToHashBucketFast",category:"string",inputs:[{start:0,name:"input",type:"tensor"}],attrs:[{tfName:"num_buckets",name:"numBuckets",type:"number"}]}]};var Z={__proto__:null,json:[{tfOpName:"Cast",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"SrcT",name:"sdtype",type:"dtype",notSupported:!0},{tfName:"DstT",name:"dtype",type:"dtype"}]},{tfOpName:"ExpandDims",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}]},{tfOpName:"MirrorPad",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"padding",type:"number[]"}],attrs:[{tfName:"mode",name:"mode",type:"string"}]},{tfOpName:"Pad",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"padding",type:"number[]"}],attrs:[{tfName:"constant_value",name:"constantValue",type:"number",defaultValue:0}]},{tfOpName:"PadV2",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"padding",type:"number[]"},{start:2,name:"constantValue",type:"number",defaultValue:0}]},{tfOpName:"Reshape",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"shape",type:"number[]"}]},{tfOpName:"Squeeze",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"axis",tfDeprecatedName:"squeeze_dims",name:"axis",type:"number[]"}]},{tfOpName:"SpaceToBatchND",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"blockShape",type:"number[]"},{start:2,name:"paddings",type:"number[]"}]},{tfOpName:"BatchToSpaceND",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"blockShape",type:"number[]"},{start:2,name:"crops",type:"number[]"}]},{tfOpName:"DepthToSpace",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"block_size",name:"blockSize",type:"number"},{tfName:"data_format",name:"dataFormat",type:"string"}]},{tfOpName:"BroadcastTo",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"shape",type:"number[]"}],attrs:[]},{tfOpName:"BroadcastArgs",category:"transformation",inputs:[{start:0,name:"s0",type:"tensor"},{start:1,name:"s1",type:"tensor"}],attrs:[]}]};class Q{static get Instance(){return this._instance||(this._instance=new this)}constructor(){const e=[].concat(...[A,O,M,C,F,R,z,V,L,B,P,K,q,U,W,j,H,G,Z].map((e=>e.json)));this.opMappers=e.reduce(((e,t)=>(e[t.tfOpName]=t,e)),{})}transformGraph(e,t={}){const n=e.node,r=[],s=[],a=[],o=n.reduce(((e,t)=>(e[t.name]=this.mapNode(t),t.op.startsWith("Placeholder")?r.push(e[t.name]):"Const"===t.op?s.push(e[t.name]):null!=t.input&&0!==t.input.length||a.push(e[t.name]),e)),{});let i=[];const u=[];let p={},l={};null!=t&&(p=this.mapSignatureEntries(t.inputs),l=this.mapSignatureEntries(t.outputs));const c=Object.keys(o);c.forEach((e=>{const t=o[e];t.inputNames.forEach(((e,n)=>{const[r,,s]=S(e),a=o[r];if(null!=a.outputs){const e=a.outputs.indexOf(s);if(-1!==e){const s=`${r}:${e}`;t.inputNames[n]=s}}t.inputs.push(a),a.children.push(t)}))})),0===Object.keys(l).length?c.forEach((e=>{const t=o[e];0===t.children.length&&u.push(t)})):Object.keys(l).forEach((e=>{const[t]=S(e),n=o[t];null!=n&&(n.signatureKey=l[e],u.push(n))})),Object.keys(p).length>0?Object.keys(p).forEach((e=>{const[t]=S(e),n=o[t];n&&(n.signatureKey=p[e],i.push(n))})):i=r;let h={};null!=e.library&&null!=e.library.function&&(h=e.library.function.reduce(((e,t)=>(e[t.signature.name]=this.mapFunction(t),e)),{}));const d={nodes:o,inputs:i,outputs:u,weights:s,placeholders:r,signature:t,functions:h};return a.length>0&&(d.initNodes=a),d}mapSignatureEntries(e){return Object.keys(e||{}).reduce(((t,n)=>(t[e[n].name]=n,t)),{})}mapNode(e){const t=w(e.op)||this.opMappers[e.op]||{};null==e.attr&&(e.attr={});const n={name:e.name,op:e.op,category:t.category,inputNames:(e.input||[]).map((e=>e.startsWith("^")?e.slice(1):e)),inputs:[],children:[],inputParams:{},attrParams:{},rawAttrs:e.attr,outputs:t.outputs};return null!=t.inputs&&(n.inputParams=t.inputs.reduce(((e,t)=>(e[t.name]={type:t.type,inputIndexStart:t.start,inputIndexEnd:t.end},e)),{})),null!=t.attrs&&(n.attrParams=t.attrs.reduce(((t,n)=>{const r=n.type;let s;switch(n.type){case"string":s=X(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=X(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"string[]":s=ue(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=ue(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"number":s=ee(e.attr,n.tfName,n.defaultValue||0),void 0===s&&n.tfDeprecatedName&&(s=ee(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"number[]":s=ie(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=ie(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"bool":s=J(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=J(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"bool[]":s=le(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=le(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"shape":s=oe(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=oe(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"shape[]":s=pe(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=pe(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"dtype":s=re(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=re(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"dtype[]":s=se(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=se(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"func":s=ne(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=ne(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"tensor":case"tensors":break;default:throw new Error(`Unsupported param type: ${n.type} for op: ${e.op}`)}return t[n.name]={value:s,type:r},t}),{})),n}mapFunction(e){const t=e.nodeDef,n=[];let r={};null!=t&&(r=t.reduce(((e,t)=>(e[t.name]=this.mapNode(t),"Const"===t.op&&n.push(e[t.name]),e)),{}));const s=[],a=[];e.signature.inputArg.forEach((e=>{const[t]=S(e.name),n={name:t,op:"Placeholder",inputs:[],inputNames:[],category:"graph",inputParams:{},attrParams:{dtype:{value:te(e.type),type:"dtype"}},children:[]};n.signatureKey=e.name,s.push(n),r[t]=n}));Object.keys(r).forEach((e=>{const t=r[e];t.inputNames.forEach(((e,n)=>{const[s,,a]=S(e),o=r[s];if(null!=o.outputs){const e=o.outputs.indexOf(a);if(-1!==e){const r=`${s}:${e}`;t.inputNames[n]=r}}t.inputs.push(o),o.children.push(t)}))}));const o=e.ret;e.signature.outputArg.forEach((e=>{const[t,n]=S(o[e.name]),s=r[t];null!=s&&(s.defaultOutput=n,a.push(s))}));const i=this.mapArgsToSignature(e);return{nodes:r,inputs:s,outputs:a,weights:n,placeholders:[],signature:i}}mapArgsToSignature(e){return{methodName:e.signature.name,inputs:e.signature.inputArg.reduce(((e,t)=>(e[t.name]=this.mapArgToTensorInfo(t),e)),{}),outputs:e.signature.outputArg.reduce(((t,n)=>(t[n.name]=this.mapArgToTensorInfo(n,e.ret),t)),{})}}mapArgToTensorInfo(e,t){let n=e.name;return null!=t&&(n=t[n]),{name:n,dtype:e.type}}}function Y(e,n){const r=Array.isArray(e)?String.fromCharCode.apply(null,e):function(e){const n=t().global;if("undefined"!=typeof n.atob)return n.atob(e);if("undefined"!=typeof Buffer)return new Buffer(e,"base64").toString();throw new Error("Unable to decode base64 in this environment. Missing built-in atob() or Buffer()")}(e);return n?r:r.toLowerCase()}function X(e,t,n,r=!1){const s=e[t];return null!=s?Y(s.s,r):n}function J(e,t,n){const r=e[t];return r?r.b:n}function ee(e,t,n){const r=e[t]||{},s=null!=r.i?r.i:null!=r.f?r.f:n;return"number"==typeof s?s:parseInt(s,10)}function te(e){switch("string"==typeof e&&(e=g[e]),e){case g.DT_FLOAT:case g.DT_HALF:return"float32";case g.DT_INT32:case g.DT_INT64:case g.DT_INT8:case g.DT_UINT8:return"int32";case g.DT_BOOL:return"bool";case g.DT_DOUBLE:return"float32";case g.DT_STRING:return"string";default:return null}}function ne(e,t,n){const r=e[t];return r&&r.func?r.func.name:n}function re(e,t,n){const r=e[t];return r&&r.type?te(r.type):n}function se(e,t,n){const r=e[t];return r&&r.list&&r.list.type?r.list.type.map((e=>te(e))):n}function ae(e){if(!e.unknownRank)return null!=e.dim?e.dim.map((e=>"number"==typeof e.size?e.size:parseInt(e.size,10))):[]}function oe(e,t,n){const r=e[t];return r&&r.shape?ae(r.shape):n}function ie(e,t,n){const r=e[t];return r?((r.list.f&&r.list.f.length?r.list.f:r.list.i)||[]).map((e=>"number"==typeof e?e:parseInt(e,10))):n}function ue(e,t,n,r=!1){const s=e[t];return s&&s.list&&s.list.s?s.list.s.map((e=>Y(e,r))):n}function pe(e,t,n){const r=e[t];return r&&r.list&&r.list.shape?r.list.shape.map((e=>ae(e))):n}function le(e,t,n){const r=e[t];return r&&r.list&&r.list.b?r.list.b:n}class ce{constructor(e,t,n){this.node=e,this.tensorMap=t,this.context=n,this.inputs=[],this.attrs={},this.inputs=e.inputNames.map((e=>this.getInput(e))),null!=e.rawAttrs&&(this.attrs=Object.keys(e.rawAttrs).reduce(((e,t)=>(e[t]=this.getAttr(t),e)),{}))}getInput(e){return v(e,this.tensorMap,this.context)}getAttr(e,t){const n=this.node.rawAttrs[e];if(null!=n.tensor)return v(e,this.tensorMap,this.context);if(null!=n.i||null!=n.f)return ee(this.node.rawAttrs,e,t);if(null!=n.s)return X(this.node.rawAttrs,e,t);if(null!=n.b)return J(this.node.rawAttrs,e,t);if(null!=n.shape)return oe(this.node.rawAttrs,e,t);if(null!=n.type)return re(this.node.rawAttrs,e,t);if(null!=n.list){if(null!=n.list.i||null!=n.list.f)return ie(this.node.rawAttrs,e,t);if(null!=n.list.s)return ue(this.node.rawAttrs,e,t);if(null!=n.list.shape)return pe(this.node.rawAttrs,e,t);if(null!=n.list.b)return le(this.node.rawAttrs,e,t);if(null!=n.list.type)return se(this.node.rawAttrs,e,t)}return t}}function he(e){throw new Error(`'${e}' not yet implemented or not found in the registry. This kernel may not be supported by the tfjs backend you have chosen`)}function de(e,t){if(!e)throw new Error("string"==typeof t?t:t())}function me(e,t,n=""){de(ge(e,t),(()=>n+` Shapes ${e} and ${t} must match`))}function fe(e){de(null!=e,(()=>"The input to the tensor constructor must be a non-null value."))}function ye(e){if(0===e.length)return 1;let t=e[0];for(let n=1;n<e.length;n++)t*=e[n];return t}function ge(e,t){if(e===t)return!0;if(null==e||null==t)return!1;if(e.length!==t.length)return!1;for(let n=0;n<e.length;n++)if(e[n]!==t[n])return!1;return!0}function be(e){return e%1==0}function Ne(e,t){return t<=e.length?e:e+" ".repeat(t-e.length)}function xe(e,t){const n=t.length;return de((e=null==e?t.map(((e,t)=>t)):[].concat(e)).every((e=>e>=-n&&e<n)),(()=>`All values in axis param must be in range [-${n}, ${n}) but got axis ${e}`)),de(e.every((e=>be(e))),(()=>`All values in axis param must be integers but got axis ${e}`)),e.map((e=>e<0?n+e:e))}function we(e,t){let n=null;if(null==e||"float32"===e)n=new Float32Array(t);else if("int32"===e)n=new Int32Array(t);else if("bool"===e)n=new Uint8Array(t);else{if("string"!==e)throw new Error(`Unknown data type ${e}`);n=new Array(t)}return n}function ke(e){if("float32"===e||"int32"===e)return 4;if("complex64"===e)return 8;if("bool"===e)return 1;throw new Error(`Unknown dtype ${e}`)}function Te(e){return"string"==typeof e||e instanceof String}function ve(e){return Array.isArray(e)?ve(e[0]):e instanceof Float32Array?"float32":e instanceof Int32Array||e instanceof Uint8Array||e instanceof Uint8ClampedArray?"int32":"number"==typeof e?"float32":Te(e)?"string":function(e){return"boolean"==typeof e}(e)?"bool":"float32"}function _e(e){return!!(e&&e.constructor&&e.call&&e.apply)}function Se(e){const t=e.length;if(t<2)return[];const n=new Array(t-1);n[t-2]=e[t-1];for(let r=t-3;r>=0;--r)n[r]=n[r+1]*e[r+1];return n}function Ee(e,t,n,r=!1){const s=new Array;if(1===t.length){const a=t[0]*(r?2:1);for(let t=0;t<a;t++)s[t]=n[e+t]}else{const a=t[0],o=t.slice(1),i=o.reduce(((e,t)=>e*t))*(r?2:1);for(let t=0;t<a;t++)s[t]=Ee(e+t*i,o,n,r)}return s}function Ie(e,t,n=!1){if(0===e.length)return t[0];const r=e.reduce(((e,t)=>e*t))*(n?2:1);if(0===r)return[];if(r!==t.length)throw new Error(`[${e}] does not match the input size ${t.length}${n?" for a complex tensor":""}.`);return Ee(0,e,t,n)}function $e(e,t){const n=De(e,t);for(let e=0;e<n.length;e++)n[e]=1;return n}function De(e,t){if(null==t||"float32"===t||"complex64"===t)return new Float32Array(e);if("int32"===t)return new Int32Array(e);if("bool"===t)return new Uint8Array(e);throw new Error(`Unknown data type ${t}`)}function Ae(e){e.forEach((t=>{de(Number.isInteger(t)&&t>=0,(()=>`Tensor must have a shape comprised of positive integers but got shape [${e}].`))}))}function Oe(e){return e&&e.then&&"function"==typeof e.then}class Me{constructor(e){this.global=e,this.flags={},this.flagRegistry={},this.urlFlags={},this.getQueryParams=Ce,this.populateURLFlags()}setPlatform(e,t){null!=this.platform&&(Fe().getBool("IS_TEST")||Fe().getBool("PROD")||console.warn(`Platform ${this.platformName} has already been set. Overwriting the platform with ${e}.`)),this.platformName=e,this.platform=t}registerFlag(e,t,n){if(this.flagRegistry[e]={evaluationFn:t,setHook:n},null!=this.urlFlags[e]){const t=this.urlFlags[e];Fe().getBool("IS_TEST")||Fe().getBool("PROD")||console.warn(`Setting feature override from URL ${e}: ${t}.`),this.set(e,t)}}async getAsync(e){return e in this.flags||(this.flags[e]=await this.evaluateFlag(e)),this.flags[e]}get(e){if(e in this.flags)return this.flags[e];const t=this.evaluateFlag(e);if(Oe(t))throw new Error(`Flag ${e} cannot be synchronously evaluated. Please use getAsync() instead.`);return this.flags[e]=t,this.flags[e]}getNumber(e){return this.get(e)}getBool(e){return this.get(e)}getString(e){return this.get(e)}getFlags(){return this.flags}get features(){return this.flags}set(e,t){if(null==this.flagRegistry[e])throw new Error(`Cannot set flag ${e} as it has not been registered.`);this.flags[e]=t,null!=this.flagRegistry[e].setHook&&this.flagRegistry[e].setHook(t)}evaluateFlag(e){if(null==this.flagRegistry[e])throw new Error(`Cannot evaluate flag '${e}': no evaluation function found.`);return this.flagRegistry[e].evaluationFn()}setFlags(e){this.flags=Object.assign({},e)}reset(){this.flags={},this.urlFlags={},this.populateURLFlags()}populateURLFlags(){if("undefined"==typeof this.global||"undefined"==typeof this.global.location||"undefined"==typeof this.global.location.search)return;const e=this.getQueryParams(this.global.location.search);if("tfjsflags"in e){e.tfjsflags.split(",").forEach((e=>{const[t,n]=e.split(":");this.urlFlags[t]=function(e,t){const n=t.toLowerCase();return"true"===n||"false"===n?"true"===n:""+ +n===n?+n:t}(0,n)}))}}}function Ce(e){const t={};return e.replace(/[?&]([^=?&]+)(?:=([^&]*))?/g,((e,...n)=>(function(e,t,n){e[decodeURIComponent(t)]=decodeURIComponent(n||"")}(t,n[0],n[1]),n.join("=")))),t}function Fe(){return ze}let Re,ze=null;function Ve(){if(null==Re){let e;if("undefined"!=typeof window)e=window;else if("undefined"!=typeof global)e=global;else if("undefined"!=typeof process)e=process;else{if("undefined"==typeof self)throw new Error("Could not find a global object");e=self}Re=e}return Re}function Le(e,t){const n=function(){const e=Ve();return null==e._tfGlobals&&(e._tfGlobals=new Map),e._tfGlobals}();if(n.has(e))return n.get(e);{const r=t();return n.set(e,r),n.get(e)}}function Be(...e){Fe().getBool("IS_TEST")||Fe().getBool("PROD")||console.warn(...e)}const Pe=Le("kernelRegistry",(()=>new Map)),Ke=Le("gradRegistry",(()=>new Map));function qe(e,t){const n=function(e,t){return`${t}_${e}`}(e,t);return Pe.get(n)}function Ue(e){return Ke.get(e)}function We(e){const t=Pe.entries(),n=[];for(;;){const{done:r,value:s}=t.next();if(r)break;const[a,o]=s,[i]=a.split("_");i===e&&n.push(o)}return n}var je=Ge,He=null;try{He=new WebAssembly.Instance(new WebAssembly.Module(new Uint8Array([0,97,115,109,1,0,0,0,1,13,2,96,0,1,127,96,4,127,127,127,127,1,127,3,7,6,0,1,1,1,1,1,6,6,1,127,1,65,0,11,7,50,6,3,109,117,108,0,1,5,100,105,118,95,115,0,2,5,100,105,118,95,117,0,3,5,114,101,109,95,115,0,4,5,114,101,109,95,117,0,5,8,103,101,116,95,104,105,103,104,0,0,10,191,1,6,4,0,35,0,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,126,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,127,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,128,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,129,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,130,34,4,66,32,135,167,36,0,32,4,167,11])),{}).exports}catch(e){}function Ge(e,t,n){this.low=0|e,this.high=0|t,this.unsigned=!!n}function Ze(e){return!0===(e&&e.__isLong__)}Ge.prototype.__isLong__,Object.defineProperty(Ge.prototype,"__isLong__",{value:!0}),Ge.isLong=Ze;var Qe={},Ye={};function Xe(e,t){var n,r,s;return t?(s=0<=(e>>>=0)&&e<256)&&(r=Ye[e])?r:(n=et(e,(0|e)<0?-1:0,!0),s&&(Ye[e]=n),n):(s=-128<=(e|=0)&&e<128)&&(r=Qe[e])?r:(n=et(e,e<0?-1:0,!1),s&&(Qe[e]=n),n)}function Je(e,t){if(isNaN(e))return t?pt:ut;if(t){if(e<0)return pt;if(e>=at)return mt}else{if(e<=-ot)return ft;if(e+1>=ot)return dt}return e<0?Je(-e,t).neg():et(e%st|0,e/st|0,t)}function et(e,t,n){return new Ge(e,t,n)}Ge.fromInt=Xe,Ge.fromNumber=Je,Ge.fromBits=et;var tt=Math.pow;function nt(e,t,n){if(0===e.length)throw Error("empty string");if("NaN"===e||"Infinity"===e||"+Infinity"===e||"-Infinity"===e)return ut;if("number"==typeof t?(n=t,t=!1):t=!!t,(n=n||10)<2||36<n)throw RangeError("radix");var r;if((r=e.indexOf("-"))>0)throw Error("interior hyphen");if(0===r)return nt(e.substring(1),t,n).neg();for(var s=Je(tt(n,8)),a=ut,o=0;o<e.length;o+=8){var i=Math.min(8,e.length-o),u=parseInt(e.substring(o,o+i),n);if(i<8){var p=Je(tt(n,i));a=a.mul(p).add(Je(u))}else a=(a=a.mul(s)).add(Je(u))}return a.unsigned=t,a}function rt(e,t){return"number"==typeof e?Je(e,t):"string"==typeof e?nt(e,t):et(e.low,e.high,"boolean"==typeof t?t:e.unsigned)}Ge.fromString=nt,Ge.fromValue=rt;var st=4294967296,at=st*st,ot=at/2,it=Xe(1<<24),ut=Xe(0);Ge.ZERO=ut;var pt=Xe(0,!0);Ge.UZERO=pt;var lt=Xe(1);Ge.ONE=lt;var ct=Xe(1,!0);Ge.UONE=ct;var ht=Xe(-1);Ge.NEG_ONE=ht;var dt=et(-1,2147483647,!1);Ge.MAX_VALUE=dt;var mt=et(-1,-1,!0);Ge.MAX_UNSIGNED_VALUE=mt;var ft=et(0,-2147483648,!1);Ge.MIN_VALUE=ft;var yt=Ge.prototype;yt.toInt=function(){return this.unsigned?this.low>>>0:this.low},yt.toNumber=function(){return this.unsigned?(this.high>>>0)*st+(this.low>>>0):this.high*st+(this.low>>>0)},yt.toString=function(e){if((e=e||10)<2||36<e)throw RangeError("radix");if(this.isZero())return"0";if(this.isNegative()){if(this.eq(ft)){var t=Je(e),n=this.div(t),r=n.mul(t).sub(this);return n.toString(e)+r.toInt().toString(e)}return"-"+this.neg().toString(e)}for(var s=Je(tt(e,6),this.unsigned),a=this,o="";;){var i=a.div(s),u=(a.sub(i.mul(s)).toInt()>>>0).toString(e);if((a=i).isZero())return u+o;for(;u.length<6;)u="0"+u;o=""+u+o}},yt.getHighBits=function(){return this.high},yt.getHighBitsUnsigned=function(){return this.high>>>0},yt.getLowBits=function(){return this.low},yt.getLowBitsUnsigned=function(){return this.low>>>0},yt.getNumBitsAbs=function(){if(this.isNegative())return this.eq(ft)?64:this.neg().getNumBitsAbs();for(var e=0!=this.high?this.high:this.low,t=31;t>0&&0==(e&1<<t);t--);return 0!=this.high?t+33:t+1},yt.isZero=function(){return 0===this.high&&0===this.low},yt.eqz=yt.isZero,yt.isNegative=function(){return!this.unsigned&&this.high<0},yt.isPositive=function(){return this.unsigned||this.high>=0},yt.isOdd=function(){return 1==(1&this.low)},yt.isEven=function(){return 0==(1&this.low)},yt.equals=function(e){return Ze(e)||(e=rt(e)),(this.unsigned===e.unsigned||this.high>>>31!=1||e.high>>>31!=1)&&(this.high===e.high&&this.low===e.low)},yt.eq=yt.equals,yt.notEquals=function(e){return!this.eq(e)},yt.neq=yt.notEquals,yt.ne=yt.notEquals,yt.lessThan=function(e){return this.comp(e)<0},yt.lt=yt.lessThan,yt.lessThanOrEqual=function(e){return this.comp(e)<=0},yt.lte=yt.lessThanOrEqual,yt.le=yt.lessThanOrEqual,yt.greaterThan=function(e){return this.comp(e)>0},yt.gt=yt.greaterThan,yt.greaterThanOrEqual=function(e){return this.comp(e)>=0},yt.gte=yt.greaterThanOrEqual,yt.ge=yt.greaterThanOrEqual,yt.compare=function(e){if(Ze(e)||(e=rt(e)),this.eq(e))return 0;var t=this.isNegative(),n=e.isNegative();return t&&!n?-1:!t&&n?1:this.unsigned?e.high>>>0>this.high>>>0||e.high===this.high&&e.low>>>0>this.low>>>0?-1:1:this.sub(e).isNegative()?-1:1},yt.comp=yt.compare,yt.negate=function(){return!this.unsigned&&this.eq(ft)?ft:this.not().add(lt)},yt.neg=yt.negate,yt.add=function(e){Ze(e)||(e=rt(e));var t=this.high>>>16,n=65535&this.high,r=this.low>>>16,s=65535&this.low,a=e.high>>>16,o=65535&e.high,i=e.low>>>16,u=0,p=0,l=0,c=0;return l+=(c+=s+(65535&e.low))>>>16,p+=(l+=r+i)>>>16,u+=(p+=n+o)>>>16,u+=t+a,et((l&=65535)<<16|(c&=65535),(u&=65535)<<16|(p&=65535),this.unsigned)},yt.subtract=function(e){return Ze(e)||(e=rt(e)),this.add(e.neg())},yt.sub=yt.subtract,yt.multiply=function(e){if(this.isZero())return ut;if(Ze(e)||(e=rt(e)),He)return et(He.mul(this.low,this.high,e.low,e.high),He.get_high(),this.unsigned);if(e.isZero())return ut;if(this.eq(ft))return e.isOdd()?ft:ut;if(e.eq(ft))return this.isOdd()?ft:ut;if(this.isNegative())return e.isNegative()?this.neg().mul(e.neg()):this.neg().mul(e).neg();if(e.isNegative())return this.mul(e.neg()).neg();if(this.lt(it)&&e.lt(it))return Je(this.toNumber()*e.toNumber(),this.unsigned);var t=this.high>>>16,n=65535&this.high,r=this.low>>>16,s=65535&this.low,a=e.high>>>16,o=65535&e.high,i=e.low>>>16,u=65535&e.low,p=0,l=0,c=0,h=0;return c+=(h+=s*u)>>>16,l+=(c+=r*u)>>>16,c&=65535,l+=(c+=s*i)>>>16,p+=(l+=n*u)>>>16,l&=65535,p+=(l+=r*i)>>>16,l&=65535,p+=(l+=s*o)>>>16,p+=t*u+n*i+r*o+s*a,et((c&=65535)<<16|(h&=65535),(p&=65535)<<16|(l&=65535),this.unsigned)},yt.mul=yt.multiply,yt.divide=function(e){if(Ze(e)||(e=rt(e)),e.isZero())throw Error("division by zero");var t,n,r;if(He)return this.unsigned||-2147483648!==this.high||-1!==e.low||-1!==e.high?et((this.unsigned?He.div_u:He.div_s)(this.low,this.high,e.low,e.high),He.get_high(),this.unsigned):this;if(this.isZero())return this.unsigned?pt:ut;if(this.unsigned){if(e.unsigned||(e=e.toUnsigned()),e.gt(this))return pt;if(e.gt(this.shru(1)))return ct;r=pt}else{if(this.eq(ft))return e.eq(lt)||e.eq(ht)?ft:e.eq(ft)?lt:(t=this.shr(1).div(e).shl(1)).eq(ut)?e.isNegative()?lt:ht:(n=this.sub(e.mul(t)),r=t.add(n.div(e)));if(e.eq(ft))return this.unsigned?pt:ut;if(this.isNegative())return e.isNegative()?this.neg().div(e.neg()):this.neg().div(e).neg();if(e.isNegative())return this.div(e.neg()).neg();r=ut}for(n=this;n.gte(e);){t=Math.max(1,Math.floor(n.toNumber()/e.toNumber()));for(var s=Math.ceil(Math.log(t)/Math.LN2),a=s<=48?1:tt(2,s-48),o=Je(t),i=o.mul(e);i.isNegative()||i.gt(n);)i=(o=Je(t-=a,this.unsigned)).mul(e);o.isZero()&&(o=lt),r=r.add(o),n=n.sub(i)}return r},yt.div=yt.divide,yt.modulo=function(e){return Ze(e)||(e=rt(e)),He?et((this.unsigned?He.rem_u:He.rem_s)(this.low,this.high,e.low,e.high),He.get_high(),this.unsigned):this.sub(this.div(e).mul(e))},yt.mod=yt.modulo,yt.rem=yt.modulo,yt.not=function(){return et(~this.low,~this.high,this.unsigned)},yt.and=function(e){return Ze(e)||(e=rt(e)),et(this.low&e.low,this.high&e.high,this.unsigned)},yt.or=function(e){return Ze(e)||(e=rt(e)),et(this.low|e.low,this.high|e.high,this.unsigned)},yt.xor=function(e){return Ze(e)||(e=rt(e)),et(this.low^e.low,this.high^e.high,this.unsigned)},yt.shiftLeft=function(e){return Ze(e)&&(e=e.toInt()),0==(e&=63)?this:e<32?et(this.low<<e,this.high<<e|this.low>>>32-e,this.unsigned):et(0,this.low<<e-32,this.unsigned)},yt.shl=yt.shiftLeft,yt.shiftRight=function(e){return Ze(e)&&(e=e.toInt()),0==(e&=63)?this:e<32?et(this.low>>>e|this.high<<32-e,this.high>>e,this.unsigned):et(this.high>>e-32,this.high>=0?0:-1,this.unsigned)},yt.shr=yt.shiftRight,yt.shiftRightUnsigned=function(e){if(Ze(e)&&(e=e.toInt()),0===(e&=63))return this;var t=this.high;return e<32?et(this.low>>>e|t<<32-e,t>>>e,this.unsigned):et(32===e?t:t>>>e-32,0,this.unsigned)},yt.shru=yt.shiftRightUnsigned,yt.shr_u=yt.shiftRightUnsigned,yt.toSigned=function(){return this.unsigned?et(this.low,this.high,!1):this},yt.toUnsigned=function(){return this.unsigned?this:et(this.low,this.high,!0)},yt.toBytes=function(e){return e?this.toBytesLE():this.toBytesBE()},yt.toBytesLE=function(){var e=this.high,t=this.low;return[255&t,t>>>8&255,t>>>16&255,t>>>24,255&e,e>>>8&255,e>>>16&255,e>>>24]},yt.toBytesBE=function(){var e=this.high,t=this.low;return[e>>>24,e>>>16&255,e>>>8&255,255&e,t>>>24,t>>>16&255,t>>>8&255,255&t]},Ge.fromBytes=function(e,t,n){return n?Ge.fromBytesLE(e,t):Ge.fromBytesBE(e,t)},Ge.fromBytesLE=function(e,t){return new Ge(e[0]|e[1]<<8|e[2]<<16|e[3]<<24,e[4]|e[5]<<8|e[6]<<16|e[7]<<24,t)},Ge.fromBytesBE=function(e,t){return new Ge(e[4]<<24|e[5]<<16|e[6]<<8|e[7],e[0]<<24|e[1]<<16|e[2]<<8|e[3],t)};const gt=je||y({__proto__:null,default:je},[je]);function bt(e){return gt.fromString(e,!0,16)}function Nt(e,t){if("string"===t)throw new Error("Cannot convert a string[] to a TypedArray");if(Array.isArray(e)&&(e=Tt(e)),Fe().getBool("DEBUG")&&function(e,t){for(let n=0;n<e.length;n++){const r=e[n];if(isNaN(r)||!isFinite(r))throw Error(`A tensor of type ${t} being uploaded contains ${r}.`)}}(e,t),function(e,t){return e instanceof Float32Array&&"float32"===t||e instanceof Int32Array&&"int32"===t||e instanceof Uint8Array&&"bool"===t}(e,t))return e;if(null==t||"float32"===t||"complex64"===t)return new Float32Array(e);if("int32"===t)return new Int32Array(e);if("bool"===t){const t=new Uint8Array(e.length);for(let n=0;n<t.length;++n)0!==Math.round(e[n])&&(t[n]=1);return t}throw new Error(`Unknown data type ${t}`)}function xt(){return Fe().platform.now()}function wt(e,t="utf-8"){return t=t||"utf-8",Fe().platform.decode(e,t)}function kt(e){return null!=Fe().platform.isTypedArray?Fe().platform.isTypedArray(e):function(e){return e instanceof Float32Array||e instanceof Int32Array||e instanceof Uint8Array||e instanceof Uint8ClampedArray}(e)}function Tt(e,t=[],n=!1){if(null==t&&(t=[]),"boolean"==typeof e||"number"==typeof e||"string"==typeof e||Oe(e)||null==e||kt(e)&&n)t.push(e);else if(Array.isArray(e)||kt(e))for(let r=0;r<e.length;++r)Tt(e[r],t,n);else{let r=-1;for(const t of Object.keys(e))/^([1-9]+[0-9]*|0)$/.test(t)&&(r=Math.max(r,Number(t)));for(let s=0;s<=r;s++)Tt(e[s],t,n)}return t}bt("c3a5c85c97cb3127"),bt("b492b66fbe98f273"),bt("9ae16a3b2f90404f");class vt{constructor(e,t){this.backendTimer=e,this.logger=t,null==t&&(this.logger=new St)}profileKernel(e,t,n){let r;const s=()=>{r=n()};let a;const o=xt();if(this.backendTimer.timerAvailable())a=this.backendTimer.time(s);else{s();for(const e of r)e.dataSync();a=Promise.resolve({kernelMs:xt()-o})}if(Fe().getBool("CHECK_COMPUTATION_FOR_ERRORS"))for(let t=0;t<r.length;t++){const n=r[t];n.data().then((t=>{_t(t,n.dtype,e)}))}return{kernelName:e,outputs:r,inputs:t,timeMs:a.then((e=>e.kernelMs)),extraInfo:a.then((e=>null!=e.getExtraProfileInfo?e.getExtraProfileInfo():""))}}logKernelProfile(e){const{kernelName:t,outputs:n,timeMs:r,inputs:s,extraInfo:a}=e;n.forEach((e=>{Promise.all([e.data(),r,a]).then((n=>{this.logger.logKernelProfile(t,e,n[0],n[1],s,n[2])}))}))}}function _t(e,t,n){if("float32"!==t)return!1;for(let t=0;t<e.length;t++){const r=e[t];if(isNaN(r)||!isFinite(r))return console.warn(`Found ${r} in the result of '${n}'`),!0}return!1}class St{logKernelProfile(e,t,n,r,s,a){const o="number"==typeof r?Ne(`${r}ms`,9):r.error,i=Ne(e,25),u=t.rank,p=t.size,l=Ne(t.shape.toString(),14);let c="";for(const e in s){const n=s[e];if(null!=n){const r=n.shape||t.shape,s=r.length;c+=`${e}: ${s}D ${s>0?r:""} `}}console.log(`%c${i}\t%c${o}\t%c${u}D ${l}\t%c${p}\t%c${c}\t%c${a}`,"font-weight:bold","color:red","color:blue","color: orange","color: green","color: steelblue")}}function Et(e,t,n,r){const s=Se(t),a=function(e,t,n,r){const s=ye(t),a=r[r.length-1],o=new Array(a).fill(0),i=t.length,u="complex64"===n?At(e):e;if(i>1)for(let e=0;e<s/a;e++){const t=e*a;for(let e=0;e<a;e++)o[e]=Math.max(o[e],It(u[t+e],0,n).length)}return o}(e,t,n,s),o=t.length,i=Dt(e,t,n,s,a),u=["Tensor"];return r&&(u.push(`  dtype: ${n}`),u.push(`  rank: ${o}`),u.push(`  shape: [${t}]`),u.push("  values:")),u.push(i.map((e=>"    "+e)).join("\n")),u.join("\n")}function It(e,t,n){let r;return r=Array.isArray(e)?`${parseFloat(e[0].toFixed(7))} + ${parseFloat(e[1].toFixed(7))}j`:Te(e)?`'${e}'`:"bool"===n?$t(e):parseFloat(e.toFixed(7)).toString(),Ne(r,t)}function $t(e){return 0===e?"false":"true"}function Dt(e,t,n,r,s,a=!0){const o="complex64"===n?2:1,i=t[0],u=t.length;if(0===u){if("complex64"===n){return[It(At(e)[0],0,n)]}return"bool"===n?[$t(e[0])]:[e[0].toString()]}if(1===u){if(i>20){const t=3*o;let r=Array.from(e.slice(0,t)),a=Array.from(e.slice((i-3)*o,i*o));return"complex64"===n&&(r=At(r),a=At(a)),["["+r.map(((e,t)=>It(e,s[t],n))).join(", ")+", ..., "+a.map(((e,t)=>It(e,s[i-3+t],n))).join(", ")+"]"]}return["["+("complex64"===n?At(e):Array.from(e)).map(((e,t)=>It(e,s[t],n))).join(", ")+"]"]}const p=t.slice(1),l=r.slice(1),c=r[0]*o,h=[];if(i>20){for(let t=0;t<3;t++){const r=t*c,a=r+c;h.push(...Dt(e.slice(r,a),p,n,l,s,!1))}h.push("...");for(let t=i-3;t<i;t++){const r=t*c,a=r+c;h.push(...Dt(e.slice(r,a),p,n,l,s,t===i-1))}}else for(let t=0;t<i;t++){const r=t*c,a=r+c;h.push(...Dt(e.slice(r,a),p,n,l,s,t===i-1))}const d=2===u?",":"";h[0]="["+(i>0?h[0]+d:"");for(let e=1;e<h.length-1;e++)h[e]=" "+h[e]+d;let m=",\n";for(let e=2;e<u;e++)m+="\n";return h[h.length-1]=" "+h[h.length-1]+"]"+(a?"":m),h}function At(e){const t=[];for(let n=0;n<e.length;n+=2)t.push([e[n],e[n+1]]);return t}class Ot{constructor(e,t,n){if(this.dtype=t,this.shape=e.slice(),this.size=ye(e),null!=n){const e=n.length;de(e===this.size,(()=>`Length of values '${e}' does not match the size inferred by the shape '${this.size}'.`))}if("complex64"===t)throw new Error("complex64 dtype TensorBuffers are not supported. Please create a TensorBuffer for the real and imaginary parts separately and call tf.complex(real, imag).");this.values=n||we(t,this.size),this.strides=Se(e)}set(e,...t){0===t.length&&(t=[0]),de(t.length===this.rank,(()=>`The number of provided coordinates (${t.length}) must match the rank (${this.rank})`));const n=this.locToIndex(t);this.values[n]=e}get(...e){0===e.length&&(e=[0]);let t=0;for(const n of e){if(n<0||n>=this.shape[t]){const t=`Requested out of range element at ${e}.   Buffer shape=${this.shape}`;throw new Error(t)}t++}let n=e[e.length-1];for(let t=0;t<e.length-1;++t)n+=this.strides[t]*e[t];return this.values[n]}locToIndex(e){if(0===this.rank)return 0;if(1===this.rank)return e[0];let t=e[e.length-1];for(let n=0;n<e.length-1;++n)t+=this.strides[n]*e[n];return t}indexToLoc(e){if(0===this.rank)return[];if(1===this.rank)return[e];const t=new Array(this.shape.length);for(let n=0;n<t.length-1;++n)t[n]=Math.floor(e/this.strides[n]),e-=t[n]*this.strides[n];return t[t.length-1]=e,t}get rank(){return this.shape.length}toTensor(){return Mt().makeTensor(this.values,this.shape,this.dtype)}}let Mt=null;class Ct{constructor(e,t,n,r){this.kept=!1,this.isDisposedInternal=!1,this.shape=e.slice(),this.dtype=t||"float32",this.size=ye(e),this.strides=Se(e),this.dataId=n,this.id=r,this.rankType=this.rank<5?this.rank.toString():"higher"}get rank(){return this.shape.length}async buffer(){const e=await this.data();return null.buffer(this.shape,this.dtype,e)}bufferSync(){return null.buffer(this.shape,this.dtype,this.dataSync())}async array(){const e=await this.data();return Ie(this.shape,e,"complex64"===this.dtype)}arraySync(){return Ie(this.shape,this.dataSync(),"complex64"===this.dtype)}async data(){this.throwIfDisposed();const e=Mt().read(this.dataId);if("string"===this.dtype){const t=await e;try{return t.map((e=>wt(e)))}catch(e){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}}return e}dataToGPU(e){return this.throwIfDisposed(),Mt().readToGPU(this.dataId,e)}dataSync(){this.throwIfDisposed();const e=Mt().readSync(this.dataId);if("string"===this.dtype)try{return e.map((e=>wt(e)))}catch(e){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}return e}async bytes(){this.throwIfDisposed();const e=await Mt().read(this.dataId);return"string"===this.dtype?e:new Uint8Array(e.buffer)}dispose(){this.isDisposed||(Mt().disposeTensor(this),this.isDisposedInternal=!0)}get isDisposed(){return this.isDisposedInternal}throwIfDisposed(){if(this.isDisposed)throw new Error("Tensor is disposed.")}print(e=!1){return null.print(this,e)}clone(){return this.throwIfDisposed(),null.clone(this)}toString(e=!1){return Et(this.dataSync(),this.shape,this.dtype,e)}cast(e){return this.throwIfDisposed(),null.cast(this,e)}variable(e=!0,t,n){return this.throwIfDisposed(),Mt().makeVariable(this,e,t,n)}}Object.defineProperty(Ct,Symbol.hasInstance,{value:e=>!!e&&null!=e.data&&null!=e.dataSync&&null!=e.throwIfDisposed}),Le("Tensor",(()=>Ct));class Ft extends Ct{constructor(e,t,n,r){super(e.shape,e.dtype,e.dataId,r),this.trainable=t,this.name=n}assign(e){if(e.dtype!==this.dtype)throw new Error(`dtype of the new value (${e.dtype}) and previous value (${this.dtype}) must match`);if(!ge(e.shape,this.shape))throw new Error(`shape of the new value (${e.shape}) and previous value (${this.shape}) must match`);Mt().disposeTensor(this),this.dataId=e.dataId,Mt().incRef(this,null)}dispose(){Mt().disposeVariable(this),this.isDisposedInternal=!0}}var Rt,zt,Vt,Lt,Bt;Object.defineProperty(Ft,Symbol.hasInstance,{value:e=>e instanceof Ct&&null!=e.assign&&e.assign instanceof Function}),function(e){e.R0="R0",e.R1="R1",e.R2="R2",e.R3="R3",e.R4="R4",e.R5="R5",e.R6="R6"}(Rt||(Rt={})),function(e){e.float32="float32",e.int32="int32",e.bool="int32",e.complex64="complex64"}(zt||(zt={})),function(e){e.float32="float32",e.int32="int32",e.bool="bool",e.complex64="complex64"}(Vt||(Vt={})),function(e){e.float32="float32",e.int32="float32",e.bool="float32",e.complex64="complex64"}(Lt||(Lt={})),function(e){e.float32="complex64",e.int32="complex64",e.bool="complex64",e.complex64="complex64"}(Bt||(Bt={}));const Pt={float32:Lt,int32:zt,bool:Vt,complex64:Bt};function Kt(e){return null!=e&&"object"==typeof e&&"texture"in e&&e.texture instanceof WebGLTexture}function qt(e){return"undefined"!=typeof GPUBuffer&&null!=e&&"object"==typeof e&&"buffer"in e&&e.buffer instanceof GPUBuffer}function Ut(e,t){if(e.dtype===t.dtype)return[e,t];const n=function(e,t){if("string"===e||"string"===t){if("string"===e&&"string"===t)return"string";throw new Error(`Can not upcast ${e} with ${t}`)}return Pt[e][t]}(e.dtype,t.dtype);return[e.cast(n),t.cast(n)]}function Wt(e){const t=[];return jt(e,t,new Set),t}function jt(e,t,n){if(null==e)return;if(e instanceof Ct)return void t.push(e);if(r=e,!Array.isArray(r)&&"object"!=typeof r)return;var r;const s=e;for(const e in s){const r=s[e];n.has(r)||(n.add(r),jt(r,t,n))}}function Ht(e){return null!=e.kernelName}class Gt{constructor(){this.registeredVariables={},this.nextTapeNodeId=0,this.numBytes=0,this.numTensors=0,this.numStringTensors=0,this.numDataBuffers=0,this.gradientDepth=0,this.kernelDepth=0,this.scopeStack=[],this.numDataMovesStack=[],this.nextScopeId=0,this.tensorInfo=new WeakMap,this.profiling=!1,this.activeProfile={newBytes:0,newTensors:0,peakBytes:0,kernels:[],result:null,get kernelNames(){return Array.from(new Set(this.kernels.map((e=>e.name))))}}}dispose(){for(const e in this.registeredVariables)this.registeredVariables[e].dispose()}}class Zt{constructor(e){this.ENV=e,this.registry={},this.registryFactory={},this.pendingBackendInitId=0,this.state=new Gt}async ready(){if(null!=this.pendingBackendInit)return this.pendingBackendInit.then((()=>{}));if(null!=this.backendInstance)return;const e=this.getSortedBackends();for(let t=0;t<e.length;t++){const n=e[t];if(await this.initializeBackend(n).success)return void await this.setBackend(n)}throw new Error("Could not initialize any backends, all backend initializations failed.")}get backend(){if(null!=this.pendingBackendInit)throw new Error(`Backend '${this.backendName}' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods`);if(null==this.backendInstance){const{name:e,asyncInit:t}=this.initializeBackendsAndReturnBest();if(t)throw new Error(`The highest priority backend '${e}' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods`);this.setBackend(e)}return this.backendInstance}backendNames(){return Object.keys(this.registryFactory)}findBackend(e){if(!(e in this.registry)){if(!(e in this.registryFactory))return null;{const{asyncInit:t}=this.initializeBackend(e);if(t)return null}}return this.registry[e]}findBackendFactory(e){return e in this.registryFactory?this.registryFactory[e].factory:null}registerBackend(e,t,n=1){return e in this.registryFactory?(Be(`${e} backend was already registered. Reusing existing backend factory.`),!1):(this.registryFactory[e]={factory:t,priority:n},!0)}async setBackend(e){if(null==this.registryFactory[e])throw new Error(`Backend name '${e}' not found in registry`);if(this.backendName=e,null==this.registry[e]){this.backendInstance=null;const{success:t,asyncInit:n}=this.initializeBackend(e);if(!(n?await t:t))return!1}return this.backendInstance=this.registry[e],this.setupRegisteredKernels(),this.profiler=new vt(this.backendInstance),!0}setupRegisteredKernels(){We(this.backendName).forEach((e=>{null!=e.setupFunc&&e.setupFunc(this.backendInstance)}))}disposeRegisteredKernels(e){We(e).forEach((t=>{null!=t.disposeFunc&&t.disposeFunc(this.registry[e])}))}initializeBackend(e){const t=this.registryFactory[e];if(null==t)throw new Error(`Cannot initialize backend ${e}, no registration found.`);try{const n=t.factory();if(!n||n instanceof class{refCount(e){return he("refCount")}incRef(e){return he("incRef")}timerAvailable(){return!0}time(e){return he("time")}read(e){return he("read")}readSync(e){return he("readSync")}readToGPU(e,t){return he("readToGPU")}numDataIds(){return he("numDataIds")}disposeData(e,t){return he("disposeData")}write(e,t,n){return he("write")}move(e,t,n,r,s){return he("move")}createTensorFromGPUData(e,t,n){return he("createTensorFromGPUData")}memory(){return he("memory")}floatPrecision(){return he("floatPrecision")}epsilon(){return 32===this.floatPrecision()?1e-7:1e-4}dispose(){return he("dispose")}}||"function"!=typeof n.then)return this.registry[e]=n,{success:!0,asyncInit:!1};{const t=++this.pendingBackendInitId,r=n.then((n=>!(t<this.pendingBackendInitId)&&(this.registry[e]=n,this.pendingBackendInit=null,!0))).catch((n=>(t<this.pendingBackendInitId||(this.pendingBackendInit=null,Be(`Initialization of backend ${e} failed`),Be(n.stack||n.message)),!1)));return this.pendingBackendInit=r,{success:r,asyncInit:!0}}}catch(t){return Be(`Initialization of backend ${e} failed`),Be(t.stack||t.message),{success:!1,asyncInit:!1}}}removeBackend(e){if(!(e in this.registryFactory))throw new Error(`${e} backend not found in registry`);this.backendName===e&&null!=this.pendingBackendInit&&this.pendingBackendInitId++,e in this.registry&&(this.disposeRegisteredKernels(e),this.registry[e].dispose(),delete this.registry[e]),delete this.registryFactory[e],this.backendName===e&&(this.pendingBackendInit=null,this.backendName=null,this.backendInstance=null)}getSortedBackends(){if(0===Object.keys(this.registryFactory).length)throw new Error("No backend found in registry.");return Object.keys(this.registryFactory).sort(((e,t)=>this.registryFactory[t].priority-this.registryFactory[e].priority))}initializeBackendsAndReturnBest(){const e=this.getSortedBackends();for(let t=0;t<e.length;t++){const n=e[t],{success:r,asyncInit:s}=this.initializeBackend(n);if(s||r)return{name:n,asyncInit:s}}throw new Error("Could not initialize any backends, all backend initializations failed.")}moveData(e,t){const n=this.state.tensorInfo.get(t),r=n.backend,s=this.readSync(t),a=r.refCount(t);r.disposeData(t,!0),n.backend=e,e.move(t,s,n.shape,n.dtype,a),this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack[this.state.numDataMovesStack.length-1]++}tidy(e,t){let n,r=null;if(null==t){if("function"!=typeof e)throw new Error("Please provide a function to tidy()");t=e}else{if("string"!=typeof e&&!(e instanceof String))throw new Error("When calling with two arguments, the first argument to tidy() must be a string");if("function"!=typeof t)throw new Error("When calling with two arguments, the 2nd argument to tidy() must be a function");r=e}return this.scopedRun((()=>this.startScope(r)),(()=>this.endScope(n)),(()=>(n=t(),n instanceof Promise&&console.error("Cannot return a Promise inside of tidy."),n)))}scopedRun(e,t,n){e();try{const e=n();return t(),e}catch(e){throw t(),e}}nextTensorId(){return Zt.nextTensorId++}nextVariableId(){return Zt.nextVariableId++}clone(e){const t=Qt.runKernel("Identity",{x:e}),n={x:e};return this.addTapeNode(this.state.activeScope.name,n,[t],(e=>({x:()=>{const t={x:e},n={dtype:"float32"};return Qt.runKernel("Cast",t,n)}})),[],{}),t}runKernel(e,t,n){null==this.backendName&&this.backend;if(!(null!=qe(e,this.backendName)))throw new Error(`Kernel '${e}' not registered for backend '${this.backendName}'`);return this.runKernelFunc({kernelName:e,inputs:t,attrs:n})}shouldCheckForMemLeaks(){return this.ENV.getBool("IS_TEST")}checkKernelForMemLeak(e,t,n){const r=this.backend.numDataIds();let s=0;n.forEach((e=>{s+="complex64"===e.dtype?3:1}));const a=this.state.numDataMovesStack[this.state.numDataMovesStack.length-1],o=r-t-s-a;if(o>0)throw new Error(`Backend '${this.backendName}' has an internal memory leak (${o} data ids) after running '${e}'`)}runKernelFunc(e){let t,n=[];const r=this.isTapeOn(),s=this.state.numBytes,a=this.state.numTensors;let o,i;this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack.push(0),null==this.backendName&&this.backend;const u=Ht(e)?e.kernelName:null!=this.state.activeScope?this.state.activeScope.name:"";if(Ht(e)){const{kernelName:t,inputs:s,attrs:a}=e;null==this.backendName&&this.backend;const u=qe(t,this.backendName);de(null!=u,(()=>`Cannot find registered kernel '${t}' for backend '${this.backendName}'`)),o=()=>{const e=this.backend.numDataIds();i=u.kernelFunc({inputs:s,attrs:a,backend:this.backend});const o=Array.isArray(i)?i:[i];this.shouldCheckForMemLeaks()&&this.checkKernelForMemLeak(t,e,o);const p=o.map((e=>null!=e.rank?e:this.makeTensorFromTensorInfo(e)));if(r){const e=this.getTensorsForGradient(t,s,p);n=this.saveTensorsForBackwardMode(e)}return p}}else{const{forwardFunc:t}=e,s=e=>{r&&(n=e.map((e=>this.keep(this.clone(e)))))};o=()=>{const e=this.backend.numDataIds();i=this.tidy((()=>t(this.backend,s)));const n=Array.isArray(i)?i:[i];return this.shouldCheckForMemLeaks()&&this.checkKernelForMemLeak(u,e,n),n}}const{inputs:p,attrs:l}=e,c=Ht(e)?null:e.backwardsFunc;let h;return this.scopedRun((()=>this.state.kernelDepth++),(()=>this.state.kernelDepth--),(()=>{this.ENV.getBool("DEBUG")||this.state.profiling?(h=this.profiler.profileKernel(u,p,(()=>o())),this.ENV.getBool("DEBUG")&&this.profiler.logKernelProfile(h),t=h.outputs):t=o()})),r&&this.addTapeNode(u,p,t,c,n,l),this.state.profiling&&this.state.activeProfile.kernels.push({name:u,bytesAdded:this.state.numBytes-s,totalBytesSnapshot:this.state.numBytes,tensorsAdded:this.state.numTensors-a,totalTensorsSnapshot:this.state.numTensors,inputShapes:Object.keys(p).map((e=>null!=p[e]?p[e].shape:null)),outputShapes:t.map((e=>e.shape)),kernelTimeMs:h.timeMs,extraInfo:h.extraInfo}),Array.isArray(i)?t:t[0]}saveTensorsForBackwardMode(e){const t=e.map((e=>this.keep(this.clone(e))));return t}getTensorsForGradient(e,t,n){const r=Ue(e);if(null!=r){const e=r.inputsToSave||[],s=r.outputsToSave||[];let a;r.saveAllInputs?(de(Array.isArray(t),(()=>"saveAllInputs is true, expected inputs to be an array.")),a=Object.keys(t).map((e=>t[e]))):a=e.map((e=>t[e]));const o=n.filter(((e,t)=>s[t]));return a.concat(o)}return[]}makeTensor(e,t,n,r){if(null==e)throw new Error("Values passed to engine.makeTensor() are null");n=n||"float32",r=r||this.backend;let s=e;"string"===n&&Te(e[0])&&(s=e.map((e=>function(e,t="utf-8"){return t=t||"utf-8",Fe().platform.encode(e,t)}(e))));const a=r.write(s,t,n),o=new Ct(t,n,a,this.nextTensorId());if(this.trackTensor(o,r),"string"===n){const e=this.state.tensorInfo.get(a),t=function(e){if(null==e)return 0;let t=0;return e.forEach((e=>t+=e.length)),t}(s);this.state.numBytes+=t-e.bytes,e.bytes=t}return o}makeTensorFromDataId(e,t,n,r){const s={dataId:e,shape:t,dtype:n=n||"float32"};return this.makeTensorFromTensorInfo(s,r)}makeTensorFromTensorInfo(e,t){const{dataId:n,shape:r,dtype:s}=e,a=new Ct(r,s,n,this.nextTensorId());return this.trackTensor(a,t),a}makeVariable(e,t=!0,n,r){n=n||this.nextVariableId().toString(),null!=r&&r!==e.dtype&&(e=e.cast(r));const s=new Ft(e,t,n,this.nextTensorId());if(null!=this.state.registeredVariables[s.name])throw new Error(`Variable with name ${s.name} was already registered`);return this.state.registeredVariables[s.name]=s,this.incRef(s,this.backend),s}trackTensor(e,t){this.state.numTensors++,"string"===e.dtype&&this.state.numStringTensors++;let n=0;"complex64"!==e.dtype&&"string"!==e.dtype&&(n=e.size*ke(e.dtype)),this.state.numBytes+=n,this.state.tensorInfo.has(e.dataId)||(this.state.numDataBuffers++,this.state.tensorInfo.set(e.dataId,{backend:t||this.backend,dtype:e.dtype,shape:e.shape,bytes:n})),e instanceof Ft||this.track(e)}incRef(e,t){this.trackTensor(e,t),this.backend.incRef(e.dataId)}removeDataId(e,t){this.state.tensorInfo.has(e)&&this.state.tensorInfo.get(e).backend===t&&(this.state.tensorInfo.delete(e),this.state.numDataBuffers--)}disposeTensor(e){if(!this.state.tensorInfo.has(e.dataId))return;const t=this.state.tensorInfo.get(e.dataId);if(this.state.numTensors--,"string"===e.dtype&&(this.state.numStringTensors--,this.state.numBytes-=t.bytes),"complex64"!==e.dtype&&"string"!==e.dtype){const t=e.size*ke(e.dtype);this.state.numBytes-=t}t.backend.disposeData(e.dataId)&&this.removeDataId(e.dataId,t.backend)}disposeVariables(){for(const e in this.state.registeredVariables){const t=this.state.registeredVariables[e];this.disposeVariable(t)}}disposeVariable(e){this.disposeTensor(e),null!=this.state.registeredVariables[e.name]&&delete this.state.registeredVariables[e.name]}memory(){const e=this.backend.memory();return e.numTensors=this.state.numTensors,e.numDataBuffers=this.state.numDataBuffers,e.numBytes=this.state.numBytes,this.state.numStringTensors>0&&(e.unreliable=!0,null==e.reasons&&(e.reasons=[]),e.reasons.push("Memory usage by string tensors is approximate (2 bytes per character)")),e}async profile(e){this.state.profiling=!0;const t=this.state.numBytes,n=this.state.numTensors;this.state.activeProfile.kernels=[],this.state.activeProfile.result=await e(),this.state.profiling=!1,this.state.activeProfile.peakBytes=Math.max(...this.state.activeProfile.kernels.map((e=>e.totalBytesSnapshot))),this.state.activeProfile.newBytes=this.state.numBytes-t,this.state.activeProfile.newTensors=this.state.numTensors-n;for(const e of this.state.activeProfile.kernels)e.kernelTimeMs=await e.kernelTimeMs,e.extraInfo=await e.extraInfo;return this.state.activeProfile}isTapeOn(){return this.state.gradientDepth>0&&0===this.state.kernelDepth}addTapeNode(e,t,n,r,s,a){const o={id:this.state.nextTapeNodeId++,kernelName:e,inputs:t,outputs:n,saved:s},i=Ue(e);null!=i&&(r=i.gradFunc),null!=r&&(o.gradient=e=>(e=e.map(((e,t)=>{if(null==e){const e=n[t],r=De(e.size,e.dtype);return this.makeTensor(r,e.shape,e.dtype)}return e})),r(e.length>1?e:e[0],s,a))),this.state.activeTape.push(o)}keep(e){return e.kept=!0,e}startTape(){0===this.state.gradientDepth&&(this.state.activeTape=[]),this.state.gradientDepth++}endTape(){this.state.gradientDepth--}startScope(e){const t={track:[],name:"unnamed scope",id:this.state.nextScopeId++};e&&(t.name=e),this.state.scopeStack.push(t),this.state.activeScope=t}endScope(e){const t=Wt(e),n=new Set(t.map((e=>e.id)));for(let e=0;e<this.state.activeScope.track.length;e++){const t=this.state.activeScope.track[e];t.kept||n.has(t.id)||t.dispose()}const r=this.state.scopeStack.pop();this.state.activeScope=0===this.state.scopeStack.length?null:this.state.scopeStack[this.state.scopeStack.length-1],t.forEach((e=>{e.kept||e.scopeId!==r.id||this.track(e)}))}gradients(e,t,n,r=!1){if(de(t.length>0,(()=>"gradients() received an empty list of xs.")),null!=n&&"float32"!==n.dtype)throw new Error(`dy must have 'float32' dtype, but has '${n.dtype}'`);const s=this.scopedRun((()=>this.startTape()),(()=>this.endTape()),(()=>this.tidy("forward",e)));de(s instanceof Ct,(()=>"The result y returned by f() must be a tensor."));const a=function(e,t,n){const r={},s={};for(let e=0;e<t.length;e++)r[t[e].id]=!0;for(let n=0;n<e.length;n++){const a=e[n],o=a.inputs;for(const e in o){const n=o[e];let i=!1;for(let e=0;e<t.length;e++)if(r[n.id]){a.outputs.forEach((e=>r[e.id]=!0)),i=!0,s[a.id]=!0;break}if(i)break}}const a={};a[n.id]=!0;const o={};for(let t=e.length-1;t>=0;t--){const n=e[t],r=n.inputs;for(let e=0;e<n.outputs.length;e++)if(a[n.outputs[e].id]){for(const e in r)a[r[e].id]=!0,o[n.id]=!0;break}}const i=[];for(let t=0;t<e.length;t++){const n=e[t];if(s[n.id]&&o[n.id]){const e={};for(const t in n.inputs){const s=n.inputs[t];r[s.id]&&(e[t]=s)}const t=Object.assign({},n);t.inputs=e,t.outputs=n.outputs,i.push(t)}}return i}(this.state.activeTape,t,s);if(!r&&0===a.length&&t.length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that the f you passed encloses all operations that lead from x to y.");return this.tidy("backward",(()=>{const e={};e[s.id]=null==n?function(e){const t=$e(ye(e),"float32");return Qt.makeTensor(t,e,"float32")}(s.shape):n,function(e,t,n,r){for(let s=t.length-1;s>=0;s--){const a=t[s],o=[];if(a.outputs.forEach((t=>{const n=e[t.id];null!=n?o.push(n):o.push(null)})),null==a.gradient)throw new Error(`Cannot compute gradient: gradient function not found for ${a.kernelName}.`);const i=a.gradient(o);for(const t in a.inputs){if(!(t in i))throw new Error(`Cannot backprop through input ${t}. Available gradients found: ${Object.keys(i)}.`);const s=n((()=>i[t]()));if("float32"!==s.dtype)throw new Error(`Error in gradient for op ${a.kernelName}. The gradient of input ${t} must have 'float32' dtype, but has '${s.dtype}'`);const o=a.inputs[t];if(!ge(s.shape,o.shape))throw new Error(`Error in gradient for op ${a.kernelName}. The gradient of input '${t}' has shape '${s.shape}', which does not match the shape of the input '${o.shape}'`);if(null==e[o.id])e[o.id]=s;else{const t=e[o.id];e[o.id]=r(t,s),t.dispose()}}}}(e,a,(e=>this.tidy(e)),Yt);const r=t.map((t=>e[t.id]));return 0===this.state.gradientDepth&&(this.state.activeTape.forEach((e=>{for(const t of e.saved)t.dispose()})),this.state.activeTape=null),{value:s,grads:r}}))}customGrad(e){return de(_e(e),(()=>"The f passed in customGrad(f) must be a function.")),(...t)=>{let n;de(t.every((e=>e instanceof Ct)),(()=>"The args passed in customGrad(f)(x1, x2,...) must all be tensors"));const r={};t.forEach(((e,t)=>{r[t]=e}));return this.runKernelFunc({forwardFunc:(r,s)=>(n=e(...t,s),de(n.value instanceof Ct,(()=>"The function f passed in customGrad(f) must return an object where `obj.value` is a tensor")),de(_e(n.gradFunc),(()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function.")),n.value),backwardsFunc:(e,r)=>{const s=n.gradFunc(e,r),a=Array.isArray(s)?s:[s];de(a.length===t.length,(()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns the same number of tensors as inputs passed to f(...).")),de(a.every((e=>e instanceof Ct)),(()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns a list of only tensors."));const o={};return a.forEach(((e,t)=>{o[t]=()=>e})),o},inputs:r})}}readSync(e){return this.state.tensorInfo.get(e).backend.readSync(e)}read(e){return this.state.tensorInfo.get(e).backend.read(e)}readToGPU(e,t){return this.state.tensorInfo.get(e).backend.readToGPU(e,t)}async time(e){const t=xt(),n=await this.backend.time(e);return n.wallMs=xt()-t,n}track(e){return null!=this.state.activeScope&&(e.scopeId=this.state.activeScope.id,this.state.activeScope.track.push(e)),e}get registeredVariables(){return this.state.registeredVariables}reset(){this.pendingBackendInitId++,this.state.dispose(),this.ENV.reset(),this.state=new Gt;for(const e in this.registry)this.disposeRegisteredKernels(e),this.registry[e].dispose(),delete this.registry[e];this.backendName=null,this.backendInstance=null,this.pendingBackendInit=null}}Zt.nextTensorId=0,Zt.nextVariableId=0;const Qt=function(){const e=Ve();if(null==e._tfengine){const t=new Me(e);e._tfengine=new Zt(t)}var t;return t=e._tfengine.ENV,ze=t,Mt=()=>e._tfengine,e._tfengine}();function Yt(e,t){const n={a:e,b:t};return Qt.runKernel("Add",n)}function Xt(e,t){let n=e;if(kt(e))return"string"===t?[]:[e.length];if(Kt(e)){const t=e.channels||"RGBA";return[e.height,e.width*t.length]}if(qt(e))return[e.buffer.size/(null==t?4:ke(t))];if(!Array.isArray(e))return[];const r=[];for(;Array.isArray(n)||kt(n)&&"string"!==t;)r.push(n.length),n=n[0];return Array.isArray(e)&&Fe().getBool("TENSORLIKE_CHECK_SHAPE_CONSISTENCY")&&Jt(e,r,[]),r}function Jt(e,t,n){if(n=n||[],!Array.isArray(e)&&!kt(e))return void de(0===t.length,(()=>`Element arr[${n.join("][")}] is a primitive, but should be an array/TypedArray of ${t[0]} elements`));de(t.length>0,(()=>`Element arr[${n.join("][")}] should be a primitive, but is an array of ${e.length} elements`)),de(e.length===t[0],(()=>`Element arr[${n.join("][")}] should have ${t[0]} elements, but has ${e.length} elements`));const r=t.slice(1);for(let t=0;t<e.length;++t)Jt(e[t],r,n.concat(t))}function en(e,t,n,r){if("string_or_numeric"!==e){if(null==e)throw new Error("Expected dtype cannot be null.");if("numeric"!==e&&e!==t||"numeric"===e&&"string"===t)throw new Error(`Argument '${n}' passed to '${r}' must be ${e} tensor, but got ${t} tensor`)}}function tn(e,t,n,r="numeric"){if(e instanceof Ct)return en(r,e.dtype,t,n),e;let s=ve(e);if("string"!==s&&["bool","int32","float32"].indexOf(r)>=0&&(s=r),en(r,s,t,n),null==e||!kt(e)&&!Array.isArray(e)&&"number"!=typeof e&&"boolean"!=typeof e&&"string"!=typeof e){const r=null==e?"null":e.constructor.name;throw new Error(`Argument '${t}' passed to '${n}' must be a Tensor or TensorLike, but got '${r}'`)}const a=Xt(e,s);kt(e)||Array.isArray(e)||(e=[e]);const o="string"!==s?Nt(e,s):Tt(e,[],!0);return Qt.makeTensor(o,a,s)}function nn(e,t,n,r="numeric"){if(!Array.isArray(e))throw new Error(`Argument ${t} passed to ${n} must be a \`Tensor[]\` or \`TensorLike[]\``);return e.map(((e,s)=>tn(e,`${t}[${s}]`,n,r)))}function rn(e){const t=Object.keys(e);if(1!==t.length)throw new Error(`Please provide an object with a single key (operation name) mapping to a function. Got an object with ${t.length} keys.`);let n=t[0];const r=e[n];n.endsWith("_")&&(n=n.substring(0,n.length-1)),n+="__op";const s=(...e)=>{Qt.startScope(n);try{const t=r(...e);return Oe(t)&&console.error("Cannot return a Promise inside of tidy."),Qt.endScope(t),t}catch(e){throw Qt.endScope(null),e}};return Object.defineProperty(s,"name",{value:n,configurable:!0}),s}const sn=rn({abs_:function(e){const t=tn(e,"x","abs");if("complex64"===t.dtype){const e={x:t};return Qt.runKernel("ComplexAbs",e)}{const e={x:t};return Qt.runKernel("Abs",e)}}});const an=rn({acos_:function(e){const t={x:tn(e,"x","acos")};return Qt.runKernel("Acos",t)}});const on=rn({acosh_:function(e){const t={x:tn(e,"x","acosh")};return Qt.runKernel("Acosh",t)}});const un=rn({add_:function(e,t){let n=tn(e,"a","add"),r=tn(t,"b","add");[n,r]=Ut(n,r);const s={a:n,b:r};return Qt.runKernel("Add",s)}});const pn=rn({addN_:function(e){de(Array.isArray(e),(()=>"The argument passed to tf.addN() must be a list of tensors")),de(e.length>=1,(()=>`Must pass at least one tensor to tf.addN(), but got ${e.length}`));const t=e.map(((e,t)=>tn(e,`tensors${t}`,"addN"))),n=t[0];t.forEach((e=>{if(e.dtype!==n.dtype)throw new Error("All tensors passed to tf.addN() must have the same dtype")})),t.forEach((e=>{if(!ge(e.shape,n.shape))throw new Error("All tensors passed to tf.addN() must have the same shape")}));const r=t;return Qt.runKernel("AddN",r)}});const ln=rn({all_:function(e,t=null,n=!1){const r={x:tn(e,"x","all","bool")},s={axis:t,keepDims:n};return Qt.runKernel("All",r,s)}});const cn=rn({any_:function(e,t=null,n=!1){const r={x:tn(e,"x","any","bool")},s={axis:t,keepDims:n};return Qt.runKernel("Any",r,s)}});const hn=rn({argMax_:function(e,t=0){const n={x:tn(e,"x","argMax")},r={axis:t};return Qt.runKernel("ArgMax",n,r)}});const dn=rn({argMin_:function(e,t=0){const n={x:tn(e,"x","argMin")},r={axis:t};return Qt.runKernel("ArgMin",n,r)}});const mn=rn({asin_:function(e){const t={x:tn(e,"x","asin")};return Qt.runKernel("Asin",t)}});const fn=rn({asinh_:function(e){const t={x:tn(e,"x","asinh")};return Qt.runKernel("Asinh",t)}});const yn=rn({atan_:function(e){const t={x:tn(e,"x","atan")};return Qt.runKernel("Atan",t)}});const gn=rn({atan2_:function(e,t){let n=tn(e,"a","atan2"),r=tn(t,"b","atan2");[n,r]=Ut(n,r);const s={a:n,b:r};return Qt.runKernel("Atan2",s)}});const bn=rn({atanh_:function(e){const t={x:tn(e,"x","atanh")};return Qt.runKernel("Atanh",t)}});const Nn=rn({cast_:function(e,t){const n=tn(e,"x","cast");if(!function(e){return"bool"===e||"complex64"===e||"float32"===e||"int32"===e||"string"===e}(t))throw new Error(`Failed to cast to unknown dtype ${t}`);if("string"===t&&"string"!==n.dtype||"string"!==t&&"string"===n.dtype)throw new Error("Only strings can be casted to strings");const r={x:n},s={dtype:t};return Qt.runKernel("Cast",r,s)}});function xn(e,t,n,r,s,a,o=!1,i="channelsLast"){let[u,p,l,c]=[-1,-1,-1,-1];if("channelsLast"===i)[u,p,l,c]=e;else{if("channelsFirst"!==i)throw new Error(`Unknown dataFormat ${i}`);[u,c,p,l]=e}const[h,d,,m]=t,[f,y]=wn(n),[g,b]=wn(r),N=kn(h,g),x=kn(d,b),{padInfo:w,outHeight:k,outWidth:T}=function(e,t,n,r,s,a,o,i,u){let p,l,c;if("number"==typeof e){p={top:e,bottom:e,left:e,right:e,type:0===e?"VALID":"NUMBER"};const s=function(e,t,n,r,s){null==r&&(r=function(e,t,n,r=1){const s=kn(t,r);return Math.floor((e[0]*(n-1)-n+s)/2)}(e,t,n));const a=e[0],o=e[1],i=Tn((a-t+2*r)/n+1,s),u=Tn((o-t+2*r)/n+1,s);return[i,u]}([t,n],a,r,e,i);l=s[0],c=s[1]}else if("same"===e){l=Math.ceil(t/r),c=Math.ceil(n/s);const e=Math.max(0,(l-1)*r+a-t),i=Math.max(0,(c-1)*s+o-n),u=Math.floor(e/2),h=e-u,d=Math.floor(i/2);p={top:u,bottom:h,left:d,right:i-d,type:"SAME"}}else if("valid"===e)p={top:0,bottom:0,left:0,right:0,type:"VALID"},l=Math.ceil((t-a+1)/r),c=Math.ceil((n-o+1)/s);else{if("object"!=typeof e)throw Error(`Unknown padding parameter: ${e}`);{const h="channelsLast"===u?e[1][0]:e[2][0],d="channelsLast"===u?e[1][1]:e[2][1],m="channelsLast"===u?e[2][0]:e[3][0],f="channelsLast"===u?e[2][1]:e[3][1];p={top:h,bottom:d,left:m,right:f,type:0===h&&0===d&&0===m&&0===f?"VALID":"EXPLICIT"},l=Tn((t-a+h+d)/r+1,i),c=Tn((n-o+m+f)/s+1,i)}}return{padInfo:p,outHeight:l,outWidth:c}}(s,p,l,f,y,N,x,a,i),v=o?m*c:m;let _;return"channelsFirst"===i?_=[u,v,k,T]:"channelsLast"===i&&(_=[u,k,T,v]),{batchSize:u,dataFormat:i,inHeight:p,inWidth:l,inChannels:c,outHeight:k,outWidth:T,outChannels:v,padInfo:w,strideHeight:f,strideWidth:y,filterHeight:h,filterWidth:d,effectiveFilterHeight:N,effectiveFilterWidth:x,dilationHeight:g,dilationWidth:b,inShape:e,outShape:_,filterShape:t}}function wn(e){return"number"==typeof e?[e,e,e]:2===e.length?[e[0],e[1],1]:e}function kn(e,t){return t<=1?e:e+(e-1)*(t-1)}function Tn(e,t){if(!t)return Math.trunc(e);switch(t){case"round":return Math.round(e);case"ceil":return Math.ceil(e);case"floor":return Math.floor(e);default:throw new Error(`Unknown roundingMode ${t}`)}}function vn(e){const[t,n,r]=wn(e);return 1===t&&1===n&&1===r}function _n(e,t){return vn(e)||vn(t)}function Sn(e){return wn(e).every((e=>e>0))}function En(e,t,n){if(null!=n){if("string"==typeof t)throw Error(`Error in ${e}: pad must be an integer when using dimRoundingMode ${n} but got pad ${t}.`);if("number"==typeof t)de(be(t),(()=>`Error in ${e}: pad must be an integer when using dimRoundingMode ${n} but got pad ${t}.`));else{if("object"!=typeof t)throw Error(`Error in ${e}: Unknown padding parameter: ${t}`);t.forEach((t=>{t.forEach((t=>{de(be(t),(()=>`Error in ${e}: pad must be an integer when using dimRoundingMode ${n} but got pad ${t}.`))}))}))}}}const In=rn({reshape_:function(e,t){const n={x:tn(e,"x","reshape","string_or_numeric")},r={shape:t};return Qt.runKernel("Reshape",n,r)}});const $n=rn({avgPool_:function(e,t,n,r,s){const a=tn(e,"x","avgPool","float32");de(_n(n,1),(()=>`Error in avgPool: Either strides or dilations must be 1. Got strides ${n} and dilations '1'`));let o=a,i=!1;3===a.rank&&(i=!0,o=In(a,[1,a.shape[0],a.shape[1],a.shape[2]])),de(4===o.rank,(()=>`Error in avgPool: x must be rank 4 but got rank ${o.rank}.`)),En("avgPool",r,s);const u={x:o},p={filterSize:t,strides:n,pad:r,dimRoundingMode:s};let l=Qt.runKernel("AvgPool",u,p);return l=Nn(l,a.dtype),i?In(l,[l.shape[1],l.shape[2],l.shape[3]]):l}});const Dn=rn({avgPool3d_:function(e,t,n,r,s,a="NDHWC"){const o=tn(e,"x","avgPool3d","float32");let i=o,u=!1;4===o.rank&&(u=!0,i=In(o,[1,o.shape[0],o.shape[1],o.shape[2],o.shape[3]])),de(5===i.rank,(()=>`Error in avgPool3d: x must be rank 5 but got rank ${i.rank}.`)),de("NDHWC"===a,(()=>`Error in avgPool3d: Only NDHWC is currently supported, but got dataFormat of ${a}`)),de("number"==typeof n&&n>0||Array.isArray(n)&&n[0]>0&&n[1]>0&&n[2]>0,(()=>`Error in avgPool3d: Stride must be > 0, but got '${n}'`)),En("avgPool3d",r,s);const p={x:i},l={filterSize:t,strides:n,pad:r,dimRoundingMode:s,dataFormat:a};let c=Qt.runKernel("AvgPool3D",p,l);return c=Nn(c,i.dtype),u?In(c,[c.shape[1],c.shape[2],c.shape[3],c.shape[4]]):c}});const An=rn({clone_:function(e){const t={x:tn(e,"x","clone","string_or_numeric")};return Qt.runKernel("Identity",t)}});const On=rn({concat_:function(e,t=0){de(e.length>=1,(()=>"Pass at least one tensor to concat"));const n=nn(e,"tensors","concat","string_or_numeric");if("complex64"===n[0].dtype&&n.forEach((e=>{if("complex64"!==e.dtype)throw new Error(`Cannot concatenate complex64 tensors with a tensor\n          with dtype ${e.dtype}. `)})),1===n.length)return An(n[0]);const r=n,s={axis:t};return Qt.runKernel("Concat",r,s)}});const Mn=rn({matMul_:function(e,t,n=!1,r=!1){let s=tn(e,"a","matMul"),a=tn(t,"b","matMul");[s,a]=Ut(s,a);const o={a:s,b:a},i={transposeA:n,transposeB:r};return Qt.runKernel("BatchMatMul",o,i)}});const Cn=rn({mul_:function(e,t){let n=tn(e,"a","mul"),r=tn(t,"b","mul");[n,r]=Ut(n,r);const s={a:n,b:r};return Qt.runKernel("Multiply",s)}});const Fn=rn({sigmoid_:function(e){const t={x:tn(e,"x","sigmoid","float32")};return Qt.runKernel("Sigmoid",t)}});const Rn=rn({slice_:function(e,t,n){const r=tn(e,"x","slice","string_or_numeric");if(0===r.rank)throw new Error("Slicing scalar is not possible");const s={x:r},a={begin:t,size:n};return Qt.runKernel("Slice",s,a)}});const zn=rn({tanh_:function(e){const t={x:tn(e,"x","tanh","float32")};return Qt.runKernel("Tanh",t)}});const Vn=rn({basicLSTMCell_:function(e,t,n,r,s,a){const o=tn(e,"forgetBias","basicLSTMCell"),i=tn(t,"lstmKernel","basicLSTMCell"),u=tn(n,"lstmBias","basicLSTMCell"),p=tn(r,"data","basicLSTMCell"),l=tn(s,"c","basicLSTMCell"),c=tn(a,"h","basicLSTMCell"),h=On([p,c],1),d=Mn(h,i),m=un(d,u),f=m.shape[0],y=m.shape[1]/4,g=[f,y],b=Rn(m,[0,0],g),N=Rn(m,[0,y],g),x=Rn(m,[0,2*y],g),w=Rn(m,[0,3*y],g),k=un(Cn(Fn(b),zn(N)),Cn(l,Fn(un(o,x))));return[k,Cn(zn(k),Fn(w))]}});const Ln=rn({batchToSpaceND_:function(e,t,n){const r=tn(e,"x","batchToSpaceND"),s=t.reduce(((e,t)=>e*t));de(r.rank>=1+t.length,(()=>`input rank is ${r.rank} but should be > than blockShape.length ${t.length}`)),de(n.length===t.length,(()=>`crops.length is ${n.length} but should be equal to blockShape.length  ${t.length}`)),de(r.shape[0]%s==0,(()=>`input tensor batch is ${r.shape[0]} but is not divisible by the product of the elements of blockShape ${t.join(" * ")} === ${s}`));const a={x:r},o={blockShape:t,crops:n};return Qt.runKernel("BatchToSpaceND",a,o)}});const Bn=rn({batchNorm_:function(e,t,n,r,s,a){null==a&&(a=.001);const o=tn(e,"x","batchNorm"),i=tn(t,"mean","batchNorm"),u=tn(n,"variance","batchNorm");let p,l;null!=s&&(p=tn(s,"scale","batchNorm")),null!=r&&(l=tn(r,"offset","batchNorm")),de(i.rank===u.rank,(()=>"Batch normalization gradient requires mean and variance to have equal ranks.")),de(null==l||i.rank===l.rank,(()=>"Batch normalization gradient requires mean and offset to have equal ranks.")),de(null==p||i.rank===p.rank,(()=>"Batch normalization gradient requires mean and scale to have equal ranks."));const c=function(e){let t;return t=0===e.rank||1===e.rank?In(e,[1,1,1,e.size]):2===e.rank?In(e,[1,1,e.shape[0],e.shape[1]]):3===e.rank?In(e,[1,e.shape[0],e.shape[1],e.shape[2]]):e,t}(o),h={x:c,scale:p,offset:l,mean:i,variance:u},d={varianceEpsilon:a},m=Qt.runKernel("FusedBatchNorm",h,d);return In(m,o.shape)}});const Pn=rn({batchNorm2d_:function(e,t,n,r,s,a){const o=tn(e,"x","batchNorm"),i=tn(t,"mean","batchNorm"),u=tn(n,"variance","batchNorm");let p,l;return null!=s&&(p=tn(s,"scale","batchNorm")),null!=r&&(l=tn(r,"offset","batchNorm")),de(2===o.rank,(()=>`Error in batchNorm2D: x must be rank 2 but got rank ${o.rank}.`)),de(2===i.rank||1===i.rank,(()=>`Error in batchNorm2D: mean must be rank 2 or rank 1 but got rank ${i.rank}.`)),de(2===u.rank||1===u.rank,(()=>`Error in batchNorm2D: variance must be rank 2 or rank 1 but got rank ${u.rank}.`)),null!=p&&de(2===p.rank||1===p.rank,(()=>`Error in batchNorm2D: scale must be rank 2 or rank 1 but got rank ${p.rank}.`)),null!=l&&de(2===l.rank||1===l.rank,(()=>`Error in batchNorm2D: offset must be rank 2 or rank 1 but got rank ${l.rank}.`)),Bn(o,i,u,l,p,a)}});const Kn=rn({batchNorm3d_:function(e,t,n,r,s,a){const o=tn(e,"x","batchNorm"),i=tn(t,"mean","batchNorm"),u=tn(n,"variance","batchNorm");let p,l;return null!=s&&(p=tn(s,"scale","batchNorm")),null!=r&&(l=tn(r,"offset","batchNorm")),de(3===o.rank,(()=>`Error in batchNorm3D: x must be rank 3 but got rank ${o.rank}.`)),de(3===i.rank||1===i.rank,(()=>`Error in batchNorm3D: mean must be rank 3 or rank 1 but got rank ${i.rank}.`)),de(3===u.rank||1===u.rank,(()=>`Error in batchNorm3D: variance must be rank 3 or rank 1 but got rank ${u.rank}.`)),null!=p&&de(3===p.rank||1===p.rank,(()=>`Error in batchNorm3D: scale must be rank 3 or rank 1 but got rank ${p.rank}.`)),null!=l&&de(3===l.rank||1===l.rank,(()=>`Error in batchNorm3D: offset must be rank 3 or rank 1 but got rank ${l.rank}.`)),Bn(o,i,u,l,p,a)}});const qn=rn({batchNorm4d_:function(e,t,n,r,s,a){const o=tn(e,"x","batchNorm"),i=tn(t,"mean","batchNorm"),u=tn(n,"variance","batchNorm");let p,l;return null!=s&&(p=tn(s,"scale","batchNorm")),null!=r&&(l=tn(r,"offset","batchNorm")),de(4===o.rank,(()=>`Error in batchNorm4D: x must be rank 4 but got rank ${o.rank}.`)),de(4===i.rank||1===i.rank,(()=>`Error in batchNorm4D: mean must be rank 4 or rank 1 but got rank ${i.rank}.`)),de(4===u.rank||1===u.rank,(()=>`Error in batchNorm4D: variance must be rank 4 or rank 1 but got rank ${u.rank}.`)),null!=p&&de(4===p.rank||1===p.rank,(()=>`Error in batchNorm4D: scale must be rank 4 or rank 1 but got rank ${p.rank}.`)),null!=l&&de(4===l.rank||1===l.rank,(()=>`Error in batchNorm4D: offset must be rank 4 or rank 1 but got rank ${l.rank}.`)),Bn(o,i,u,l,p,a)}});const Un=rn({bincount_:function(e,t,n){const r=tn(e,"x","bincount"),s=tn(t,"weights","bincount");de("int32"===r.dtype,(()=>`Error in bincount: input dtype must be int32, but got ${r.dtype}`)),de(n>=0,(()=>`size must be non-negative, but got ${n}.`)),de(s.size===r.size||0===s.size,(()=>`Error in bincount: weights must have the same size as input or0-length, but got input shape: ${r.shape}, weights shape: ${s.shape}.`));const a={x:r,weights:s},o={size:n};return Qt.runKernel("Bincount",a,o)}});const Wn=rn({broadcastArgs_:function(e,t){const n=tn(e,"s0","broadcastArgs","int32"),r=tn(t,"s1","broadcastArgs","int32");if(1!==n.rank)throw new Error(`broadcastArgs(): first input must be a vector (rank=1). Has rank ${n.rank}`);if(1!==r.rank)throw new Error(`broadcastArgs(): second input must be a vector (rank=1). Has rank ${r.rank}`);const s={s0:n,s1:r};return Qt.runKernel("BroadcastArgs",s)}});const jn=rn({broadcastTo_:function(e,t){let n=tn(e,"broadcastTo","x");const r=n.shape;if(Ae(t),t.length<n.rank)throw new Error(`broadcastTo(): shape.length=${t.length} < input.rank=${n.rank}.`);if(t.length>n.rank){const e=n.shape.slice();for(;e.length<t.length;)e.unshift(1);n=In(n,e)}const s=n.shape,a=Array.from(t);for(let e=t.length-1;e>=0;e--)if(s[e]===t[e])a[e]=1;else if(1!==n.shape[e])throw new Error(`broadcastTo(): [${r}] cannot be broadcast to [${t}].`);if(0===a.map(((e,t)=>e>1?t:-1)).filter((e=>e>=0)).length)return An(n);const o={x:n},i={reps:a};return Qt.runKernel("Tile",o,i)}});function Hn(e,t="float32",n){return t=t||"float32",Ae(e),new Ot(e,t,n)}const Gn=rn({ceil_:function(e){const t={x:tn(e,"x","ceil","float32")};return Qt.runKernel("Ceil",t)}});function Zn(e,t,n){Ae(e);const r={shape:e,value:t,dtype:n=n||ve(t)};return Qt.runKernel("Fill",{},r)}const Qn=rn({clipByValue_:function(e,t,n){const r=tn(e,"x","clipByValue");if(de(t<=n,(()=>`Error in clip: min (${t}) must be less than or equal to max (${n}).`)),t===n)return Zn(r.shape,t,r.dtype);const s={x:r},a={clipValueMin:t,clipValueMax:n};return Qt.runKernel("ClipByValue",s,a)}});const Yn=rn({complex_:function(e,t){const n=tn(e,"real","complex"),r=tn(t,"imag","complex");me(n.shape,r.shape,`real and imag shapes, ${n.shape} and ${r.shape}, must match in call to tf.complex().`);const s={real:n,imag:r};return Qt.runKernel("Complex",s)}});const Xn=rn({concat1d_:function(e){return On(e,0)}});const Jn=rn({concat2d_:function(e,t){return On(e,t)}});const er=rn({concat3d_:function(e,t){return On(e,t)}});const tr=rn({concat4d_:function(e,t){return On(e,t)}});const nr=rn({conv2d_:function(e,t,n,r,s="NHWC",a=[1,1],o){const i=tn(e,"x","conv2d","float32"),u=tn(t,"filter","conv2d","float32");let p=i,l=!1;3===i.rank&&(l=!0,p=In(i,[1,i.shape[0],i.shape[1],i.shape[2]])),de(4===p.rank,(()=>`Error in conv2d: input must be rank 4, but got rank ${p.rank}.`)),de(4===u.rank,(()=>`Error in conv2d: filter must be rank 4, but got rank ${u.rank}.`)),En("conv2d",r,o);const c="NHWC"===s?p.shape[3]:p.shape[1];de(c===u.shape[2],(()=>`Error in conv2d: depth of input (${c}) must match input depth for filter ${u.shape[2]}.`)),de(_n(n,a),(()=>`Error in conv2D: Either strides or dilations must be 1. Got strides ${n} and dilations '${a}'`)),de(Sn(a),(()=>"Error in conv2D: Dilated rates should be larger than 0.")),de(Sn(n),(()=>"Error in conv2D: Strides should be larger than 0."));const h={x:p,filter:u},d={strides:n,pad:r,dataFormat:s,dilations:a,dimRoundingMode:o},m=Qt.runKernel("Conv2D",h,d);return l?In(m,[m.shape[1],m.shape[2],m.shape[3]]):m}});const rr=rn({conv1d_:function(e,t,n,r,s="NWC",a=1,o){const i=tn(e,"x","conv1d"),u=tn(t,"filter","conv1d");let p=i,l=!1;2===i.rank&&(l=!0,p=In(i,[1,i.shape[0],i.shape[1]])),de(3===p.rank,(()=>`Error in conv1d: input must be rank 3, but got rank ${p.rank}.`)),de(3===u.rank,(()=>`Error in conv1d: filter must be rank 3, but got rank ${u.rank}.`)),En("conv1d",r,o),de(p.shape[2]===u.shape[1],(()=>`Error in conv1d: depth of input (${p.shape[2]}) must match input depth for filter ${u.shape[1]}.`)),de(_n(n,a),(()=>`Error in conv1D: Either stride or dilation must be 1. Got stride ${n} and dilation '${a}'`)),de(Sn(a),(()=>"Error in conv1D: Dilated rates should be larger than 0.")),de(Sn(n),(()=>"Error in conv1D: Stride should be larger than 0.")),de("NWC"===s,(()=>`Error in conv1d: got dataFormat of ${s} but only NWC is currently supported.`));const c=In(u,[1,u.shape[0],u.shape[1],u.shape[2]]),h=In(p,[p.shape[0],1,p.shape[1],p.shape[2]]),d=nr(h,c,[1,n],r,"NHWC",[1,a],o);return In(d,l?[d.shape[2],d.shape[3]]:[d.shape[0],d.shape[2],d.shape[3]])}});const sr=rn({conv2DBackpropInput_:function(e,t,n,r,s,a="NHWC",o){de(e.length===t.rank,(()=>`Length of inShape (${e.length}) and rank of dy (${t.rank}) must match`));let i=e,u=t,p=!1;3===t.rank&&(p=!0,u=In(t,[1,t.shape[0],t.shape[1],t.shape[2]]),i=[1,e[0],e[1],e[2]]),de(4===i.length,(()=>`Error in conv2dDerInput: inShape must be length 4, but got length ${i.length}.`)),de(4===u.rank,(()=>`Error in conv2dDerInput: dy must be rank 4, but got rank ${u.rank}`)),de(4===n.rank,(()=>`Error in conv2dDerInput: filter must be rank 4, but got rank ${n.rank}`));const l="NHWC"===a?i[3]:i[1],c="NHWC"===a?u.shape[3]:u.shape[1];de(l===n.shape[2],(()=>`Error in conv2dDerInput: depth of input (${l}) must match input depth for filter ${n.shape[2]}.`)),de(c===n.shape[3],(()=>`Error in conv2dDerInput: depth of output (${c}) must match output depth for filter ${n.shape[3]}.`)),En("conv2dDerInput",s,o);const h={dy:u,filter:n},d={strides:r,pad:s,dataFormat:a,dimRoundingMode:o,inputShape:i},m=Qt.runKernel("Conv2DBackpropInput",h,d);return p?In(m,[m.shape[1],m.shape[2],m.shape[3]]):m}});const ar=rn({conv2dTranspose_:function(e,t,n,r,s,a){const o=tn(e,"x","conv2dTranspose"),i=tn(t,"filter","conv2dTranspose");return sr(n,o,i,r,s,"NHWC",a)}});const or=rn({conv3d_:function(e,t,n,r,s="NDHWC",a=[1,1,1]){const o=tn(e,"x","conv3d"),i=tn(t,"filter","conv3d");let u=o,p=!1;4===o.rank&&(p=!0,u=In(o,[1,o.shape[0],o.shape[1],o.shape[2],o.shape[3]])),de(5===u.rank,(()=>`Error in conv3d: input must be rank 5, but got rank ${u.rank}.`)),de(5===i.rank,(()=>`Error in conv3d: filter must be rank 5, but got rank ${i.rank}.`)),de(u.shape[4]===i.shape[3],(()=>`Error in conv3d: depth of input (${u.shape[4]}) must match input depth for filter ${i.shape[3]}.`)),de(_n(n,a),(()=>`Error in conv3D: Either strides or dilations must be 1. Got strides ${n} and dilations '${a}'`)),de("NDHWC"===s,(()=>`Error in conv3d: got dataFormat of ${s} but only NDHWC is currently supported.`)),de(Sn(a),(()=>"Error in conv3D: Dilated rates should be larger than 0.")),de(Sn(n),(()=>"Error in conv3D: Strides should be larger than 0."));const l={x:u,filter:i},c={strides:n,pad:r,dataFormat:s,dilations:a},h=Qt.runKernel("Conv3D",l,c);return p?In(h,[h.shape[1],h.shape[2],h.shape[3],h.shape[4]]):h}});const ir=rn({conv3DBackpropInput_:function(e,t,n,r,s){de(e.length===t.rank,(()=>`Length of inShape (${e.length}) and rank of dy (${t.rank}) must match`));let a=e,o=t,i=!1;4===t.rank&&(i=!0,o=In(t,[1,t.shape[0],t.shape[1],t.shape[2],t.shape[3]]),a=[1,e[0],e[1],e[2],e[3]]);const u=a[4],p=o.shape[4];de(5===a.length,(()=>`Error in conv3dDerInput: inShape must be length 5, but got length ${a.length}.`)),de(5===o.rank,(()=>`Error in conv3dDerInput: dy must be rank 5, but got rank ${o.rank}`)),de(5===n.rank,(()=>`Error in conv3dDerInput: filter must be rank 5, but got rank ${n.rank}`)),de(u===n.shape[3],(()=>`Error in conv3dDerInput: depth of input (${u}) must match input depth for filter ${n.shape[3]}.`)),de(p===n.shape[4],(()=>`Error in conv3dDerInput: depth of output (${p}) must match output depth for filter ${n.shape[4]}.`));const l={dy:o,filter:n},c={pad:s,strides:r,inputShape:a},h=Qt.runKernel("Conv3DBackpropInputV2",l,c);return i?In(h,[h.shape[1],h.shape[2],h.shape[3],h.shape[4]]):h}});const ur=rn({conv3dTranspose_:function(e,t,n,r,s){const a=tn(e,"x","conv3dTranspose"),o=tn(t,"filter","conv3dTranspose");return ir(n,a,o,r,s)}});const pr=rn({cos_:function(e){const t={x:tn(e,"x","cos","float32")};return Qt.runKernel("Cos",t)}});const lr=rn({cosh_:function(e){const t={x:tn(e,"x","cosh","float32")};return Qt.runKernel("Cosh",t)}});const cr=rn({cumprod_:function(e,t=0,n=!1,r=!1){const s={x:tn(e,"x","cumprod")},a={axis:t,exclusive:n,reverse:r};return Qt.runKernel("Cumprod",s,a)}});const hr=rn({cumsum_:function(e,t=0,n=!1,r=!1){const s={x:tn(e,"x","cumsum")},a={axis:t,exclusive:n,reverse:r};return Qt.runKernel("Cumsum",s,a)}});const dr=rn({denseBincount_:function(e,t,n,r=!1){const s=tn(e,"x","denseBincount"),a=tn(t,"weights","denseBincount");de("int32"===s.dtype,(()=>`Error in denseBincount: input dtype must be int32, but got ${s.dtype}`)),de(s.rank<=2,(()=>`Error in denseBincount: input must be at most rank 2, but got rank ${s.rank}.`)),de(n>=0,(()=>`size must be non-negative, but got ${n}.`)),de(a.size===s.size||0===a.size,(()=>`Error in denseBincount: weights must have the same shape as x or 0-length, but got x shape: ${s.shape}, weights shape: ${a.shape}.`));const o={x:s,weights:a},i={size:n,binaryOutput:r};return Qt.runKernel("DenseBincount",o,i)}});const mr=rn({depthToSpace_:function(e,t,n="NHWC"){const r=tn(e,"x","depthToSpace","float32"),s="NHWC"===n?r.shape[1]:r.shape[2],a="NHWC"===n?r.shape[2]:r.shape[3],o="NHWC"===n?r.shape[3]:r.shape[1];de(t>1,(()=>`blockSize should be > 1 for depthToSpace, but was: ${t}`)),de(s*t>=0,(()=>`Negative dimension size caused by overflow when multiplying\n    ${s} and ${t}  for depthToSpace with input shape\n    ${r.shape}`)),de(a*t>=0,(()=>`Negative dimension size caused by overflow when multiplying\n    ${a} and ${t} for depthToSpace with input shape\n        ${r.shape}`)),de(o%(t*t)==0,(()=>`Dimension size must be evenly divisible by ${t*t} but is ${o} for depthToSpace with input shape ${r.shape}`));const i={x:r},u={blockSize:t,dataFormat:n};return Qt.runKernel("DepthToSpace",i,u)}});const fr=rn({depthwiseConv2d_:function(e,t,n,r,s="NHWC",a=[1,1],o){const i=tn(e,"x","depthwiseConv2d","float32"),u=tn(t,"filter","depthwiseConv2d","float32");let p=i,l=!1;3===i.rank&&(l=!0,p=In(i,[1,i.shape[0],i.shape[1],i.shape[2]])),de(4===p.rank,(()=>`Error in depthwiseConv2d: input must be rank 4, but got rank ${p.rank}.`)),de(4===u.rank,(()=>`Error in depthwiseConv2d: filter must be rank 4, but got rank ${u.rank}.`));const c="NHWC"===s?p.shape[3]:p.shape[1];de(c===u.shape[2],(()=>`Error in depthwiseConv2d: number of input channels (${c}) must match the inChannels dimension in filter ${u.shape[2]}.`)),En("depthwiseConv2d",r,o);const h={x:p,filter:u},d={strides:n,pad:r,dataFormat:s,dilations:a,dimRoundingMode:o},m=Qt.runKernel("DepthwiseConv2dNative",h,d);return l?In(m,[m.shape[1],m.shape[2],m.shape[3]]):m}});const yr=rn({diag_:function(e){const t={x:tn(e,"x","diag")};return Qt.runKernel("Diag",t)}});const gr=rn({dilation2d_:function(e,t,n,r,s=[1,1],a="NHWC"){const o=tn(e,"x","dilation2d"),i=tn(t,"filter","dilation2d");de(3===o.rank||4===o.rank,(()=>`Error in dilation2d: input must be rank 3 or 4, but got rank ${o.rank}.`)),de(3===i.rank,(()=>`Error in dilation2d: filter must be rank 3, but got rank ${i.rank}.`)),de("NHWC"===a,(()=>`Error in dilation2d: Only NHWC is currently supported, but got dataFormat of ${a}`));let u=o,p=!1;3===o.rank&&(u=In(o,[1,o.shape[0],o.shape[1],o.shape[2]]),p=!0),de(u.shape[3]===i.shape[2],(()=>`Error in dilation2d:  input and filter must have the same depth: ${u.shape[3]} vs ${i.shape[2]}`));const l={x:u,filter:i},c={strides:n,pad:r,dilations:s},h=Qt.runKernel("Dilation2D",l,c);return p?In(h,[h.shape[1],h.shape[2],h.shape[3]]):h}});const br=rn({floorDiv_:function(e,t){let n=tn(e,"a","floorDiv"),r=tn(t,"b","floorDiv");[n,r]=Ut(n,r);const s={a:n,b:r};return Qt.runKernel("FloorDiv",s)}});const Nr=rn({div_:function(e,t){let n=tn(e,"a","div"),r=tn(t,"b","div");if([n,r]=Ut(n,r),"int32"===n.dtype&&"int32"===r.dtype)return br(n,r);const s={a:n,b:r};return Qt.runKernel("RealDiv",s,{})}});function xr(e,t){const n=Math.max(e.length,t.length),r=new Array(n);for(let s=0;s<n;s++){let a=e[e.length-s-1];null==a&&(a=1);let o=t[t.length-s-1];if(null==o&&(o=1),1===a)r[n-s-1]=o;else if(1===o)r[n-s-1]=a;else{if(a!==o){throw Error(`Operands could not be broadcast together with shapes ${e} and ${t}.`)}r[n-s-1]=a}}return r}const wr=rn({equal_:function(e,t){let n=tn(e,"a","equal","string_or_numeric"),r=tn(t,"b","equal","string_or_numeric");[n,r]=Ut(n,r),xr(n.shape,r.shape);const s={a:n,b:r};return Qt.runKernel("Equal",s)}});const kr=rn({where_:function(e,t,n){const r=tn(t,"a","where"),s=tn(n,"b","where"),a=tn(e,"condition","where","bool"),o=xr(xr(a.shape,r.shape),s.shape),i={condition:jn(a,o),t:jn(r,o),e:jn(s,o)};return Qt.runKernel("Select",i)}});const Tr=rn({zerosLike_:function(e){const t={x:tn(e,"x","zerosLike")};return Qt.runKernel("ZerosLike",t)}});const vr=rn({divNoNan_:function(e,t){let n=tn(e,"a","div"),r=tn(t,"b","div");[n,r]=Ut(n,r);const s=Nr(n,r),a=Tr(s),o=wr(r,a);return kr(o,a,s)}});const _r=rn({dot_:function(e,t){const n=tn(e,"t1","dot"),r=tn(t,"t2","dot");de(!(1!==n.rank&&2!==n.rank||1!==r.rank&&2!==r.rank),(()=>`Error in dot: inputs must all be rank 1 or 2, but got ranks ${n.rank} and ${r.rank}.`));const s=1===n.rank?n.size:n.shape[1],a=1===r.rank?r.size:r.shape[0];if(de(s===a,(()=>`Error in dot: inner dimensions of inputs must match, but got ${s} and ${a}.`)),1===n.rank&&1===r.rank){const e=In(n,[1,-1]),t=In(r,[-1,1]),s=Mn(e,t);return In(s,[])}if(1===n.rank&&2===r.rank){const e=In(n,[1,-1]),t=In(r,[r.shape[0],r.shape[1]]),s=Mn(e,t);return In(s,[s.size])}if(2===n.rank&&1===r.rank){const e=In(r,[-1,1]),t=Mn(n,e);return In(t,[t.size])}{const e=In(r,[r.shape[0],r.shape[1]]);return Mn(n,e)}}});const Sr=rn({einsum_:function(e,...t){const n=t.map(((e,t)=>tn(e,`tensors${t}`,"einsum"))),r={equation:e};return Qt.runKernel("Einsum",n,r)}});const Er=rn({elu_:function(e){const t={x:tn(e,"x","elu","float32")};return Qt.runKernel("Elu",t)}});const Ir=rn({erf_:function(e){let t=tn(e,"x","erf");de("int32"===t.dtype||"float32"===t.dtype,(()=>"Input dtype must be `int32` or `float32`.")),"int32"===t.dtype&&(t=Nn(t,"float32"));const n={x:t};return Qt.runKernel("Erf",n)}});function $r(e,t){return function(e,t,n){const r=e.length+t.length,s=[];let a=0,o=0;for(let i=0;i<r;i++)-1===n.indexOf(i)?s.push(e[a++]):s.push(t[o++]);return s}(e,t.map((e=>1)),t)}const Dr=rn({max_:function(e,t=null,n=!1){const r={x:tn(e,"x","max")},s={reductionIndices:t,keepDims:n};return Qt.runKernel("Max",r,s)}});const Ar=rn({min_:function(e,t=null,n=!1){const r={x:tn(e,"x","min")},s={axis:t,keepDims:n};return Qt.runKernel("Min",r,s)}});const Or=rn({pow_:function(e,t){let n=tn(e,"base","pow"),r=tn(t,"exp","pow");[n,r]=Ut(n,r);const s={a:n,b:r};return Qt.runKernel("Pow",s)}});function Mr(e,t,n,r){if(null==r)r=ve(e);else if("complex64"===r)throw new Error("Cannot construct a complex64 tensor directly. Please use tf.complex(real, imag).");if(qt(e)||Kt(e)){if("float32"!==r&&"int32"!==r)throw new Error(`Creating tensor from GPU data only supports 'float32'|'int32' dtype, while the dtype is ${r}.`);return Qt.backend.createTensorFromGPUData(e,t||n,r)}if(!kt(e)&&!Array.isArray(e)&&"number"!=typeof e&&"boolean"!=typeof e&&"string"!=typeof e)throw new Error("values passed to tensor(values) must be a number/boolean/string or an array of numbers/booleans/strings, or a TypedArray");if(null!=t){Ae(t);const e=ye(t),r=ye(n);de(e===r,(()=>`Based on the provided shape, [${t}], the tensor should have ${e} values but has ${r}`));for(let e=0;e<n.length;++e){const r=n[e],s=e!==n.length-1||r!==ye(t.slice(e));de(n[e]===t[e]||!s,(()=>`Error creating a new Tensor. Inferred shape (${n}) does not match the provided shape (${t}). `))}}return kt(e)||Array.isArray(e)||(e=[e]),t=t||n,e="string"!==r?Nt(e,r):Tt(e,[],!0),Qt.makeTensor(e,t,r)}function Cr(e,t){if((kt(e)&&"string"!==t||Array.isArray(e))&&"complex64"!==t)throw new Error("Error creating a new Scalar: value must be a primitive (number|boolean|string)");if("string"===t&&kt(e)&&!(e instanceof Uint8Array))throw new Error("When making a scalar from encoded string, the value must be `Uint8Array`.");return Mr(e,[],[],t)}const Fr=rn({sqrt_:function(e){const t={x:tn(e,"x","sqrt","float32")};return Qt.runKernel("Sqrt",t)}});const Rr=rn({square_:function(e){const t=tn(e,"x","square");return Qt.runKernel("Square",{x:t},{})}});const zr=rn({sum_:function(e,t=null,n=!1){let r=tn(e,"x","sum");"bool"===r.dtype&&(r=Nn(r,"int32"));const s={x:r},a={axis:t,keepDims:n};return Qt.runKernel("Sum",s,a)}});function Vr(e,t,n=null){if(0===e.rank)return sn(e);if(1!==e.rank&&null===n)return Vr(In(e,[-1]),t,n);if(1===e.rank||"number"==typeof n||Array.isArray(n)&&1===n.length){if(1===t)return zr(sn(e),n);if(t===1/0)return Dr(sn(e),n);if(t===-1/0)return Ar(sn(e),n);if("euclidean"===t||2===t)return Fr(zr(Or(sn(e),Cr(2,"int32")),n));throw new Error(`Error in norm: invalid ord value: ${t}`)}if(Array.isArray(n)&&2===n.length){if(1===t)return Dr(zr(sn(e),n[0]),n[1]-1);if(t===1/0)return Dr(zr(sn(e),n[1]),n[0]);if(t===-1/0)return Ar(zr(sn(e),n[1]),n[0]);if("fro"===t||"euclidean"===t)return Fr(zr(Rr(e),n));throw new Error(`Error in norm: invalid ord value: ${t}`)}throw new Error(`Error in norm: invalid axis: ${n}`)}const Lr=rn({norm_:function(e,t="euclidean",n=null,r=!1){const s=Vr(e=tn(e,"x","norm"),t,n);let a=s.shape;if(r){const t=xe(n,e.shape);a=$r(s.shape,t)}return In(s,a)}});const Br=rn({euclideanNorm_:function(e,t=null,n=!1){return Lr(e,"euclidean",t,n)}});const Pr=rn({exp_:function(e){const t={x:tn(e,"x","exp")};return Qt.runKernel("Exp",t)}});const Kr=rn({expandDims_:function(e,t=0){const n=tn(e,"x","expandDims","string_or_numeric");de(t<=n.rank,(()=>"Axis must be <= rank of the tensor"));const r={input:n},s={dim:t};return Qt.runKernel("ExpandDims",r,s)}});const qr=rn({expm1_:function(e){const t={x:tn(e,"x","expm1")};return Qt.runKernel("Expm1",t)}});const Ur=rn({tile_:function(e,t){const n=tn(e,"x","tile","string_or_numeric");de(n.rank===t.length,(()=>`Error in transpose: rank of input ${n.rank} must match length of reps ${t}.`));const r={x:n},s={reps:t};return Qt.runKernel("Tile",r,s)}});const Wr=rn({eye_:function(e,t,n,r="float32"){null==t&&(t=e);const s=Hn([e,t],r),a=e<=t?e:t;for(let e=0;e<a;++e)s.set(1,e,e);const o=In(s.toTensor(),[e,t]);if(null==n)return o;if(1===n.length)return Ur(Kr(o,0),[n[0],1,1]);if(2===n.length)return Ur(Kr(Kr(o,0),0),[n[0],n[1],1,1]);if(3===n.length)return Ur(Kr(Kr(Kr(o,0),0),0),[n[0],n[1],n[2],1,1]);throw new Error(`eye() currently supports only 1D and 2D batchShapes, but received ${n.length}D.`)}});const jr=rn({floor_:function(e){const t={x:tn(e,"x","floor","float32")};return Qt.runKernel("Floor",t)}});const Hr=rn({gather_:function(e,t,n=0,r=0){const s={x:tn(e,"x","gather"),indices:tn(t,"indices","gather","int32")},a={axis:n,batchDims:r};return Qt.runKernel("GatherV2",s,a)}});const Gr=rn({greater_:function(e,t){let n=tn(e,"a","greater","string_or_numeric"),r=tn(t,"b","greater","string_or_numeric");[n,r]=Ut(n,r),xr(n.shape,r.shape);const s={a:n,b:r};return Qt.runKernel("Greater",s)}});const Zr=rn({greaterEqual_:function(e,t){let n=tn(e,"a","greaterEqual","string_or_numeric"),r=tn(t,"b","greaterEqual","string_or_numeric");[n,r]=Ut(n,r),xr(n.shape,r.shape);const s={a:n,b:r};return Qt.runKernel("GreaterEqual",s)}});const Qr=rn({imag_:function(e){const t={input:tn(e,"input","imag")};return Qt.runKernel("Imag",t)}});const Yr=rn({isFinite_:function(e){const t={x:tn(e,"x","isFinite")};return Qt.runKernel("IsFinite",t)}});const Xr=rn({isInf_:function(e){const t={x:tn(e,"x","isInf")};return Qt.runKernel("IsInf",t)}});const Jr=rn({isNaN_:function(e){const t={x:tn(e,"x","isNaN")};return Qt.runKernel("IsNan",t)}});const es=rn({leakyRelu_:function(e,t=.2){const n={x:tn(e,"x","leakyRelu")},r={alpha:t};return Qt.runKernel("LeakyRelu",n,r)}});const ts=rn({less_:function(e,t){let n=tn(e,"a","less","string_or_numeric"),r=tn(t,"b","less","string_or_numeric");[n,r]=Ut(n,r),xr(n.shape,r.shape);const s={a:n,b:r};return Qt.runKernel("Less",s)}});const ns=rn({lessEqual_:function(e,t){let n=tn(e,"a","lessEqual","string_or_numeric"),r=tn(t,"b","lessEqual","string_or_numeric");[n,r]=Ut(n,r),xr(n.shape,r.shape);const s={a:n,b:r};return Qt.runKernel("LessEqual",s)}});const rs=rn({localResponseNormalization_:function(e,t=5,n=1,r=1,s=.5){const a=tn(e,"x","localResponseNormalization");de(4===a.rank||3===a.rank,(()=>`Error in localResponseNormalization: x must be rank 3 or 4 but got\n               rank ${a.rank}.`)),de(be(t),(()=>`Error in localResponseNormalization: depthRadius must be an integer but got depthRadius ${t}.`));let o=a,i=!1;3===a.rank&&(i=!0,o=In(a,[1,a.shape[0],a.shape[1],a.shape[2]]));const u={x:o},p={depthRadius:t,bias:n,alpha:r,beta:s},l=Qt.runKernel("LRN",u,p);return i?In(l,[l.shape[1],l.shape[2],l.shape[3]]):l}});const ss=rn({log_:function(e){const t={x:tn(e,"x","log","float32")};return Qt.runKernel("Log",t)}});const as=rn({log1p_:function(e){const t={x:tn(e,"x","log1p")};return Qt.runKernel("Log1p",t)}});function os(e){return Qt.customGrad(e)}const is=rn({neg_:function(e){const t={x:tn(e,"x","neg")};return Qt.runKernel("Neg",t)}});const us=rn({softplus_:function(e){const t={x:tn(e,"x","softplus")};return Qt.runKernel("Softplus",t)}});const ps=rn({logSigmoid_:function(e){const t=tn(e,"x","logSigmoid"),n=os((e=>({value:is(us(is(e))),gradFunc:t=>Cn(t,Fn(is(e)))})));return n(t)}});const ls=rn({sub_:function(e,t){let n=tn(e,"a","sub"),r=tn(t,"b","sub");[n,r]=Ut(n,r);const s={a:n,b:r};return Qt.runKernel("Sub",s)}});const cs=rn({logSoftmax_:function(e,t=-1){const n=tn(e,"logits","logSoftmax");if(-1===t&&(t=n.rank-1),t!==n.rank-1)throw Error(`Log Softmax along a non-last dimension is not yet supported. Logits was rank ${n.rank} and axis was ${t}`);const r=os(((e,n)=>{const r=Dr(e,t,!0),s=ls(e,r),a=ls(Nn(s,"float32"),ss(zr(Pr(s),t,!0)));n([a]);return{value:a,gradFunc:(e,n)=>{const[r]=n,s=Pr(r);return ls(e,Cn(zr(e,t,!0),s))}}}));return r(n)}});const hs=rn({logSumExp_:function(e,t=null,n=!1){const r=tn(e,"x","logSumExp"),s=xe(t,r.shape),a=Dr(r,s,!0),o=ls(r,a),i=Pr(o),u=zr(i,s),p=ss(u),l=un(In(a,p.shape),p);if(n){const e=$r(l.shape,s);return In(l,e)}return l}});const ds=rn({logicalAnd_:function(e,t){const n=tn(e,"a","logicalAnd","bool"),r=tn(t,"b","logicalAnd","bool");xr(n.shape,r.shape);const s={a:n,b:r};return Qt.runKernel("LogicalAnd",s)}});const ms=rn({logicalNot_:function(e){const t={x:tn(e,"x","logicalNot","bool")};return Qt.runKernel("LogicalNot",t)}});const fs=rn({logicalOr_:function(e,t){const n=tn(e,"a","logicalOr","bool"),r=tn(t,"b","logicalOr","bool");xr(n.shape,r.shape);const s={a:n,b:r};return Qt.runKernel("LogicalOr",s)}});const ys=rn({logicalXor_:function(e,t){const n=tn(e,"a","logicalXor","bool"),r=tn(t,"b","logicalXor","bool");return xr(n.shape,r.shape),ds(fs(e,t),ms(ds(e,t)))}});const gs=rn({searchSorted_:function(e,t,n="left"){const r=tn(e,"sortedSequence","searchSorted"),s=tn(t,"values","searchSorted"),a=r.shape[r.shape.length-1],o=s.shape[s.shape.length-1],i=In(r,[-1,a]),u=In(s,[-1,o]);if(i.rank<2)throw new Error("Sorted input argument must be at least 2-dimensional");if(i.shape[0]!==u.shape[0])throw new Error("Leading dimension of 'sortedSequence' and 'values' must match.");if(ye(u.shape)>=2147483648)throw new Error("values tensor size must less than 2147483648");if(i.shape[1]>=2147483648)throw new Error(`trailing dim_size must less than 2147483648 for int32 output type, was ${i.shape[1]}`);const p={sortedSequence:i,values:u},l={side:n};return Qt.runKernel("SearchSorted",p,l)}});const bs=rn({maxPool_:function(e,t,n,r,s){const a=tn(e,"x","maxPool");let o=a,i=!1;3===a.rank&&(i=!0,o=In(a,[1,a.shape[0],a.shape[1],a.shape[2]])),de(4===o.rank,(()=>`Error in maxPool: input must be rank 4 but got rank ${o.rank}.`)),de(_n(n,1),(()=>`Error in maxPool: Either strides or dilations must be 1. Got strides ${n} and dilations '1'`)),En("maxPool",r,s);const u={x:o},p={filterSize:t,strides:n,pad:r,dimRoundingMode:s},l=Qt.runKernel("MaxPool",u,p);return i?In(l,[l.shape[1],l.shape[2],l.shape[3]]):l}});const Ns=rn({maxPool3d_:function(e,t=[1,1,1],n,r,s,a="NDHWC"){const o=tn(e,"x","maxPool3d");let i=o,u=!1;4===o.rank&&(u=!0,i=In(o,[1,o.shape[0],o.shape[1],o.shape[2],o.shape[3]])),de(5===i.rank,(()=>`Error in maxPool3d: x must be rank 5 but got rank ${i.rank}.`)),de("NDHWC"===a,(()=>`Error in maxPool3d: Only NDHWC is currently supported, but got dataFormat of ${a}`)),En("maxPool3d",r,s);const p={x:i},l={filterSize:t,strides:n,pad:r,dimRoundingMode:s,dataFormat:a},c=Qt.runKernel("MaxPool3D",p,l);return u?In(c,[c.shape[1],c.shape[2],c.shape[3],c.shape[4]]):c}});const xs=rn({maxPoolWithArgmax_:function(e,t,n,r,s=!1){const a={x:tn(e,"x","maxPoolWithArgmax")},o={filterSize:t,strides:n,pad:r,includeBatchInIndex:s},i=Qt.runKernel("MaxPoolWithArgmax",a,o);return{result:i[0],indexes:i[1]}}});const ws=rn({maximum_:function(e,t){let n=tn(e,"a","maximum"),r=tn(t,"b","maximum");[n,r]=Ut(n,r),"bool"===n.dtype&&(n=Nn(n,"int32"),r=Nn(r,"int32")),xr(n.shape,r.shape);const s={a:n,b:r};return Qt.runKernel("Maximum",s)}});const ks=rn({mean_:function(e,t=null,n=!1){const r={x:tn(e,"x","mean")},s={axis:t,keepDims:n};return Qt.runKernel("Mean",r,s)}});function Ts(e,t="float32"){if(Ae(e),"complex64"===t){const t=Ts(e,"float32"),n=Ts(e,"float32");return Yn(t,n)}const n=De(ye(e),t);return Qt.makeTensor(n,e,t)}function vs(e,t="float32"){if(Ae(e),"complex64"===t){const t=vs(e,"float32"),n=Ts(e,"float32");return Yn(t,n)}const n=$e(ye(e),t);return Qt.makeTensor(n,e,t)}const _s=rn({minimum_:function(e,t){let n=tn(e,"a","minimum"),r=tn(t,"b","minimum");[n,r]=Ut(n,r),"bool"===n.dtype&&(n=Nn(n,"int32"),r=Nn(r,"int32")),xr(n.shape,r.shape);const s={a:n,b:r};return Qt.runKernel("Minimum",s)}});const Ss=rn({mirrorPad_:function(e,t,n){de("reflect"===n||"symmetric"===n,(()=>`Invalid mode. Mode must be either reflect or symmetric. Got ${n}.`));const r=tn(e,"x","mirrorPad");if(0===r.rank)throw new Error("mirrorPad(scalar) is not defined. Pass non-scalar to mirrorPad");de(t.length===r.rank,(()=>`Padding doesn't match input. Must be ${r.rank}. Got ${t.length}.`));const s="reflect"===n?1:0;for(let e=0;e<r.rank;e++)de(2===t[e].length,(()=>"Invalid number of paddings. Must be length of 2 each.")),de(t[e][0]>=0&&t[e][0]<=r.shape[e]-s&&t[e][1]>=0&&t[e][1]<=r.shape[e]-s,(()=>`Padding in dimension ${e} cannot be greater than or equal to ${r.shape[e]-s} or less than 0 for input of shape ${r.shape}`));const a={paddings:t,mode:n},o={x:r};return Qt.runKernel("MirrorPad",o,a)}});const Es=rn({mod_:function(e,t){let n=tn(e,"a","mod"),r=tn(t,"b","mod");[n,r]=Ut(n,r);const s={a:n,b:r};return Qt.runKernel("Mod",s)}});const Is=rn({moments_:function(e,t=null,n=!1){const r=xe(t,(e=tn(e,"x","moments")).shape),s=ks(e,r,n);let a=s.shape;n||(a=$r(s.shape,r));const o=Rr(ls(Nn(e,"float32"),In(s,a)));return{mean:s,variance:ks(o,r,n)}}});const $s=rn({multiRNNCell_:function(e,t,n,r){const s=tn(t,"data","multiRNNCell"),a=nn(n,"c","multiRNNCell"),o=nn(r,"h","multiRNNCell");let i=s;const u=[];for(let t=0;t<e.length;t++){const n=e[t](i,a[t],o[t]);u.push(n[0]),u.push(n[1]),i=n[1]}const p=[],l=[];for(let e=0;e<u.length;e+=2)p.push(u[e]),l.push(u[e+1]);return[p,l]}});const Ds=rn({multinomial_:function(e,t,n,r=!1){const s=tn(e,"logits","multinomial"),a=s.size,o=s.rank;if(a<2)throw new Error(`Error in multinomial: you need at least 2 outcomes, but got ${a}.`);if(o>2)throw new Error(`Rank of probabilities must be 1 or 2, but is ${o}`);n=n||Math.random();const i={logits:1===o?In(s,[1,-1]):s},u={numSamples:t,seed:n,normalized:r},p=Qt.runKernel("Multinomial",i,u);return 1===o?In(p,[p.size]):p}});const As=rn({notEqual_:function(e,t){let n=tn(e,"a","notEqual","string_or_numeric"),r=tn(t,"b","notEqual","string_or_numeric");[n,r]=Ut(n,r),xr(n.shape,r.shape);const s={a:n,b:r};return Qt.runKernel("NotEqual",s)}});const Os=rn({oneHot_:function(e,t,n=1,r=0,s="int32"){if(t<2)throw new Error(`Error in oneHot: depth must be >=2, but it is ${t}`);const a={indices:tn(e,"indices","oneHot","int32")},o={dtype:s,depth:t,onValue:n,offValue:r};return Qt.runKernel("OneHot",a,o)}});const Ms=rn({onesLike_:function(e){const t={x:tn(e,"x","onesLike")};return Qt.runKernel("OnesLike",t)}});const Cs=rn({outerProduct_:function(e,t){const n=tn(e,"v1","outerProduct"),r=tn(t,"v2","outerProduct");de(1===n.rank&&1===r.rank,(()=>`Error in outerProduct: inputs must be rank 1, but got ranks ${n.rank} and ${r.rank}.`));const s=In(n,[-1,1]),a=In(r,[1,-1]);return Mn(s,a)}});const Fs=rn({pad_:function(e,t,n=0){const r=tn(e,"x","pad");if(0===r.rank)throw new Error("pad(scalar) is not defined. Pass non-scalar to pad");const s={paddings:t,constantValue:n},a={x:r};return Qt.runKernel("PadV2",a,s)}});const Rs=rn({pad1d_:function(e,t,n=0){return de(2===t.length,(()=>"Invalid number of paddings. Must be length of 2.")),Fs(e,[t],n)}});const zs=rn({pad2d_:function(e,t,n=0){return de(2===t.length&&2===t[0].length&&2===t[1].length,(()=>"Invalid number of paddings. Must be length of 2 each.")),Fs(e,t,n)}});const Vs=rn({pad3d_:function(e,t,n=0){return de(3===t.length&&2===t[0].length&&2===t[1].length&&2===t[2].length,(()=>"Invalid number of paddings. Must be length of 2 each.")),Fs(e,t,n)}});const Ls=rn({pad4d_:function(e,t,n=0){return de(4===t.length&&2===t[0].length&&2===t[1].length&&2===t[2].length&&2===t[3].length,(()=>"Invalid number of paddings. Must be length of 2 each.")),Fs(e,t,n)}});const Bs=rn({spaceToBatchND_:function(e,t,n){const r=tn(e,"x","spaceToBatchND");de(r.rank>=1+t.length,(()=>`input rank ${r.rank} should be > than [blockShape] ${t.length}`)),de(n.length===t.length,(()=>`paddings.shape[0] ${n.length} must be equal to [blockShape] ${t.length}`)),de(r.shape.reduce(((e,r,s)=>s>0&&s<=t.length?e&&(r+n[s-1][0]+n[s-1][1])%t[s-1]==0:e),!0),(()=>`input spatial dimensions ${r.shape.slice(1)} with paddings ${n.toString()} must be divisible by blockShapes ${t.toString()}`));const s={x:r},a={blockShape:t,paddings:n};return Qt.runKernel("SpaceToBatchND",s,a)}});const Ps=rn({pool_:function(e,t,n,r,s,a,o){null==s&&(s=[1,1]),null==a&&(a=1),0===r&&(r="valid");const i=tn(e,"x","maxPool");let u=i,p=!1;3===i.rank&&(p=!0,u=In(i,[1,i.shape[0],i.shape[1],i.shape[2]])),de(_n(a,s),(()=>`Error in pool: Either strides or dilations must be 1. Got strides ${a} and dilations '${s}'`));const l=function(e,t,n,r,s,a,o="channelsLast"){const[i,u]=wn(t);let p;if("channelsLast"===o)p=[i,u,e[3],e[3]];else{if("channelsFirst"!==o)throw new Error(`Unknown dataFormat ${o}`);p=[i,u,e[1],e[1]]}return xn(e,p,n,r,s,a,!1,o)}(u.shape,t,a,s,r),c=[l.dilationHeight,l.dilationWidth];let h;h="same"===r?function(e,t){const n=e.map(((e,n)=>e+(e-1)*(t[n]-1))).map((e=>e-1)),r=n.map((e=>Math.floor(e/2))),s=n.map(((e,t)=>e-r[t]));return n.map(((e,t)=>[r[t],s[t]]))}([l.filterHeight,l.filterWidth],c):[[0,0],[0,0]];const d=1===c[0]&&1===c[1],[m,f]=function(e,t,n){const r=n.map((e=>e[0])),s=n.map((e=>e[1])),a=e.concat(r,s),o=t.map(((e,t)=>(e-a[t]%e)%e)),i=s.map(((e,t)=>e+o[t])),u=t.map(((e,t)=>[r[t],i[t]])),p=t.map(((e,t)=>[0,o[t]]));return[u,p]}([l.inHeight,l.inWidth],c,h),y=d?r:"valid",g=d?u:Bs(u,c,m),b=("avg"===n?()=>$n(g,t,a,y,o):()=>bs(g,t,a,y,o))(),N=d?b:Ln(b,c,f);return p?In(N,[N.shape[1],N.shape[2],N.shape[3]]):N}});const Ks=rn({prelu_:function(e,t){const n={x:tn(e,"x","prelu"),alpha:tn(t,"alpha","prelu")};return Qt.runKernel("Prelu",n)}});const qs=rn({prod_:function(e,t=null,n=!1){let r=tn(e,"x","prod");"bool"===r.dtype&&(r=Nn(r,"int32"));const s={x:r},a={axis:t,keepDims:n};return Qt.runKernel("Prod",s,a)}});const Us=rn({raggedGather_:function(e,t,n,r){const s={paramsNestedSplits:e.map(((e,t)=>tn(e,`tensors${t}`,"raggedGather","int32"))),paramsDenseValues:tn(t,"paramsDenseValues","raggedGather"),indices:tn(n,"indices","raggedGather","int32")},a={outputRaggedRank:r},o=Qt.runKernel("RaggedGather",s,a);return{outputNestedSplits:o.slice(0,o.length-1),outputDenseValues:o[o.length-1]}}});const Ws=rn({raggedRange_:function(e,t,n){const r=tn(e,"starts","raggedRange"),s={starts:r,limits:tn(t,"limits","raggedRange",r.dtype),deltas:tn(n,"deltas","raggedRange",r.dtype)},a=Qt.runKernel("RaggedRange",s);return{rtNestedSplits:a[0],rtDenseValues:a[1]}}});const js=rn({raggedTensorToTensor_:function(e,t,n,r,s){const a=tn(e,"shape","raggedTensorToTensor","int32"),o=tn(t,"values","raggedTensorToTensor"),i={shape:a,values:o,defaultValue:tn(n,"defaultValue","raggedTensorToTensor",o.dtype),rowPartitionTensors:r.map(((e,t)=>tn(e,`tensors${t}`,"raggedTensorToTensor","int32")))},u={rowPartitionTypes:s};return Qt.runKernel("RaggedTensorToTensor",i,u)}});const Hs=rn({rand_:function(e,t,n){Ae(e);const r=ye(e);let s=null;if(null==n||"float32"===n)s=new Float32Array(r);else if("int32"===n)s=new Int32Array(r);else{if("bool"!==n)throw new Error(`Unknown data type ${n}`);s=new Uint8Array(r)}for(let e=0;e<r;e++)s[e]=t();return Qt.makeTensor(s,e,n)}});var Gs="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function Zs(e){if(e.__esModule)return e;var t=Object.defineProperty({},"__esModule",{value:!0});return Object.keys(e).forEach((function(n){var r=Object.getOwnPropertyDescriptor(e,n);Object.defineProperty(t,n,r.get?r:{enumerable:!0,get:function(){return e[n]}})})),t}function Qs(e){var t={exports:{}};return e(t,t.exports),t.exports}var Ys=Qs((function(e){!function(e,t,n){function r(e){var t,n=this,r=(t=4022871197,function(e){e=String(e);for(var n=0;n<e.length;n++){var r=.02519603282416938*(t+=e.charCodeAt(n));r-=t=r>>>0,t=(r*=t)>>>0,t+=4294967296*(r-=t)}return 2.3283064365386963e-10*(t>>>0)});n.next=function(){var e=2091639*n.s0+2.3283064365386963e-10*n.c;return n.s0=n.s1,n.s1=n.s2,n.s2=e-(n.c=0|e)},n.c=1,n.s0=r(" "),n.s1=r(" "),n.s2=r(" "),n.s0-=r(e),n.s0<0&&(n.s0+=1),n.s1-=r(e),n.s1<0&&(n.s1+=1),n.s2-=r(e),n.s2<0&&(n.s2+=1),r=null}function s(e,t){return t.c=e.c,t.s0=e.s0,t.s1=e.s1,t.s2=e.s2,t}function a(e,t){var n=new r(e),a=t&&t.state,o=n.next;return o.int32=function(){return 4294967296*n.next()|0},o.double=function(){return o()+11102230246251565e-32*(2097152*o()|0)},o.quick=o,a&&("object"==typeof a&&s(a,n),o.state=function(){return s(n,{})}),o}t&&t.exports?t.exports=a:n&&n.amd?n((function(){return a})):this.alea=a}(0,e,!1)})),Xs=Qs((function(e){!function(e,t,n){function r(e){var t=this,n="";t.x=0,t.y=0,t.z=0,t.w=0,t.next=function(){var e=t.x^t.x<<11;return t.x=t.y,t.y=t.z,t.z=t.w,t.w^=t.w>>>19^e^e>>>8},e===(0|e)?t.x=e:n+=e;for(var r=0;r<n.length+64;r++)t.x^=0|n.charCodeAt(r),t.next()}function s(e,t){return t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t}function a(e,t){var n=new r(e),a=t&&t.state,o=function(){return(n.next()>>>0)/4294967296};return o.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},o.int32=n.next,o.quick=o,a&&("object"==typeof a&&s(a,n),o.state=function(){return s(n,{})}),o}t&&t.exports?t.exports=a:n&&n.amd?n((function(){return a})):this.xor128=a}(0,e,!1)})),Js=Qs((function(e){!function(e,t,n){function r(e){var t=this,n="";t.next=function(){var e=t.x^t.x>>>2;return t.x=t.y,t.y=t.z,t.z=t.w,t.w=t.v,(t.d=t.d+362437|0)+(t.v=t.v^t.v<<4^e^e<<1)|0},t.x=0,t.y=0,t.z=0,t.w=0,t.v=0,e===(0|e)?t.x=e:n+=e;for(var r=0;r<n.length+64;r++)t.x^=0|n.charCodeAt(r),r==n.length&&(t.d=t.x<<10^t.x>>>4),t.next()}function s(e,t){return t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t.v=e.v,t.d=e.d,t}function a(e,t){var n=new r(e),a=t&&t.state,o=function(){return(n.next()>>>0)/4294967296};return o.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},o.int32=n.next,o.quick=o,a&&("object"==typeof a&&s(a,n),o.state=function(){return s(n,{})}),o}t&&t.exports?t.exports=a:n&&n.amd?n((function(){return a})):this.xorwow=a}(0,e,!1)})),ea=Qs((function(e){!function(e,t,n){function r(e){var t=this;t.next=function(){var e,n,r=t.x,s=t.i;return e=r[s],n=(e^=e>>>7)^e<<24,n^=(e=r[s+1&7])^e>>>10,n^=(e=r[s+3&7])^e>>>3,n^=(e=r[s+4&7])^e<<7,e=r[s+7&7],n^=(e^=e<<13)^e<<9,r[s]=n,t.i=s+1&7,n},function(e,t){var n,r=[];if(t===(0|t))r[0]=t;else for(t=""+t,n=0;n<t.length;++n)r[7&n]=r[7&n]<<15^t.charCodeAt(n)+r[n+1&7]<<13;for(;r.length<8;)r.push(0);for(n=0;n<8&&0===r[n];++n);for(8==n&&(r[7]=-1),e.x=r,e.i=0,n=256;n>0;--n)e.next()}(t,e)}function s(e,t){return t.x=e.x.slice(),t.i=e.i,t}function a(e,t){null==e&&(e=+new Date);var n=new r(e),a=t&&t.state,o=function(){return(n.next()>>>0)/4294967296};return o.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},o.int32=n.next,o.quick=o,a&&(a.x&&s(a,n),o.state=function(){return s(n,{})}),o}t&&t.exports?t.exports=a:n&&n.amd?n((function(){return a})):this.xorshift7=a}(0,e,!1)})),ta=Qs((function(e){!function(e,t,n){function r(e){var t=this;t.next=function(){var e,n,r=t.w,s=t.X,a=t.i;return t.w=r=r+1640531527|0,n=s[a+34&127],e=s[a=a+1&127],n^=n<<13,e^=e<<17,n^=n>>>15,e^=e>>>12,n=s[a]=n^e,t.i=a,n+(r^r>>>16)|0},function(e,t){var n,r,s,a,o,i=[],u=128;for(t===(0|t)?(r=t,t=null):(t+="\0",r=0,u=Math.max(u,t.length)),s=0,a=-32;a<u;++a)t&&(r^=t.charCodeAt((a+32)%t.length)),0===a&&(o=r),r^=r<<10,r^=r>>>15,r^=r<<4,r^=r>>>13,a>=0&&(o=o+1640531527|0,s=0==(n=i[127&a]^=r+o)?s+1:0);for(s>=128&&(i[127&(t&&t.length||0)]=-1),s=127,a=512;a>0;--a)r=i[s+34&127],n=i[s=s+1&127],r^=r<<13,n^=n<<17,r^=r>>>15,n^=n>>>12,i[s]=r^n;e.w=o,e.X=i,e.i=s}(t,e)}function s(e,t){return t.i=e.i,t.w=e.w,t.X=e.X.slice(),t}function a(e,t){null==e&&(e=+new Date);var n=new r(e),a=t&&t.state,o=function(){return(n.next()>>>0)/4294967296};return o.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},o.int32=n.next,o.quick=o,a&&(a.X&&s(a,n),o.state=function(){return s(n,{})}),o}t&&t.exports?t.exports=a:n&&n.amd?n((function(){return a})):this.xor4096=a}(0,e,!1)})),na=Qs((function(e){!function(e,t,n){function r(e){var t=this,n="";t.next=function(){var e=t.b,n=t.c,r=t.d,s=t.a;return e=e<<25^e>>>7^n,n=n-r|0,r=r<<24^r>>>8^s,s=s-e|0,t.b=e=e<<20^e>>>12^n,t.c=n=n-r|0,t.d=r<<16^n>>>16^s,t.a=s-e|0},t.a=0,t.b=0,t.c=-1640531527,t.d=1367130551,e===Math.floor(e)?(t.a=e/4294967296|0,t.b=0|e):n+=e;for(var r=0;r<n.length+20;r++)t.b^=0|n.charCodeAt(r),t.next()}function s(e,t){return t.a=e.a,t.b=e.b,t.c=e.c,t.d=e.d,t}function a(e,t){var n=new r(e),a=t&&t.state,o=function(){return(n.next()>>>0)/4294967296};return o.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},o.int32=n.next,o.quick=o,a&&("object"==typeof a&&s(a,n),o.state=function(){return s(n,{})}),o}t&&t.exports?t.exports=a:n&&n.amd?n((function(){return a})):this.tychei=a}(0,e,!1)})),ra=Zs({__proto__:null,default:{}}),sa=Qs((function(e){!function(t,n,r){var s,a=256,o=r.pow(a,6),i=r.pow(2,52),u=2*i,p=255;function l(e,p,l){var y=[],g=m(d((p=1==p?{entropy:!0}:p||{}).entropy?[e,f(n)]:null==e?function(){try{var e;return s&&(e=s.randomBytes)?e=e(a):(e=new Uint8Array(a),(t.crypto||t.msCrypto).getRandomValues(e)),f(e)}catch(e){var r=t.navigator,o=r&&r.plugins;return[+new Date,t,o,t.screen,f(n)]}}():e,3),y),b=new c(y),N=function(){for(var e=b.g(6),t=o,n=0;e<i;)e=(e+n)*a,t*=a,n=b.g(1);for(;e>=u;)e/=2,t/=2,n>>>=1;return(e+n)/t};return N.int32=function(){return 0|b.g(4)},N.quick=function(){return b.g(4)/4294967296},N.double=N,m(f(b.S),n),(p.pass||l||function(e,t,n,s){return s&&(s.S&&h(s,b),e.state=function(){return h(b,{})}),n?(r.random=e,t):e})(N,g,"global"in p?p.global:this==r,p.state)}function c(e){var t,n=e.length,r=this,s=0,o=r.i=r.j=0,i=r.S=[];for(n||(e=[n++]);s<a;)i[s]=s++;for(s=0;s<a;s++)i[s]=i[o=p&o+e[s%n]+(t=i[s])],i[o]=t;(r.g=function(e){for(var t,n=0,s=r.i,o=r.j,i=r.S;e--;)t=i[s=p&s+1],n=n*a+i[p&(i[s]=i[o=p&o+t])+(i[o]=t)];return r.i=s,r.j=o,n})(a)}function h(e,t){return t.i=e.i,t.j=e.j,t.S=e.S.slice(),t}function d(e,t){var n,r=[],s=typeof e;if(t&&"object"==s)for(n in e)try{r.push(d(e[n],t-1))}catch(e){}return r.length?r:"string"==s?e:e+"\0"}function m(e,t){for(var n,r=e+"",s=0;s<r.length;)t[p&s]=p&(n^=19*t[p&s])+r.charCodeAt(s++);return f(t)}function f(e){return String.fromCharCode.apply(0,e)}if(m(r.random(),n),e.exports){e.exports=l;try{s=ra}catch(e){}}else r.seedrandom=l}("undefined"!=typeof self?self:Gs,[],Math)}));sa.alea=Ys,sa.xor128=Xs,sa.xorwow=Js,sa.xorshift7=ea,sa.xor4096=ta,sa.tychei=na;var aa=sa;class oa{constructor(e,t,n,r,s){this.mean=e,this.stdDev=t,this.dtype=n,this.nextVal=NaN,this.truncated=r,this.truncated&&(this.upper=this.mean+2*this.stdDev,this.lower=this.mean-2*this.stdDev);const a=s||Math.random();this.random=aa.alea(a.toString())}nextValue(){if(!isNaN(this.nextVal)){const e=this.nextVal;return this.nextVal=NaN,e}let e,t,n=!1;for(;!n;){let r,s,a;do{r=2*this.random()-1,s=2*this.random()-1,a=r*r+s*s}while(a>=1||0===a);const o=Math.sqrt(-2*Math.log(a)/a);e=this.mean+this.stdDev*r*o,t=this.mean+this.stdDev*s*o,this.truncated&&!this.isValidTruncated(e)||(n=!0)}return this.truncated&&!this.isValidTruncated(t)||(this.nextVal=this.convertValue(t)),this.convertValue(e)}convertValue(e){return null==this.dtype||"float32"===this.dtype?e:Math.round(e)}isValidTruncated(e){return e<=this.upper&&e>=this.lower}}class ia{constructor(e,t,n,r){this.alpha=e,this.beta=1/t,this.dtype=n;const s=r||Math.random();this.randu=aa.alea(s.toString()),this.randn=new oa(0,1,n,!1,this.randu()),this.d=e<1?e+2/3:e-1/3,this.c=1/Math.sqrt(9*this.d)}nextValue(){let e,t,n,r,s,a;for(;;){do{r=this.randn.nextValue(),a=1+this.c*r}while(a<=0);if(a*=a*a,e=r*r,t=1-.331*e*e,n=.5*e+this.d*(1-a+Math.log(a)),s=this.randu(),s<t||Math.log(s)<n)break}return a=1/this.beta*this.d*a,this.alpha<1&&(a*=Math.pow(this.randu(),1/this.alpha)),this.convertValue(a)}convertValue(e){return"float32"===this.dtype?e:Math.round(e)}}class ua{constructor(e=0,t=1,n,r){if(this.canReturnFloat=()=>null==this.dtype||"float32"===this.dtype,this.min=e,this.range=t-e,this.dtype=n,null==r&&(r=Math.random()),"number"==typeof r&&(r=r.toString()),!this.canReturnFloat()&&this.range<=1)throw new Error(`The difference between ${e} - ${t} <= 1 and dtype is not float`);this.random=aa.alea(r)}convertValue(e){return this.canReturnFloat()?e:Math.round(e)}nextValue(){return this.convertValue(this.min+this.range*this.random())}}const pa=rn({randomGamma_:function(e,t,n=1,r="float32",s){if(Ae(e),null==n&&(n=1),null==r&&(r="float32"),"float32"!==r&&"int32"!==r)throw new Error(`Unsupported data type ${r}`);const a=new ia(t,n,r,s),o=Hn(e,r);for(let e=0;e<o.values.length;e++)o.values[e]=a.nextValue();return o.toTensor()}});const la=rn({randomNormal_:function(e,t=0,n=1,r,s){if(Ae(e),null!=r&&"bool"===r)throw new Error(`Unsupported data type ${r}`);const a=new oa(t,n,r,!1,s),o=Hn(e,r);for(let e=0;e<o.values.length;e++)o.values[e]=a.nextValue();return o.toTensor()}});const ca=rn({randomStandardNormal_:function(e,t,n){if(null!=t&&"bool"===t)throw new Error(`Unsupported data type ${t}`);return la(e,0,1,t,n)}});const ha=rn({randomUniform_:function(e,t=0,n=1,r="float32",s){Ae(e);const a=Hn(e,r),o=new ua(t,n,null,s);for(let e=0;e<a.values.length;e++)a.values[e]=o.nextValue();return a.toTensor()}});function da(e,t,n=1,r="float32"){if(0===n)throw new Error("Cannot have a step of zero");const s={start:e,stop:t,step:n,dtype:r};return Qt.runKernel("Range",{},s)}const ma=rn({real_:function(e){const t={input:tn(e,"input","real")};return Qt.runKernel("Real",t)}});const fa=rn({reciprocal_:function(e){const t={x:tn(e,"x","reciprocal")};return Qt.runKernel("Reciprocal",t)}});const ya=rn({relu_:function(e){const t={x:tn(e,"x","relu")};return Qt.runKernel("Relu",t)}});const ga=rn({relu6_:function(e){const t={x:tn(e,"x","relu6")};return Qt.runKernel("Relu6",t)}});const ba=rn({reverse_:function(e,t){const n={x:tn(e,"x","reverse")},r={dims:t};return Qt.runKernel("Reverse",n,r)}});const Na=rn({reverse1d_:function(e){const t=tn(e,"x","reverse");return de(1===t.rank,(()=>`Error in reverse1D: x must be rank 1 but got rank ${t.rank}.`)),ba(t,0)}});const xa=rn({reverse2d_:function(e,t){const n=tn(e,"x","reverse");return de(2===n.rank,(()=>`Error in reverse2D: x must be rank 2 but got rank ${n.rank}.`)),ba(n,t)}});const wa=rn({reverse3d_:function(e,t){const n=tn(e,"x","reverse");return de(3===n.rank,(()=>`Error in reverse3D: x must be rank 3 but got rank ${n.rank}.`)),ba(n,t)}});const ka=rn({reverse4d_:function(e,t){const n=tn(e,"x","reverse");return de(4===n.rank,(()=>`Error in reverse4D: x must be rank 4 but got rank ${n.rank}.`)),ba(n,t)}});const Ta=rn({round_:function(e){const t={x:tn(e,"x","round")};return Qt.runKernel("Round",t)}});const va=rn({rsqrt_:function(e){const t={x:tn(e,"x","rsqrt","float32")};return Qt.runKernel("Rsqrt",t)}});const _a=rn({selu_:function(e){const t={x:tn(e,"x","selu")};return Qt.runKernel("Selu",t)}});const Sa=rn({separableConv2d_:function(e,t,n,r,s,a=[1,1],o="NHWC"){const i=tn(e,"x","separableConv2d"),u=tn(t,"depthwiseFilter","separableConv2d"),p=tn(n,"pointwiseFilter","separableConv2d");let l=i,c=!1;if(3===i.rank&&(c=!0,l=In(i,[1,i.shape[0],i.shape[1],i.shape[2]])),"NCHW"===o)throw new Error("separableConv2d currently does not support dataFormat NCHW; only NHWC is supported");de(4===l.rank,(()=>`Error in separableConv2d: input must be rank 4, but got rank ${l.rank}.`)),de(4===u.rank,(()=>`Error in separableConv2d: depthwise filter must be rank 4, but got rank ${u.rank}.`)),de(4===p.rank,(()=>`Error in separableConv2d: pointwise filter must be rank 4, but got rank ${u.rank}.`)),de(1===p.shape[0],(()=>`Error in separableConv2d: the first dimension of pointwise filter  must be 1, but got ${p.shape[0]}.`)),de(1===p.shape[1],(()=>`Error in separableConv2d: the second dimension of pointwise filter must be 1, but got ${p.shape[1]}.`));const h=u.shape[2],d=u.shape[3];de(p.shape[2]===h*d,(()=>`Error in separableConv2d: the third dimension of pointwise filter must be ${h*d}, but got ${p.shape[2]}.`));const m=fr(l,u,r,s,o,a),f=nr(m,p,1,"valid",o);return c?In(f,[f.shape[1],f.shape[2],f.shape[3]]):f}});const Ea=async function(e,t){const n=tn(e,"x","setdiff1d"),r=tn(t,"y","setdiff1d");de(n.dtype===r.dtype,(()=>`x and y should have the same dtype, but got x (${n.dtype}) and y (${r.dtype}).`)),de(1===n.rank,(()=>`x should be 1D tensor, but got x (${n.shape}).`)),de(1===r.rank,(()=>`y should be 1D tensor, but got y (${r.shape}).`));const s=await n.data(),a=await r.data(),o=new Set(a);let i=0;for(let e=0;e<s.length;e++)o.has(s[e])||i++;const u=new Ot([i],n.dtype),p=new Ot([i],"int32");for(let e=0,t=0;e<s.length;e++)o.has(s[e])||(u.values[t]=s[e],p.values[t]=e,t++);return[u.toTensor(),p.toTensor()]};const Ia=rn({sign_:function(e){const t={x:tn(e,"x","sign")};return Qt.runKernel("Sign",t)}});const $a=rn({sin_:function(e){const t={x:tn(e,"x","sin","float32")};return Qt.runKernel("Sin",t)}});const Da=rn({sinh_:function(e){const t={x:tn(e,"x","sinh")};return Qt.runKernel("Sinh",t)}});const Aa=rn({slice1d_:function(e,t,n){const r=tn(e,"x","slice1d");return de(1===r.rank,(()=>`slice1d expects a rank-1 tensor, but got a rank-${r.rank} tensor`)),Rn(r,[t],[n])}});const Oa=rn({slice2d_:function(e,t,n){const r=tn(e,"x","slice2d");return de(2===r.rank,(()=>`slice2d expects a rank-2 tensor, but got a rank-${r.rank} tensor`)),Rn(r,t,n)}});const Ma=rn({slice3d_:function(e,t,n){const r=tn(e,"x","slice3d");return de(3===r.rank,(()=>`slice3d expects a rank-3 tensor, but got a rank-${r.rank} tensor`)),Rn(r,t,n)}});const Ca=rn({slice4d_:function(e,t,n){const r=tn(e,"x","slice4d");return de(4===r.rank,(()=>`slice4d expects a rank-4 tensor, but got a rank-${r.rank} tensor`)),Rn(r,t,n)}});const Fa=rn({softmax_:function(e,t=-1){const n=tn(e,"logits","softmax","float32");if(-1===t&&(t=n.rank-1),t!==n.rank-1)throw Error(`Softmax along a non-last dimension is not yet supported. Logits was rank ${n.rank} and dim was ${t}`);const r={logits:n},s={dim:t};return Qt.runKernel("Softmax",r,s)}});const Ra=rn({fft_:function(e){de("complex64"===e.dtype,(()=>`The dtype for tf.spectral.fft() must be complex64 but got ${e.dtype}.`));const t={input:e};return Qt.runKernel("FFT",t)}});const za=rn({ifft_:function(e){de("complex64"===e.dtype,(()=>`The dtype for tf.spectral.ifft() must be complex64 but got ${e.dtype}.`));const t={input:e};return Qt.runKernel("IFFT",t)}});const Va=rn({irfft_:function(e){const t=e.shape[e.shape.length-1],n=e.size/t;let r;if(t<=2){const s=In(e,[n,t]);r=za(s)}else{const s=[n,2*(t-1)],a=In(ma(e),[n,t]),o=In(Qr(e),[n,t]),i=ba(Rn(a,[0,1],[n,t-2]),1),u=Cn(ba(Rn(o,[0,1],[n,t-2]),1),Cr(-1)),p=On([a,i],1),l=On([o,u],1),c=In(Yn(p,l),[s[0],s[1]]);r=za(c)}if(r=ma(r),3===e.rank&&0!==e.shape[0]){const t=r,n=e.shape[0];r=In(r,[n,r.shape[0]/n,r.shape[1]]),t.dispose()}return r}});const La=rn({split_:function(e,t,n=0){const r={x:tn(e,"x","split")},s={numOrSizeSplits:t,axis:n};return Qt.runKernel("SplitV",r,s)}});const Ba=rn({rfft_:function(e,t){de("float32"===e.dtype,(()=>`The dtype for rfft() must be real value but got ${e.dtype}`));let n=e.shape[e.shape.length-1];const r=e.size/n;let s;if(null!=t&&t<n){const r=e.shape.map((e=>0)),a=e.shape.map((e=>e));a[e.shape.length-1]=t,s=Rn(e,r,a),n=t}else if(null!=t&&t>n){const r=e.shape.map((e=>e));r[e.shape.length-1]=t-n,s=On([e,Ts(r)],e.shape.length-1),n=t}else s=e;const a=Tr(s),o=In(Yn(s,a),[r,n]),i=Ra(o),u=Math.floor(n/2)+1,p=ma(i),l=Qr(i),c=La(p,[u,n-u],p.shape.length-1),h=La(l,[u,n-u],l.shape.length-1),d=s.shape.slice();return d[s.shape.length-1]=u,In(Yn(c[0],h[0]),d)}});const Pa=rn({squaredDifference_:function(e,t){let n=tn(e,"a","squaredDifference"),r=tn(t,"b","squaredDifference");[n,r]=Ut(n,r),xr(n.shape,r.shape);const s={a:n,b:r};return Qt.runKernel("SquaredDifference",s,{})}});const Ka=rn({squeeze_:function(e,t){const n=tn(e,"x","squeeze","string_or_numeric");return In(n,function(e,t){const n=[],r=[],s=null!=t&&Array.isArray(t)&&0===t.length,a=null==t||s?null:xe(t,e).sort();let o=0;for(let t=0;t<e.length;++t){if(null!=a){if(a[o]===t&&1!==e[t])throw new Error(`Can't squeeze axis ${t} since its dim '${e[t]}' is not 1`);(null==a[o]||a[o]>t)&&1===e[t]&&(n.push(e[t]),r.push(t)),a[o]<=t&&o++}1!==e[t]&&(n.push(e[t]),r.push(t))}return{newShape:n,keptDims:r}}(n.shape,t).newShape)}});const qa=rn({stack_:function(e,t=0){const n=nn(e,"tensors","stack","string_or_numeric");de(n.length>=1,(()=>"Pass at least one tensor to tf.stack")),n.length>0&&de(t<=n[0].rank,(()=>"Axis must be <= rank of the tensor"));const r=n,s={axis:t};return Qt.runKernel("Pack",r,s)}});const Ua=rn({step_:function(e,t=0){const n={x:tn(e,"x","step")},r={alpha:t};return Qt.runKernel("Step",n,r)}});const Wa=rn({stridedSlice_:function(e,t,n,r,s=0,a=0,o=0,i=0,u=0){const p={x:tn(e,"x","stridedSlice","string_or_numeric")},l={begin:t,end:n,strides:r,beginMask:s,endMask:a,ellipsisMask:o,newAxisMask:i,shrinkAxisMask:u};return Qt.runKernel("StridedSlice",p,l)}});const ja=rn({tan_:function(e){const t={x:tn(e,"x","tan","float32")};return Qt.runKernel("Tan",t)}});function Ha(e,t,n){return Mr(e,t,Xt(e,n),n)}function Ga(e,t){fe(e);const n=Xt(e,t);if(1!==n.length)throw new Error("tensor1d() requires values to be a flat/TypedArray");return Mr(e,null,n,t)}function Za(e,t,n){if(fe(e),null!=t&&2!==t.length)throw new Error("tensor2d() requires shape to have two numbers");const r=Xt(e,n);if(2!==r.length&&1!==r.length)throw new Error("tensor2d() requires values to be number[][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor2d() requires shape to be provided when `values` are a flat/TypedArray");return Mr(e,t,r,n)}function Qa(e,t,n){if(t.rank<1)throw new Error(`tf.scatterND() expects the indices to be rank 1 or higher, but the rank was ${t.rank}.`);if(e.rank<1)throw new Error(`tf.scatterND() expects the updates to be rank 1 or higher, but the rank was ${e.rank}.`);if("int32"!==t.dtype)throw new Error(`The dtype of 'indices' should be int32, but got dtype: ${t.dtype}`);if(n.length<1)throw new Error(`Output rank must be greater or equal to 1, but got shape: ${n}`);if(0===n.length){if(0===t.size)throw new Error(`Indices specified for empty output. indices shape: ${t.shape}`);if(0===e.size)throw new Error(`Updates specified for empty output. updates shape: ${e.shape}`)}!function(e,t,n){const r=t.rank>1?t.shape[t.rank-1]:1,s=t.rank>1?t.rank-1:1,a=`Must have updates.shape = indices.shape[:batchDim] + shape[sliceDim:], got updates.shape: ${n.shape}, indices.shape: ${t.shape}, shape: ${e}, sliceDim: ${r}, and batchDim: ${s}.`;if(n.rank<s)throw new Error(a+` update.rank < ${s}. `);if(e.length<r+(n.rank-s))throw new Error(a+` Output shape length < ${r+(n.rank-s)}`);if(n.rank!==s+e.length-r)throw new Error(a+" update.rank != "+(s+e.length-r));for(let e=0;e<s;++e)if(n.shape[e]!==t.shape[e])throw new Error(a+` updates.shape[${e}] (${n.shape[e]}) != indices.shape[${e}] (${t.shape[e]}).`);for(let t=0;t<n.rank-s;++t)if(n.shape[t+s]!==e[t+r])throw new Error(a+` updates.shape[${t+s}] (${n.shape[t+s]}) != shape[${t+s}] (${e[t+s]})`)}(n,t,e)}const Ya=rn({tensorScatterUpdate_:function(e,t,n){const r=tn(e,"tensor","tensorScatterupdate"),s=tn(t,"indices","tensorScatterupdate","int32"),a=tn(n,"updates","tensorScatterupdate");if(Qa(a,s,r.shape),r.dtype!==a.dtype)throw new Error(`tensor and updates must have the same dtype, instead they are ${r.dtype} and ${a.dtype}.`);const o={tensor:r,indices:s,updates:a};return Qt.runKernel("TensorScatterUpdate",o,{})}});const Xa=rn({topk_:function(e,t=1,n=!0){const r=tn(e,"x","topk");if(0===r.rank)throw new Error("topk() expects the input to be of rank 1 or higher");const s=r.shape[r.shape.length-1];if(t<0)throw new Error(`'k' passed to topk() must be >= 0 but got ${t}`);if(t>s)throw new Error(`'k' passed to topk() must be <= the last dimension (${s}) but got ${t}`);const a={x:r},o={k:t,sorted:n},[i,u]=Qt.runKernel("TopK",a,o);return{values:i,indices:u}}});const Ja=rn({truncatedNormal_:function(e,t=0,n=1,r,s){if(Ae(e),null!=r&&"bool"===r)throw new Error("Unsupported data type $ { dtype }");const a=new oa(t,n,r,!0,s),o=Hn(e,r);for(let e=0;e<o.values.length;e++)o.values[e]=a.nextValue();return o.toTensor()}});const eo=rn({unique_:function(e,t=0){const n=tn(e,"x","unique","string_or_numeric");de(n.rank>0,(()=>"The input tensor must be at least 1D"));const r={x:n},s={axis:t},[a,o]=Qt.runKernel("Unique",r,s);return{values:a,indices:o}}});const to=rn({unsortedSegmentSum_:function(e,t,n){const r=tn(e,"x","unsortedSegmentSum"),s=tn(t,"segmentIds","unsortedSegmentSum","int32");de(be(n),(()=>"numSegments must be of dtype int"));const a={x:r,segmentIds:s},o={numSegments:n};return Qt.runKernel("UnsortedSegmentSum",a,o)}});const no=rn({unstack_:function(e,t=0){const n=tn(e,"x","unstack","string_or_numeric");de(t>=-n.shape.length&&t<n.shape.length,(()=>`Axis = ${t} is not in [-${n.shape.length}, ${n.shape.length})`));const r={value:n},s={axis:t};return Qt.runKernel("Unpack",r,s)}});const ro=async function(e){const t=tn(e,"condition","whereAsync","bool"),n=await t.data(),r=function(e,t){const n=[];for(let e=0;e<t.length;e++)t[e]&&n.push(e);const r=Hn(e,"int32"),s=Hn([n.length,e.length],"int32");for(let t=0;t<n.length;t++){const a=r.indexToLoc(n[t]),o=t*e.length;s.values.set(a,o)}return s.toTensor()}(t.shape,n);return e!==t&&t.dispose(),r};const so=async function(e,t,n){const r=tn(e,"tensor","boolMask"),s=tn(t,"mask","boolMask","bool"),a=null==n?0:n,o=s.rank,i=r.shape;de(o>0,(()=>"mask cannot be scalar")),me(i.slice(a,a+o),s.shape,"mask's shape must match the first K dimensions of tensor's shape,");let u=1;for(let e=a;e<a+o;e++)u*=i[e];const p=i.slice(0,a).concat([u],i.slice(a+o)),l=In(r,p),c=In(s,[-1]),h=await ro(c),d=Ka(h,[1]),m=Hr(l,d,a);return e!==r&&r.dispose(),t!==s&&s.dispose(),d.dispose(),l.dispose(),c.dispose(),h.dispose(),m};const ao=rn({transpose_:function(e,t,n){const r=tn(e,"x","transpose");if(null==t&&(t=r.shape.map(((e,t)=>t)).reverse()),de(r.rank===t.length,(()=>`Error in transpose: rank of input ${r.rank} must match length of perm ${t}.`)),t.forEach((e=>{de(e>=0&&e<r.rank,(()=>"All entries in 'perm' must be between 0 and "+(r.rank-1)+` but got ${t}`))})),r.rank<=1)return r.clone();const s={x:r},a={perm:t};return"complex64"===r.dtype?(o=()=>{let e=ma(r),t=Qr(r);return e=Qt.runKernel("Transpose",{x:e},a),t=Qt.runKernel("Transpose",{x:t},a),n&&(t=is(t)),Yn(e,t)},Qt.tidy(o,i)):Qt.runKernel("Transpose",s,a);var o,i}});const oo=rn({movingAverage_:function(e,t,n,r,s=!0){const a=tn(e,"v","movingAverage"),o=tn(t,"x","movingAverage"),i=tn(n,"decay","movingAverage");var u,p;p=o,de((u=a).dtype===p.dtype,(()=>`The dtypes of the first(${u.dtype}) and second(${p.dtype}) input must match`)),de(ge(a.shape,o.shape),(()=>"Shape mismatch in v and x"));const l=Cr(1),c=ls(l,i);let h=Cn(ls(o,a),c);if(s){de(null!=r,(()=>"When using zeroDebias: true, step is required."));const e=tn(r,"step","movingAverage");h=Nr(h,ls(l,Or(i,e)))}return un(a,h)}});const io=rn({scatterND_:function(e,t,n){Ae(n);const r=tn(e,"indices","scatterND","int32"),s=tn(t,"updates","scatterND");Qa(s,r,n);const a={indices:r,updates:s},o={shape:n};return Qt.runKernel("ScatterNd",a,o)}});const uo=rn({sparseToDense_:function(e,t,n,r=0){Ae(n);const s=tn(e,"sparseIndices","sparseToDense","int32"),a=tn(t,"sparseValues","sparseToDense","string_or_numeric"),o=tn(r,"defaultValue","sparseToDense",a.dtype);!function(e,t,n,r){if("int32"!==e.dtype)throw new Error(`tf.sparseToDense() expects the indices to be int32 type, but the dtype was ${e.dtype}.`);if(e.rank>2)throw new Error(`sparseIndices should be a scalar, vector, or matrix, but got shape ${e.shape}.`);const s=e.rank>0?e.shape[0]:1,a=e.rank>1?e.shape[1]:1;if(n.length!==a)throw new Error(`outputShape has incorrect number of elements:, ${n.length}, should be: ${a}.`);const o=t.size;if(0!==t.rank&&(1!==t.rank||o!==s))throw new Error(`sparseValues has incorrect shape ${t.shape}, should be [] or [${s}]`);if(t.dtype!==r.dtype)throw new Error("sparseValues.dtype must match defaultValues.dtype")}(s,a,n,o);const i={sparseIndices:s,sparseValues:a,defaultValue:o},u={outputShape:n};return Qt.runKernel("SparseToDense",i,u)}});const po=rn({gatherND_:function(e,t){const n=tn(t,"indices","gatherND","int32"),r={params:tn(e,"x","gatherND","string_or_numeric"),indices:n};return Qt.runKernel("GatherNd",r)}});const lo=rn({dropout_:function(e,t,n,r){const s=tn(e,"x","dropout");if(de("float32"===s.dtype,(()=>`x has to be a floating point tensor since it's going to be scaled, but got a ${s.dtype} tensor instead.`)),de(t>=0&&t<1,(()=>`rate must be a float in the range [0, 1), but got ${t}.`)),0===t)return e instanceof Ct?s.clone():s;const a=function(e,t){if(null==t)return e.shape.slice();if(ge(e.shape,t))return t;if(e.shape.length===t.length){const n=[];for(let r=0;r<e.shape.length;r++)null==t[r]&&null!=e.shape[r]?n.push(e.shape[r]):n.push(t[r]);return n}return t}(s,n),o=1-t,i=Nr(jr(un(ha(a,0,1,"float32",r),o)),o);return Cn(s,i)}});function co(e){return Math.floor(Math.pow(2,Math.ceil(Math.log(e)/Math.log(2))))}function ho(e,t,n){const r=1-e%2,s=new Float32Array(e);for(let a=0;a<e;++a){const o=2*Math.PI*a/(e+r-1);s[a]=t-n*Math.cos(o)}return Ga(s,"float32")}const mo=async function(e,t,n=1){const r=tn(e,"predictions","inTopK"),s=tn(t,"targets","inTopK");de(r.rank>1,(()=>`inTopK() expects the predictions to be of rank 2 or higher, but got ${r.rank}`)),de(r.rank-1===s.rank,(()=>`predictions rank should be 1 larger than targets rank, but got predictions rank ${r.rank} and targets rank ${s.rank}`)),me(r.shape.slice(0,r.shape.length-1),s.shape,"predictions's shape should be align with the targets' shape, except the last dimension.");const a=r.shape[r.shape.length-1];de(n>0&&n<=a,(()=>`'k' passed to inTopK() must be > 0 && <= the predictions last dimension (${a}), but got ${n}`));const o=await r.data(),i=await s.data(),[u,p]=[o.length/a,a],l=function(e,t){return we(e,t)}("bool",u);for(let e=0;e<u;e++){const t=e*p,r=o.subarray(t,t+p),s=[];for(let e=0;e<r.length;e++)s.push({value:r[e],index:e});s.sort(((e,t)=>t.value-e.value)),l[e]=0;for(let t=0;t<n;t++)if(s[t].index===i[e]){l[e]=1;break}}return e!==r&&r.dispose(),t!==s&&s.dispose(),Ha(l,s.shape,"bool")};const fo=rn({conv2DBackpropFilter_:function(e,t,n,r,s,a="NHWC",o){let i=e;3===e.rank&&(i=In(e,[1,e.shape[0],e.shape[1],e.shape[2]]));let u=t;3===u.rank&&(u=In(t,[1,t.shape[0],t.shape[1],t.shape[2]])),de(4===i.rank,(()=>`Error in conv2dDerFilter: input must be rank 4, but got shape ${i.shape}.`)),de(4===u.rank,(()=>`Error in conv2dDerFilter: dy must be rank 4, but got shape ${u.shape}.`)),de(4===n.length,(()=>`Error in conv2dDerFilter: filterShape must be length 4, but got ${n}.`));const p="NHWC"===a?i.shape[3]:i.shape[1],l="NHWC"===a?u.shape[3]:u.shape[1];de(p===n[2],(()=>`Error in conv2dDerFilter: depth of input ${p}) must match input depth in filter (${n[2]}.`)),de(l===n[3],(()=>`Error in conv2dDerFilter: depth of dy (${l}) must match output depth for filter (${n[3]}).`)),En("conv2dDerFilter",s,o);const c={x:i,dy:u},h={strides:r,pad:s,dataFormat:a,dimRoundingMode:o,filterShape:n};return Qt.runKernel("Conv2DBackpropFilter",c,h)}});function yo(e,t,n){if(null==n||"linear"===n)return e;if("relu"===n)return Cn(e,Ua(t));throw new Error(`Cannot compute gradient for fused activation ${n}.`)}function go(e,t){let n=t;const r=function(e,t){const n=[];for(let r=0;r<t.length;r++){const s=e[e.length-r-1],a=t.length-r-1,o=t[a];(null==s||1===s&&o>1)&&n.unshift(a)}return n}(e.shape,t.shape);return r.length>0&&(n=zr(n,r)),In(n,e.shape)}function bo(e,t,n,r){if("linear"===t)return e;if("relu"===t)return ya(e);if("elu"===t)return Er(e);if("relu6"===t)return ga(e);if("prelu"===t)return Ks(e,n);if("leakyrelu"===t)return es(e,r);if("sigmoid"===t)return Fn(e);throw new Error(`Unknown fused activation ${t}.`)}const No=(e,t)=>!(e>0)||"linear"===t;const xo=rn({fusedConv2d_:function({x:e,filter:t,strides:n,pad:r,dataFormat:s="NHWC",dilations:a=[1,1],dimRoundingMode:o,bias:i,activation:u="linear",preluActivationWeights:p,leakyreluAlpha:l}){if(u=u||"linear",!1===No(Qt.state.gradientDepth,u)){de("NHWC"===s,(()=>`Error in fused conv2d: got dataFormat of ${s} but only NHWC is currently supported for the case of gradient depth is 0 and the activation is not linear.`));let c=nr(e,t,n,r,s,a,o);return null!=i&&(c=un(c,i)),bo(c,u,p,l)}const c=tn(e,"x","conv2d","float32"),h=tn(t,"filter","conv2d","float32");let d=c,m=!1;3===c.rank&&(m=!0,d=In(c,[1,c.shape[0],c.shape[1],c.shape[2]])),de(4===d.rank,(()=>`Error in fused conv2d: input must be rank 4, but got rank ${d.rank}.`)),de(4===h.rank,(()=>`Error in fused conv2d: filter must be rank 4, but got rank ${h.rank}.`)),En("fused conv2d",r,o);const f="NHWC"===s?d.shape[3]:d.shape[1];de(h.shape[2]===f,(()=>`Error in conv2d: depth of input (${f}) must match input depth for filter ${h.shape[2]}.`)),de(_n(n,a),(()=>`Error in conv2D: Either strides or dilations must be 1. Got strides ${n} and dilations '${a}'`));const y=xn(d.shape,h.shape,n,a,r,o);let g,b;if(null!=i&&(g=tn(i,"bias","fused conv2d"),[g]=Ut(g,c),"NHWC"===s?xr(y.outShape,g.shape):(de(g.shape.length<=1,(()=>`Error in fused conv2d: only supports scalar or 1-D Tensor bias for NCHW format but got the bias of rank-${g.shape.length}.`)),de(0===g.shape.length||g.shape[0]===y.outChannels||1===g.shape[0],(()=>`Error in fused conv2d: bias shape (${g.shape}) is not compatible with the number of output channels (${y.outChannels})`)))),null!=p){const e=p.shape;if(de(e.length<=1||3===e.length,(()=>`Error in fused conv2d: only supports scalar, 1-D Tensor or 3-D Tensor PReLU activation weights but got a tensor of rank-${e.length}.`)),1===e.length)de(1===e[0]||e[0]===y.outChannels,(()=>`Error in fused conv2d: PReLU activation weights (${e}) is not compatible with the number of output channels (${y.outChannels}).`));else if(3===e.length)try{xr(e,y.outShape)}catch(t){const n=`Error in fused conv2d: PReLU activation weights (${e}) is not compatible with the output shape of the conv2d (${y.outShape}).`;throw Error(n)}b=tn(p,"prelu weights","fused conv2d")}const N=(e,t)=>{de("NHWC"===s,(()=>`Error in gradient of fused conv2D: got dataFormat of ${s} but only NHWC is currently supported.`));const[o,i,p,l]=t,c=yo(e,p,u);de(vn(a),(()=>`Error in gradient of fused conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '${a}'`));const h=[sr(i.shape,c,o,n,r),fo(i,c,o.shape,n,r)];if(null!=l){const e=go(l,c);h.push(e)}return h},x={x:d,filter:h,bias:g,preluActivationWeights:b},w={strides:n,pad:r,dataFormat:s,dilations:a,dimRoundingMode:o,activation:u,leakyreluAlpha:l};if(null==i){const e=os(((e,t,n)=>{let r=Qt.runKernel("FusedConv2D",x,w);return n([t,e,r]),m&&(r=In(r,[r.shape[1],r.shape[2],r.shape[3]])),{value:r,gradFunc:N}}));return e(d,h)}{const e=os(((e,t,n,r)=>{let s=Qt.runKernel("FusedConv2D",x,w);return r([t,e,s,n]),m&&(s=In(s,[s.shape[1],s.shape[2],s.shape[3]])),{value:s,gradFunc:N}}));return e(d,h,g)}}});const wo=rn({depthwiseConv2dNativeBackpropFilter_:function(e,t,n,r,s,a=[1,1],o){let i=e;3===e.rank&&(i=In(e,[1,e.shape[0],e.shape[1],e.shape[2]]));let u=t;3===u.rank&&(u=In(t,[1,t.shape[0],t.shape[1],t.shape[2]]));const p={x:i,dy:u},l={strides:r,pad:s,dimRoundingMode:o,dilations:a,filterShape:n};return Qt.runKernel("DepthwiseConv2dNativeBackpropFilter",p,l)}});const ko=rn({depthwiseConv2dNativeBackpropInput_:function(e,t,n,r,s,a=[1,1],o){let i=t,u=!1;3===t.rank&&(u=!0,i=In(t,[1,t.shape[0],t.shape[1],t.shape[2]]));const p={dy:i,filter:n},l={strides:r,pad:s,dimRoundingMode:o,dilations:a,inputShape:e},c=Qt.runKernel("DepthwiseConv2dNativeBackpropInput",p,l);return u?In(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});const To=rn({fusedDepthwiseConv2d_:function({x:e,filter:t,strides:n,pad:r,dataFormat:s="NHWC",dilations:a=[1,1],dimRoundingMode:o,bias:i,activation:u="linear",preluActivationWeights:p,leakyreluAlpha:l}){if(!1===No(Qt.state.gradientDepth,u)){let c=fr(e,t,n,r,s,a,o);return null!=i&&(c=un(c,i)),bo(c,u,p,l)}const c=tn(e,"x","depthwiseConv2d","float32"),h=tn(t,"filter","depthwiseConv2d","float32");let d=c,m=!1;3===c.rank&&(m=!0,d=In(c,[1,c.shape[0],c.shape[1],c.shape[2]])),de(4===d.rank,(()=>`Error in fused depthwiseConv2d: input must be rank 4, but got rank ${d.rank}.`)),de(4===h.rank,(()=>`Error in fused depthwiseConv2d: filter must be rank 4, but got rank ${h.rank}.`)),de(d.shape[3]===h.shape[2],(()=>`Error in fused depthwiseConv2d: number of input channels (${d.shape[3]}) must match the inChannels dimension in filter ${h.shape[2]}.`)),null==a&&(a=[1,1]),de(_n(n,a),(()=>`Error in fused depthwiseConv2d: Either strides or dilations must be 1. Got strides ${n} and dilations '${a}'`)),En("fused depthwiseConv2d",r,o);const f=xn(d.shape,h.shape,n,a,r,o,!0);let y,g;null!=i&&(y=tn(i,"bias","fused conv2d"),[y]=Ut(y,c),xr(f.outShape,y.shape)),null!=p&&(g=tn(p,"prelu weights","fused depthwiseConv2d"));const b=(e,t)=>{de(vn(a),(()=>`Error in gradient of fused depthwiseConv2d: dilation rates greater than 1 are not yet supported. Got dilations '${a}'`));const[s,i,p,l]=t,c=yo(e,p,u),h=ko(i.shape,c,s,n,r,a,o),d=wo(i,c,s.shape,n,r,a,o);if(null!=l){return[h,d,go(y,c)]}return[h,d]},N={x:d,filter:h,bias:y,preluActivationWeights:g},x={strides:n,pad:r,dataFormat:s,dilations:a,dimRoundingMode:o,activation:u,leakyreluAlpha:l};if(null==i){const e=os(((e,t,n)=>{let r=Qt.runKernel("FusedDepthwiseConv2D",N,x);return n([t,e,r]),m&&(r=In(r,[r.shape[1],r.shape[2],r.shape[3]])),{value:r,gradFunc:b}}));return e(d,h)}{const e=os(((e,t,n,r)=>{let s=Qt.runKernel("FusedDepthwiseConv2D",N,x);return r([t,e,s,n]),m&&(s=In(s,[s.shape[1],s.shape[2],s.shape[3]])),{value:s,gradFunc:b}}));return e(d,h,y)}}});var vo={__proto__:null,conv2d:xo,depthwiseConv2d:To,matMul:rn({fusedMatMul_:function({a:e,b:t,transposeA:n=!1,transposeB:r=!1,bias:s,activation:a="linear",preluActivationWeights:o,leakyreluAlpha:i=.2}){if(!1===No(Qt.state.gradientDepth,a)){let u=Mn(e,t,n,r);return null!=s&&(u=un(u,s)),bo(u,a,o,i)}let u=tn(e,"a","fused matMul"),p=tn(t,"b","fused matMul");[u,p]=Ut(u,p);const l=n?u.shape[u.rank-2]:u.shape[u.rank-1],c=r?p.shape[p.rank-1]:p.shape[p.rank-2],h=n?u.shape[u.rank-1]:u.shape[u.rank-2],d=r?p.shape[p.rank-2]:p.shape[p.rank-1],m=u.shape.slice(0,-2),f=p.shape.slice(0,-2),y=ye(m),g=ye(f);de(l===c,(()=>`Error in fused matMul: inner shapes (${l}) and (${c}) of Tensors with shapes ${u.shape} and ${p.shape} and transposeA=${n} and transposeB=${r} must match.`));const b=xr(u.shape.slice(0,-2),p.shape.slice(0,-2)).concat([h,d]),N=In(u,n?[y,l,h]:[y,h,l]),x=In(p,r?[g,d,c]:[g,c,d]);let w,k;null!=s&&(w=tn(s,"bias","fused matMul"),[w]=Ut(w,u),xr(b,w.shape)),null!=o&&(k=tn(o,"prelu weights","fused matMul"));const T=(e,t)=>{const[o,i,u,p]=t,l=yo(In(e,u.shape),u,a);let c,h;if(n||r?!n&&r?(c=Mn(l,i,!1,!1),h=Mn(l,o,!0,!1)):n&&!r?(c=Mn(i,l,!1,!0),h=Mn(o,l,!1,!1)):(c=Mn(i,l,!0,!0),h=Mn(l,o,!0,!0)):(c=Mn(l,i,!1,!0),h=Mn(o,l,!0,!1)),null!=s){return[c,h,go(p,l)]}return[c,h]},v={a:N,b:x,bias:w,preluActivationWeights:k},_={transposeA:n,transposeB:r,activation:a,leakyreluAlpha:i};if(null==s){const e=os(((e,t,n)=>{const r=Qt.runKernel("_FusedMatMul",v,_);return n([e,t,r]),{value:In(r,b),gradFunc:T}}));return e(N,x)}{const e=os(((e,t,n,r)=>{const s=Qt.runKernel("_FusedMatMul",v,_);return r([e,t,s,n]),{value:In(s,b),gradFunc:T}}));return e(N,x,w)}}})};const _o=rn({hammingWindow_:function(e){return ho(e,.54,.46)}});const So=rn({hannWindow_:function(e){return ho(e,.5,.5)}});const Eo=rn({frame_:function(e,t,n,r=!1,s=0){let a=0;const o=[];for(;a+t<=e.size;)o.push(Rn(e,a,t)),a+=n;if(r)for(;a<e.size;){const r=a+t-e.size,i=On([Rn(e,a,t-r),Zn([r],s)]);o.push(i),a+=n}return 0===o.length?Za([],[0,t]):In(On(o),[o.length,t])}});const Io=rn({stft_:function(e,t,n,r,s=So){null==r&&(r=co(t));const a=Eo(e,t,n),o=Cn(a,s(t));return Ba(o,r)}});const $o=rn({cropAndResize_:function(e,t,n,r,s="bilinear",a=0){const o=tn(e,"image","cropAndResize"),i=tn(t,"boxes","cropAndResize","float32"),u=tn(n,"boxInd","cropAndResize","int32"),p=i.shape[0];de(4===o.rank,(()=>`Error in cropAndResize: image must be rank 4,but got rank ${o.rank}.`)),de(2===i.rank&&4===i.shape[1],(()=>`Error in cropAndResize: boxes must be have size [${p},4] but had shape ${i.shape}.`)),de(1===u.rank&&u.shape[0]===p,(()=>`Error in cropAndResize: boxInd must be have size [${p}] but had shape ${i.shape}.`)),de(2===r.length,(()=>`Error in cropAndResize: cropSize must be of length 2, but got length ${r.length}.`)),de(r[0]>=1&&r[1]>=1,(()=>`cropSize must be atleast [1,1], but was ${r}`)),de("bilinear"===s||"nearest"===s,(()=>`method must be bilinear or nearest, but was ${s}`));const l={image:o,boxes:i,boxInd:u},c={method:s,extrapolationValue:a,cropSize:r};return Qt.runKernel("CropAndResize",l,c)}});const Do=rn({flipLeftRight_:function(e){const t=tn(e,"image","flipLeftRight","float32");de(4===t.rank,(()=>`Error in flipLeftRight: image must be rank 4,but got rank ${t.rank}.`));const n={image:t};return Qt.runKernel("FlipLeftRight",n,{})}});const Ao=rn({grayscaleToRGB_:function(e){const t=tn(e,"image","grayscaleToRGB"),n=t.rank-1,r=t.shape[n];de(t.rank>=2,(()=>`Error in grayscaleToRGB: images must be at least rank 2, but got rank ${t.rank}.`)),de(1===r,(()=>`Error in grayscaleToRGB: last dimension of a grayscale image should be size 1, but got size ${r}.`));const s=new Array(t.rank);return s.fill(1,0,n),s[n]=3,Ur(t,s)}});const Oo=rn({rotateWithOffset_:function(e,t,n=0,r=.5){const s=tn(e,"image","rotateWithOffset","float32");de(4===s.rank,(()=>`Error in rotateWithOffset: image must be rank 4,but got rank ${s.rank}.`));const a={image:s},o={radians:t,fillValue:n,center:r};return Qt.runKernel("RotateWithOffset",a,o)}});function Mo(e,t,n,r,s,a){null==r&&(r=.5),null==s&&(s=Number.NEGATIVE_INFINITY),null==a&&(a=0);const o=e.shape[0];return n=Math.min(n,o),de(0<=r&&r<=1,(()=>`iouThreshold must be in [0, 1], but was '${r}'`)),de(2===e.rank,(()=>`boxes must be a 2D tensor, but was of rank '${e.rank}'`)),de(4===e.shape[1],(()=>`boxes must have 4 columns, but 2nd dimension was ${e.shape[1]}`)),de(1===t.rank,(()=>"scores must be a 1D tensor")),de(t.shape[0]===o,(()=>`scores has incompatible shape with boxes. Expected ${o}, but was ${t.shape[0]}`)),de(0<=a&&a<=1,(()=>`softNmsSigma must be in [0, 1], but was '${a}'`)),{maxOutputSize:n,iouThreshold:r,scoreThreshold:s,softNmsSigma:a}}const Co=rn({nonMaxSuppression_:function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY){const a=tn(e,"boxes","nonMaxSuppression","float32"),o=tn(t,"scores","nonMaxSuppression","float32"),i=Mo(a,o,n,r,s),u={maxOutputSize:n=i.maxOutputSize,iouThreshold:r=i.iouThreshold,scoreThreshold:s=i.scoreThreshold};return Qt.runKernel("NonMaxSuppressionV3",{boxes:a,scores:o},u)}});function Fo(e,t,n){const r=function(e,t,n){return function(e,t,n){let r=0,s=e.length,a=0,o=!1;for(;r<s;){a=r+(s-r>>>1);const i=n(t,e[a]);i>0?r=a+1:(s=a,o=!i)}return o?r:-r-1}(e,t,n||Ro)}(e,t,n),s=r<0?-(r+1):r;e.splice(s,0,t)}function Ro(e,t){return e>t?1:e<t?-1:0}function zo(e,t,n,r,s,a,o=!1,i=!1,u=!1){const p=[];for(let e=0;e<t.length;e++)t[e]>s&&p.push({score:t[e],boxIndex:e,suppressBeginIndex:0});p.sort(Bo);const l=a>0?-.5/a:0,c=[],h=[];for(;c.length<n&&p.length>0;){const t=p.pop(),{score:n,boxIndex:a,suppressBeginIndex:o}=t;if(n<s)break;let i=!1;for(let n=c.length-1;n>=o;--n){const o=Vo(e,a,c[n]);if(o>=r){i=!0;break}if(t.score=t.score*Lo(r,l,o),t.score<=s)break}t.suppressBeginIndex=c.length,i||(t.score===n?(c.push(a),h.push(t.score)):t.score>s&&Fo(p,t,Bo))}const d=c.length,m=n-d;i&&m>0&&(c.push(...new Array(m).fill(0)),h.push(...new Array(m).fill(0)));const f={selectedIndices:c};return o&&(f.selectedScores=h),u&&(f.validOutputs=d),f}function Vo(e,t,n){const r=e.subarray(4*t,4*t+4),s=e.subarray(4*n,4*n+4),a=Math.min(r[0],r[2]),o=Math.min(r[1],r[3]),i=Math.max(r[0],r[2]),u=Math.max(r[1],r[3]),p=Math.min(s[0],s[2]),l=Math.min(s[1],s[3]),c=Math.max(s[0],s[2]),h=Math.max(s[1],s[3]),d=(i-a)*(u-o),m=(c-p)*(h-l);if(d<=0||m<=0)return 0;const f=Math.max(a,p),y=Math.max(o,l),g=Math.min(i,c),b=Math.min(u,h),N=Math.max(g-f,0)*Math.max(b-y,0);return N/(d+m-N)}function Lo(e,t,n){const r=Math.exp(t*n*n);return n<=e?r:0}function Bo(e,t){return e.score-t.score||e.score===t.score&&t.boxIndex-e.boxIndex}const Po=async function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY){const a=tn(e,"boxes","nonMaxSuppressionAsync"),o=tn(t,"scores","nonMaxSuppressionAsync"),i=Mo(a,o,n,r,s);n=i.maxOutputSize,r=i.iouThreshold,s=i.scoreThreshold;const u=await Promise.all([a.data(),o.data()]),p=u[0],l=u[1],{selectedIndices:c}=function(e,t,n,r,s){return zo(e,t,n,r,s,0)}(p,l,n,r,s);return a!==e&&a.dispose(),o!==t&&o.dispose(),Ga(c,"int32")};const Ko=rn({nonMaxSuppressionWithScore_:function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,a=0){const o=tn(e,"boxes","nonMaxSuppression"),i=tn(t,"scores","nonMaxSuppression"),u=Mo(o,i,n,r,s,a),p={boxes:o,scores:i},l={maxOutputSize:n=u.maxOutputSize,iouThreshold:r=u.iouThreshold,scoreThreshold:s=u.scoreThreshold,softNmsSigma:a=u.softNmsSigma},c=Qt.runKernel("NonMaxSuppressionV5",p,l);return{selectedIndices:c[0],selectedScores:c[1]}}});const qo=async function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,a=0){const o=tn(e,"boxes","nonMaxSuppressionAsync"),i=tn(t,"scores","nonMaxSuppressionAsync"),u=Mo(o,i,n,r,s,a);n=u.maxOutputSize,r=u.iouThreshold,s=u.scoreThreshold,a=u.softNmsSigma;const p=await Promise.all([o.data(),i.data()]),l=p[0],c=p[1],{selectedIndices:h,selectedScores:d}=function(e,t,n,r,s,a){return zo(e,t,n,r,s,a,!0)}(l,c,n,r,s,a);return o!==e&&o.dispose(),i!==t&&i.dispose(),{selectedIndices:Ga(h,"int32"),selectedScores:Ga(d)}};const Uo=rn({nonMaxSuppressionPadded_:function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,a=!1){const o=tn(e,"boxes","nonMaxSuppression"),i=tn(t,"scores","nonMaxSuppression"),u=Mo(o,i,n,r,s,null),p={boxes:o,scores:i},l={maxOutputSize:u.maxOutputSize,iouThreshold:u.iouThreshold,scoreThreshold:u.scoreThreshold,padToMaxOutputSize:a},c=Qt.runKernel("NonMaxSuppressionV4",p,l);return{selectedIndices:c[0],validOutputs:c[1]}}});const Wo=async function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,a=!1){const o=tn(e,"boxes","nonMaxSuppressionAsync"),i=tn(t,"scores","nonMaxSuppressionAsync"),u=Mo(o,i,n,r,s,null),p=u.maxOutputSize,l=u.iouThreshold,c=u.scoreThreshold,[h,d]=await Promise.all([o.data(),i.data()]),{selectedIndices:m,validOutputs:f}=function(e,t,n,r,s,a){return zo(e,t,n,r,s,0,!1,a,!0)}(h,d,p,l,c,a);return o!==e&&o.dispose(),i!==t&&i.dispose(),{selectedIndices:Ga(m,"int32"),validOutputs:Cr(f,"int32")}};const jo=rn({resizeBilinear_:function(e,t,n=!1,r=!1){const s=tn(e,"images","resizeBilinear");de(3===s.rank||4===s.rank,(()=>`Error in resizeBilinear: x must be rank 3 or 4, but got rank ${s.rank}.`)),de(2===t.length,(()=>`Error in resizeBilinear: new shape must 2D, but got shape ${t}.`)),de(!1===r||!1===n,(()=>"Error in resizeBilinear: If halfPixelCenters is true, alignCorners must be false."));let a=s,o=!1;3===s.rank&&(o=!0,a=In(s,[1,s.shape[0],s.shape[1],s.shape[2]]));const i={images:a},u={alignCorners:n,halfPixelCenters:r,size:t},p=Qt.runKernel("ResizeBilinear",i,u);return o?In(p,[p.shape[1],p.shape[2],p.shape[3]]):p}});const Ho=rn({resizeNearestNeighbor_:function(e,t,n=!1,r=!1){const s=tn(e,"images","resizeNearestNeighbor");de(3===s.rank||4===s.rank,(()=>`Error in resizeNearestNeighbor: x must be rank 3 or 4, but got rank ${s.rank}.`)),de(2===t.length,(()=>`Error in resizeNearestNeighbor: new shape must 2D, but got shape ${t}.`)),de("float32"===s.dtype||"int32"===s.dtype,(()=>"`images` must have `int32` or `float32` as dtype")),de(!1===r||!1===n,(()=>"Error in resizeNearestNeighbor: If halfPixelCenters is true, alignCorners must be false."));let a=s,o=!1;3===s.rank&&(o=!0,a=In(s,[1,s.shape[0],s.shape[1],s.shape[2]]));const i={images:a},u={alignCorners:n,halfPixelCenters:r,size:t},p=Qt.runKernel("ResizeNearestNeighbor",i,u);return o?In(p,[p.shape[1],p.shape[2],p.shape[3]]):p}});const Go=rn({threshold_:function(e,t="binary",n=!1,r=.5){const s=tn(e,"image","threshold"),a=s.shape[0]*s.shape[1];let o,i,u,p,l=Cn(Ga([r]),255);if(de(3===s.rank,(()=>`Error in threshold: image must be rank 3,but got rank ${s.rank}.`)),de(3===s.shape[2]||1===s.shape[2],(()=>`Error in threshold: image color channel must be equal to 3 or 1but got ${s.shape[2]}.`)),de("int32"===s.dtype||"float32"===s.dtype,(()=>`Error in dtype: image dtype must be int32 or float32,but got dtype ${s.dtype}.`)),de("otsu"===t||"binary"===t,(()=>`Method must be binary or otsu, but was ${t}`)),3===s.shape[2]){[o,i,u]=La(s,[1,1,1],-1);const e=Cn(o,.2989),t=Cn(i,.587),n=Cn(u,.114);p=un(un(e,t),n)}else p=e;if("otsu"===t){l=function(e,t){let n,r,s,a,o,i,u=Ga([-1]),p=Ga([0]),l=Ga([0]);for(let c=0;c<e.size-1;c++){n=Rn(e,0,c+1),r=Rn(e,c+1),o=Nr(zr(n),t),i=Nr(zr(r),t);const h=zr(Cn(n,da(0,n.size)));s=Nr(h,zr(n));const d=Zn(r.shape,n.size),m=un(da(0,r.size),d),f=Cn(r,m);a=Nr(zr(f),zr(r));const y=ls(s,a),g=ls(s,a),b=Cn(o,i);l=Cn(Cn(b,y),g);const N=Gr(l,p);p=kr(N,l,p),u=kr(N,Ga([c]),u)}return u}(Un(Nn(Ta(p),"int32"),Ha([]),256),a)}const c=n?ns(p,l):Gr(p,l);return Nn(Cn(c,255),"int32")}});const Zo=rn({transform_:function(e,t,n="nearest",r="constant",s=0,a){const o=tn(e,"image","transform","float32"),i=tn(t,"transforms","transform","float32");de(4===o.rank,(()=>`Error in transform: image must be rank 4,but got rank ${o.rank}.`)),de(2===i.rank&&(i.shape[0]===o.shape[0]||1===i.shape[0])&&8===i.shape[1],(()=>"Error in transform: Input transform should be batch x 8 or 1 x 8")),de(null==a||2===a.length,(()=>`Error in transform: outputShape must be [height, width] or null, but got ${a}.`));const u={image:o,transforms:i},p={interpolation:n,fillMode:r,fillValue:s,outputShape:a};return Qt.runKernel("Transform",u,p)}});const Qo=rn({bandPart_:function(e,t,n){const r=tn(e,"a","bandPart");de(r.rank>=2,(()=>`bandPart(): Rank must be at least 2, got ${r.rank}.`));const s=r.shape,[a,o]=r.shape.slice(-2);let i,u;"number"==typeof t?(de(t%1==0,(()=>`bandPart(): numLower must be an integer, got ${t}.`)),de(t<=a,(()=>`bandPart(): numLower (${t}) must not be greater than the number of rows (${a}).`)),i=tn(t<0?a:t,"numLower","bandPart")):(de("int32"===t.dtype,(()=>"bandPart(): numLower's dtype must be an int32.")),i=kr(ts(t,0),a,_s(t,a))),"number"==typeof n?(de(n%1==0,(()=>`bandPart(): numUpper must be an integer, got ${n}.`)),de(n<=o,(()=>`bandPart(): numUpper (${n}) must not be greater than the number of columns (${o}).`)),u=tn(n<0?o:n,"numUpper","bandPart")):(de("int32"===n.dtype,(()=>"bandPart(): numUpper's dtype must be an int32.")),u=kr(ts(n,0),o,_s(n,o)));const p=In(da(0,a,1,"int32"),[-1,1]),l=da(0,o,1,"int32"),c=ls(p,l),h=ds(ns(c,i),Zr(c,is(u))),d=Ts([a,o],r.dtype);return In(qa(no(In(r,[-1,a,o])).map((e=>kr(h,e,d)))),s)}});const Yo=rn({gramSchmidt_:function(e){let t;if(Array.isArray(e)){t=!1,de(null!=e&&e.length>0,(()=>"Gram-Schmidt process: input must not be null, undefined, or empty"));const n=e[0].shape[0];for(let t=1;t<e.length;++t)de(e[t].shape[0]===n,(()=>`Gram-Schmidt: Non-unique lengths found in the input vectors: (${e[t].shape[0]} vs. ${n})`))}else t=!0,e=La(e,e.shape[0],0).map((e=>Ka(e,[0])));de(e.length<=e[0].shape[0],(()=>`Gram-Schmidt: Number of vectors (${e.length}) exceeds number of dimensions (${e[0].shape[0]}).`));const n=[],r=e;for(let t=0;t<e.length;++t)n.push(Qt.tidy((()=>{let e=r[t];if(t>0)for(let r=0;r<t;++r){const t=Cn(zr(Cn(n[r],e)),n[r]);e=ls(e,t)}return Nr(e,Lr(e,"euclidean"))})));return t?qa(n,0):n}});function Xo(e,t=!1){return Qt.tidy((()=>{de(2===e.shape.length,(()=>`qr2d() requires a 2D Tensor, but got a ${e.shape.length}D Tensor.`));const n=e.shape[0],r=e.shape[1];let s=Wr(n),a=An(e);const o=Za([[1]],[1,1]);let i=An(o);const u=n>=r?r:n;for(let e=0;e<u;++e){const t=a,u=i,p=s;[i,a,s]=Qt.tidy((()=>{const t=Rn(a,[e,e],[n-e,1]),u=Lr(t),p=Rn(a,[e,e],[1,1]),l=kr(Gr(p,0),Za([[-1]]),Za([[1]])),c=ls(p,Cn(l,u)),h=Nr(t,c);i=1===h.shape[0]?An(o):On([o,Rn(h,[1,0],[h.shape[0]-1,h.shape[1]])],0);const d=is(Nr(Mn(l,c),u)),m=Rn(a,[e,0],[n-e,r]),f=Cn(d,i),y=ao(i);if(0===e)a=ls(m,Mn(f,Mn(y,m)));else{const t=ls(m,Mn(f,Mn(y,m)));a=On([Rn(a,[0,0],[e,r]),t],0)}const g=ao(f),b=Rn(s,[0,e],[n,s.shape[1]-e]);if(0===e)s=ls(b,Mn(Mn(b,i),g));else{const t=ls(b,Mn(Mn(b,i),g));s=On([Rn(s,[0,0],[n,e]),t],1)}return[i,a,s]})),Wt([t,u,p]).forEach((e=>e.dispose()))}return!t&&n>r&&(s=Rn(s,[0,0],[n,r]),a=Rn(a,[0,0],[r,r])),[s,a]}))}const Jo=rn({qr_:function(e,t=!1){if(de(e.rank>=2,(()=>`qr() requires input tensor to have a rank >= 2, but got rank ${e.rank}`)),2===e.rank)return Xo(e,t);{const n=e.shape.slice(0,e.shape.length-2).reduce(((e,t)=>e*t)),r=no(In(e,[n,e.shape[e.shape.length-2],e.shape[e.shape.length-1]]),0),s=[],a=[];r.forEach((e=>{const[n,r]=Xo(e,t);s.push(n),a.push(r)}));return[In(qa(s,0),e.shape),In(qa(a,0),e.shape)]}}});var ei;!function(e){e[e.NONE=0]="NONE",e[e.MEAN=1]="MEAN",e[e.SUM=2]="SUM",e[e.SUM_BY_NONZERO_WEIGHTS=3]="SUM_BY_NONZERO_WEIGHTS"}(ei||(ei={}));const ti=rn({computeWeightedLoss_:function(e,t,n=ei.SUM_BY_NONZERO_WEIGHTS){const r=tn(e,"losses","computeWeightedLoss");let s=null;null!=t&&(s=tn(t,"weights","computeWeightedLoss"));const a=null==s?r:Cn(r,s);if(n===ei.NONE)return a;if(n===ei.SUM)return zr(a);if(n===ei.MEAN){if(null==s)return ks(a);{const e=r.size/s.size,t=Nr(zr(a),zr(s));return e>1?Nr(t,Cr(e)):t}}if(n===ei.SUM_BY_NONZERO_WEIGHTS){if(null==s)return Nr(zr(a),Cr(r.size));{const e=Cn(s,vs(r.shape)),t=Nn(zr(As(e,Cr(0))),"float32");return Nr(zr(a),t)}}throw Error(`Unknown reduction: ${n}`)}});const ni=rn({absoluteDifference_:function(e,t,n,r=ei.SUM_BY_NONZERO_WEIGHTS){const s=tn(e,"labels","absoluteDifference"),a=tn(t,"predictions","absoluteDifference");let o=null;null!=n&&(o=tn(n,"weights","absoluteDifference")),me(s.shape,a.shape,"Error in absoluteDifference: ");const i=sn(ls(s,a));return ti(i,o,r)}});const ri=rn({cosineDistance_:function(e,t,n,r,s=ei.SUM_BY_NONZERO_WEIGHTS){const a=tn(e,"labels","cosineDistance"),o=tn(t,"predictions","cosineDistance");let i=null;null!=r&&(i=tn(r,"weights","cosineDistance")),me(a.shape,o.shape,"Error in cosineDistance: ");const u=Cr(1),p=ls(u,zr(Cn(a,o),n,!0));return ti(p,i,s)}});const si=rn({hingeLoss_:function(e,t,n,r=ei.SUM_BY_NONZERO_WEIGHTS){let s=tn(e,"labels","hingeLoss");const a=tn(t,"predictions","hingeLoss");let o=null;null!=n&&(o=tn(n,"weights","hingeLoss")),me(s.shape,a.shape,"Error in hingeLoss: ");const i=Cr(1);s=ls(Cn(Cr(2),s),i);const u=ya(ls(i,Cn(s,a)));return ti(u,o,r)}});const ai=rn({huberLoss_:function(e,t,n,r=1,s=ei.SUM_BY_NONZERO_WEIGHTS){const a=tn(e,"labels","huberLoss"),o=tn(t,"predictions","huberLoss");let i=null;null!=n&&(i=tn(n,"weights","huberLoss")),me(a.shape,o.shape,"Error in huberLoss: ");const u=Cr(r),p=sn(ls(o,a)),l=_s(p,u),c=ls(p,l),h=un(Cn(Cr(.5),Rr(l)),Cn(u,c));return ti(h,i,s)}});const oi=rn({logLoss_:function(e,t,n,r=1e-7,s=ei.SUM_BY_NONZERO_WEIGHTS){const a=tn(e,"labels","logLoss"),o=tn(t,"predictions","logLoss");let i=null;null!=n&&(i=tn(n,"weights","logLoss")),me(a.shape,o.shape,"Error in logLoss: ");const u=Cr(1),p=Cr(r),l=is(Cn(a,ss(un(o,p)))),c=Cn(ls(u,a),ss(un(ls(u,o),p))),h=ls(l,c);return ti(h,i,s)}});const ii=rn({meanSquaredError_:function(e,t,n,r=ei.SUM_BY_NONZERO_WEIGHTS){const s=tn(e,"labels","meanSquaredError"),a=tn(t,"predictions","meanSquaredError");let o=null;null!=n&&(o=tn(n,"weights","meanSquaredError")),me(s.shape,a.shape,"Error in meanSquaredError: ");const i=Pa(s,a);return ti(i,o,r)}});const ui=rn({sigmoidCrossEntropy_:function(e,t,n,r=0,s=ei.SUM_BY_NONZERO_WEIGHTS){let a=tn(e,"multiClassLabels","sigmoidCrossEntropy");const o=tn(t,"logits","sigmoidCrossEntropy");let i=null;if(null!=n&&(i=tn(n,"weights","sigmoidCrossEntropy")),me(a.shape,o.shape,"Error in sigmoidCrossEntropy: "),r>0){const e=Cr(r),t=Cr(1),n=Cr(.5);a=un(Cn(a,ls(t,e)),Cn(n,e))}const u=function(e,t){const n=tn(e,"labels","sigmoidCrossEntropyWithLogits"),r=tn(t,"logits","sigmoidCrossEntropyWithLogits");me(n.shape,r.shape,"Error in sigmoidCrossEntropyWithLogits: ");const s=ya(r),a=Cn(r,n),o=as(Pr(is(sn(r))));return un(ls(s,a),o)}(a,o);return ti(u,i,s)}});const pi=rn({softmaxCrossEntropy_:function(e,t,n,r=0,s=ei.SUM_BY_NONZERO_WEIGHTS){let a=tn(e,"onehotLabels","softmaxCrossEntropy");const o=tn(t,"logits","softmaxCrossEntropy");let i=null;if(null!=n&&(i=tn(n,"weights","softmaxCrossEntropy")),me(a.shape,o.shape,"Error in softmaxCrossEntropy: "),r>0){const e=Cr(r),t=Cr(1),n=Cr(a.shape[1]);a=un(Cn(a,ls(t,e)),Nr(e,n))}const u=function(e,t,n=-1){if(-1===n&&(n=t.rank-1),n!==t.rank-1)throw Error(`Softmax cross entropy along a non-last dimension is not yet supported. Labels / logits was rank ${t.rank} and dim was ${n}`);const r=os(((e,t,r)=>{const s=hs(t,[n],!0),a=ls(Nn(t,"float32"),s);r([e,a]);const o=is(Cn(a,e));return{value:zr(o,[n]),gradFunc:(e,t)=>{const[r,s]=t,a=$r(e.shape,[n]);return[Cn(In(e,a),ls(Nn(r,"float32"),Pr(s))),Cn(In(e,a),ls(Pr(s),Nn(r,"float32")))]}}}));return r(e,t)}(a,o);return ti(u,i,s)}});const li=rn({sparseFillEmptyRows_:function(e,t,n,r){const s=tn(e,"indices","sparseFillEmptyRows","int32"),a=tn(t,"values","sparseFillEmptyRows"),o=tn(n,"denseShape","sparseFillEmptyRows","int32"),i=tn(r,"defaultValue","sparseFillEmptyRows",a.dtype);if(2!==s.rank)throw new Error(`Indices should be Tensor2D but received shape\n        ${s.shape}`);if(1!==a.rank)throw new Error(`Values should be Tensor1D but received shape ${a.shape}`);if(1!==o.rank)throw new Error(`Dense shape should be Tensor1D but received shape ${o.shape}`);if(0!==i.rank)throw new Error(`Default value should be a scalar but received shape ${i.shape}`);const u={indices:s,values:a,denseShape:o,defaultValue:i},p=Qt.runKernel("SparseFillEmptyRows",u);return{outputIndices:p[0],outputValues:p[1],emptyRowIndicator:p[2],reverseIndexMap:p[3]}}});const ci=rn({sparseReshape_:function(e,t,n){const r=tn(e,"inputIndices","sparseReshape","int32"),s=tn(t,"inputShape","sparseReshape","int32"),a=tn(n,"newShape","sparseReshape","int32");if(2!==r.rank)throw new Error(`Input indices should be Tensor2D but received shape\n        ${r.shape}`);if(1!==s.rank)throw new Error(`Input shape should be Tensor1D but received shape ${s.shape}`);if(1!==a.rank)throw new Error(`New shape should be Tensor1D but received shape ${a.shape}`);const o={inputIndices:r,inputShape:s,newShape:a},i=Qt.runKernel("SparseReshape",o);return{outputIndices:i[0],outputShape:i[1]}}});const hi=rn({sparseSegmentMean_:function(e,t,n){const r=tn(e,"data","sparseSegmentMean"),s=tn(t,"indices","sparseSegmentMean","int32"),a=tn(n,"segmentIds","sparseSegmentMean","int32");if(r.rank<1)throw new Error("Data should be at least 1 dimensional but received scalar");if(1!==s.rank)throw new Error(`Indices should be Tensor1D but received shape\n          ${s.shape}`);if(1!==a.rank)throw new Error(`Segment ids should be Tensor1D but received shape\n          ${a.shape}`);const o={data:r,indices:s,segmentIds:a};return Qt.runKernel("SparseSegmentMean",o)}});const di=rn({sparseSegmentSum_:function(e,t,n){const r=tn(e,"data","sparseSegmentSum"),s=tn(t,"indices","sparseSegmentSum","int32"),a=tn(n,"segmentIds","sparseSegmentSum","int32");if(r.rank<1)throw new Error("Data should be at least 1 dimensional but received scalar");if(1!==s.rank)throw new Error(`Indices should be Tensor1D but received shape\n         ${s.shape}`);if(1!==a.rank)throw new Error(`Segment ids should be Tensor1D but received shape\n         ${a.shape}`);const o={data:r,indices:s,segmentIds:a};return Qt.runKernel("SparseSegmentSum",o)}});const mi=rn({stringNGrams_:function(e,t,n,r,s,a,o,i){const u=tn(e,"data","stringNGrams","string");if("string"!==u.dtype)throw new Error("Data must be of datatype string");if(1!==u.shape.length)throw new Error(`Data must be a vector, saw: ${u.shape}`);const p=tn(t,"dataSplits","stringNGrams");if("int32"!==p.dtype)throw new Error("Data splits must be of datatype int32");const l={separator:n,nGramWidths:r,leftPad:s,rightPad:a,padWidth:o,preserveShortSequences:i},c={data:u,dataSplits:p},h=Qt.runKernel("StringNGrams",c,l);return{nGrams:h[0],nGramsSplits:h[1]}}});var fi={__proto__:null,abs:sn,acos:an,acosh:on,add:un,addN:pn,all:ln,any:cn,argMax:hn,argMin:dn,asin:mn,asinh:fn,atan:yn,atan2:gn,atanh:bn,avgPool:$n,avgPool3d:Dn,basicLSTMCell:Vn,batchToSpaceND:Ln,batchNorm:Bn,batchNorm2d:Pn,batchNorm3d:Kn,batchNorm4d:qn,bincount:Un,broadcastArgs:Wn,broadcastTo:jn,buffer:Hn,cast:Nn,ceil:Gn,clipByValue:Qn,clone:An,complex:Yn,concat:On,concat1d:Xn,concat2d:Jn,concat3d:er,concat4d:tr,conv1d:rr,conv2d:nr,conv2dTranspose:ar,conv3d:or,conv3dTranspose:ur,cos:pr,cosh:lr,cumprod:cr,cumsum:hr,denseBincount:dr,depthToSpace:mr,depthwiseConv2d:fr,diag:yr,dilation2d:gr,div:Nr,divNoNan:vr,dot:_r,einsum:Sr,elu:Er,equal:wr,erf:Ir,euclideanNorm:Br,exp:Pr,expandDims:Kr,expm1:qr,eye:Wr,fill:Zn,floor:jr,floorDiv:br,gather:Hr,greater:Gr,greaterEqual:Zr,imag:Qr,isFinite:Yr,isInf:Xr,isNaN:Jr,leakyRelu:es,less:ts,lessEqual:ns,linspace:function(e,t,n){if(n<=0)throw new Error("The number of values should be positive.");const r={start:e,stop:t,num:n};return Qt.runKernel("LinSpace",{},r)},localResponseNormalization:rs,log:ss,log1p:as,logSigmoid:ps,logSoftmax:cs,logSumExp:hs,logicalAnd:ds,logicalNot:ms,logicalOr:fs,logicalXor:ys,lowerBound:function(e,t){return gs(e,t,"left")},matMul:Mn,max:Dr,maxPool:bs,maxPool3d:Ns,maxPoolWithArgmax:xs,maximum:ws,mean:ks,meshgrid:function(e,t,{indexing:n="xy"}={}){if("xy"!==n&&"ij"!==n)throw new TypeError(`${n} is not a valid third argument to meshgrid`);if(void 0===e)return[];let r=tn(e,"x","meshgrid",e instanceof Ct?e.dtype:"float32");if(void 0===t)return[r];let s=tn(t,"y","meshgrid",t instanceof Ct?t.dtype:"float32");const a=ye(r.shape),o=ye(s.shape);return"xy"===n?(r=In(r,[1,-1]),s=In(s,[-1,1]),[Mn(vs([o,1],r.dtype),r),Mn(s,vs([1,a],s.dtype))]):(r=In(r,[-1,1]),s=In(s,[1,-1]),[Mn(r,vs([1,o],r.dtype)),Mn(vs([a,1],s.dtype),s)])},min:Ar,minimum:_s,mirrorPad:Ss,mod:Es,moments:Is,mul:Cn,multiRNNCell:$s,multinomial:Ds,neg:is,notEqual:As,oneHot:Os,ones:vs,onesLike:Ms,outerProduct:Cs,pad:Fs,pad1d:Rs,pad2d:zs,pad3d:Vs,pad4d:Ls,pool:Ps,pow:Or,prelu:Ks,print:function(e,t=!1){console.log(e.toString(t))},prod:qs,raggedGather:Us,raggedRange:Ws,raggedTensorToTensor:js,rand:Hs,randomGamma:pa,randomNormal:la,randomStandardNormal:ca,randomUniform:ha,range:da,real:ma,reciprocal:fa,relu:ya,relu6:ga,reshape:In,reverse:ba,reverse1d:Na,reverse2d:xa,reverse3d:wa,reverse4d:ka,round:Ta,rsqrt:va,scalar:Cr,selu:_a,separableConv2d:Sa,setdiff1dAsync:Ea,sigmoid:Fn,sign:Ia,sin:$a,sinh:Da,slice:Rn,slice1d:Aa,slice2d:Oa,slice3d:Ma,slice4d:Ca,softmax:Fa,softplus:us,spaceToBatchND:Bs,fft:Ra,ifft:za,irfft:Va,rfft:Ba,split:La,sqrt:Fr,square:Rr,squaredDifference:Pa,squeeze:Ka,stack:qa,step:Ua,stridedSlice:Wa,sub:ls,sum:zr,tan:ja,tanh:zn,tensor:Ha,tensor1d:Ga,tensor2d:Za,tensor3d:function(e,t,n){if(fe(e),null!=t&&3!==t.length)throw new Error("tensor3d() requires shape to have three numbers");const r=Xt(e,n);if(3!==r.length&&1!==r.length)throw new Error("tensor3d() requires values to be number[][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor3d() requires shape to be provided when `values` are a flat array");return Mr(e,t,r,n)},tensor4d:function(e,t,n){if(fe(e),null!=t&&4!==t.length)throw new Error("tensor4d() requires shape to have four numbers");const r=Xt(e,n);if(4!==r.length&&1!==r.length)throw new Error("tensor4d() requires values to be number[][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor4d() requires shape to be provided when `values` are a flat array");return Mr(e,t,r,n)},tensor5d:function(e,t,n){if(fe(e),null!=t&&5!==t.length)throw new Error("tensor5d() requires shape to have five numbers");const r=Xt(e,n);if(5!==r.length&&1!==r.length)throw new Error("tensor5d() requires values to be number[][][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor5d() requires shape to be provided when `values` are a flat array");return Mr(e,t,r,n)},tensor6d:function(e,t,n){if(fe(e),null!=t&&6!==t.length)throw new Error("tensor6d() requires shape to have six numbers");const r=Xt(e,n);if(6!==r.length&&1!==r.length)throw new Error("tensor6d() requires values to be number[][][][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor6d() requires shape to be provided when `values` are a flat array");return Mr(e,t=t||r,r,n)},tensorScatterUpdate:Ya,tile:Ur,topk:Xa,truncatedNormal:Ja,unique:eo,unsortedSegmentSum:to,unstack:no,upperBound:function(e,t){return gs(e,t,"right")},variable:function(e,t=!0,n,r){return Qt.makeVariable(e,t,n,r)},where:kr,whereAsync:ro,zeros:Ts,zerosLike:Tr,op:rn,OP_SCOPE_SUFFIX:"__op",booleanMaskAsync:so,transpose:ao,norm:Lr,movingAverage:oo,scatterND:io,searchSorted:gs,sparseToDense:uo,gatherND:po,dropout:lo,enclosingPowerOfTwo:co,cosineWindow:ho,inTopKAsync:mo,image:{flipLeftRight:Do,grayscaleToRGB:Ao,resizeNearestNeighbor:Ho,resizeBilinear:jo,rotateWithOffset:Oo,cropAndResize:$o,nonMaxSuppression:Co,nonMaxSuppressionAsync:Po,nonMaxSuppressionWithScore:Ko,nonMaxSuppressionWithScoreAsync:qo,nonMaxSuppressionPadded:Uo,nonMaxSuppressionPaddedAsync:Wo,threshold:Go,transform:Zo},linalg:{bandPart:Qo,gramSchmidt:Yo,qr:Jo},losses:{absoluteDifference:ni,computeWeightedLoss:ti,cosineDistance:ri,hingeLoss:si,huberLoss:ai,logLoss:oi,meanSquaredError:ii,sigmoidCrossEntropy:ui,softmaxCrossEntropy:pi},spectral:{fft:Ra,ifft:za,rfft:Ba,irfft:Va},fused:vo,signal:{hammingWindow:_o,hannWindow:So,frame:Eo,stft:Io},sparse:{sparseFillEmptyRows:li,sparseReshape:ci,sparseSegmentMean:hi,sparseSegmentSum:di},string:{stringNGrams:mi,stringSplit:rn({stringSplit_:function(e,t,n=!0){const r=tn(e,"input","stringSplit","string"),s=tn(t,"delimiter","stringSplit","string");if(1!==r.rank)throw new Error(`Input should be Tensor1D but received shape ${r.shape}`);if(0!==s.rank)throw new Error(`Delimiter should be a scalar but received shape ${s.shape}`);const a={skipEmpty:n},o={input:r,delimiter:s},i=Qt.runKernel("StringSplit",o,a);return{indices:i[0],values:i[1],shape:i[2]}}}),stringToHashBucketFast:rn({stringToHashBucketFast_:function(e,t){const n=tn(e,"input","stringToHashBucketFast","string"),r={numBuckets:t};if(t<=0)throw new Error("Number of buckets must be at least 1");const s={input:n};return Qt.runKernel("StringToHashBucketFast",s,r)}}),staticRegexReplace:rn({staticRegexReplace_:function(e,t,n,r=!0){const s=tn(e,"input","staticRegexReplace","string"),a={pattern:t,rewrite:n,replaceGlobal:r};return Qt.runKernel("StaticRegexReplace",{x:s},a)}})}};function yi(e,t,r=""){if("number"!=typeof e&&"number"!=typeof t){n.assert(e.length===t.length,(()=>r+` Shapes ${e} and ${t} must match`));for(let s=0;s<e.length;s++){const a=e[s],o=t[s];n.assert(a<0||o<0||a===o,(()=>r+` Shapes ${e} and ${t} must match`))}}}function gi(e){return"number"!=typeof e&&!e.some((e=>e<0))}function bi(e,t,n){let r=Ni(e,n);const s=!gi(r);if(s&&0===t.length)throw new Error(`Tried to calculate elements of an empty list with non-fully-defined elementShape: ${r}`);if(s&&t.forEach((e=>{r=Ni(e.shape,r)})),!gi(r))throw new Error(`Non-fully-defined elementShape: ${r}`);return r}function Ni(e,t){if("number"==typeof e)return t;if("number"==typeof t)return e;if(e.length!==t.length)throw new Error(`Incompatible ranks during merge: ${e} vs. ${t}`);const n=[];for(let r=0;r<e.length;++r){const s=e[r],a=t[r];if(s>=0&&a>=0&&s!==a)throw new Error(`Incompatible shape during merge: ${e} vs. ${t}`);n[r]=s>=0?s:a}return n}class xi{constructor(e,t,n,r,o,i,u){this.name=e,this.dtype=t,this.maxSize=n,this.elementShape=r,this.identicalElementShapes=o,this.dynamicSize=i,this.clearAfterRead=u,this.tensors=[],this.closed_=!1,this.idTensor=s(0),a(this.idTensor)}get id(){return this.idTensor.id}get closed(){return this.closed_}clearAndClose(e){this.tensors.forEach((t=>{null!=e&&e.has(t.tensor.id)||t.tensor.dispose()})),this.tensors=[],this.closed_=!0,this.idTensor.dispose()}size(){return this.tensors.length}read(e){if(this.closed_)throw new Error(`TensorArray ${this.name} has already been closed.`);if(e<0||e>=this.size())throw new Error(`Tried to read from index ${e}, but array size is: ${this.size()}`);const t=this.tensors[e];if(t.cleared)throw new Error(`TensorArray ${this.name}: Could not read index ${e} twice because it was cleared after a previous read (perhaps try setting clear_after_read = false?).`);return this.clearAfterRead&&(t.cleared=!0),t.read=!0,t.tensor}readMany(e){return e.map((e=>this.read(e)))}write(e,t){if(this.closed_)throw new Error(`TensorArray ${this.name} has already been closed.`);if(e<0||!this.dynamicSize&&e>=this.maxSize)throw new Error(`Tried to write to index ${e}, but array is not resizeable and size is: ${this.maxSize}`);const n=this.tensors[e]||{};if(t.dtype!==this.dtype)throw new Error(`TensorArray ${this.name}: Could not write to TensorArray index ${e},\n          because the value dtype is ${t.dtype}, but TensorArray dtype is ${this.dtype}.`);if(0!==this.size()||null!=this.elementShape&&0!==this.elementShape.length||(this.elementShape=t.shape),yi(this.elementShape,t.shape,`TensorArray ${this.name}: Could not write to TensorArray index ${e}.`),n.read)throw new Error(`TensorArray ${this.name}: Could not write to TensorArray index ${e}, because it has already been read.`);if(n.written)throw new Error(`TensorArray ${this.name}: Could not write to TensorArray index ${e}, because it has already been written.`);n.tensor=t,a(t),n.written=!0,this.tensors[e]=n}writeMany(e,t){if(e.length!==t.length)throw new Error(`TensorArray ${this.name}: could not write multiple tensors,because the index size: ${e.length} is not the same as tensors size: ${t.length}.`);e.forEach(((e,n)=>this.write(e,t[n])))}gather(e,t){if(t&&t!==this.dtype)throw new Error(`TensorArray dtype is ${this.dtype} but gather requested dtype ${t}`);if(e)e=e.slice(0,this.size());else{e=[];for(let t=0;t<this.size();t++)e.push(t)}if(0===e.length)return o([],[0].concat(this.elementShape));const n=this.readMany(e);return yi(this.elementShape,n[0].shape,"TensorArray shape mismatch: "),i(n,0)}concat(e){if(e&&e!==this.dtype)throw new Error(`TensorArray dtype is ${this.dtype} but concat requested dtype ${e}`);if(0===this.size())return o([],[0].concat(this.elementShape));const t=[];for(let e=0;e<this.size();e++)t.push(e);const n=this.readMany(t);return yi(this.elementShape,n[0].shape,`TensorArray shape mismatch: tensor array shape (${this.elementShape}) vs first tensor shape (${n[0].shape})`),u(n,0)}scatter(e,t){if(t.dtype!==this.dtype)throw new Error(`TensorArray dtype is ${this.dtype} but tensor has dtype ${t.dtype}`);if(e.length!==t.shape[0])throw new Error(`Expected len(indices) == tensor.shape[0], but saw: ${e.length} vs. ${t.shape[0]}`);const n=Math.max(...e);if(!this.dynamicSize&&n>=this.maxSize)throw new Error(`Max index must be < array size (${n}  vs. ${this.maxSize})`);this.writeMany(e,p(t,0))}split(e,t){if(t.dtype!==this.dtype)throw new Error(`TensorArray dtype is ${this.dtype} but tensor has dtype ${t.dtype}`);let n=0;const r=e.map((e=>(n+=e,n)));if(n!==t.shape[0])throw new Error(`Expected sum of lengths to be equal to\n          tensor.shape[0], but sum of lengths is\n        ${n}, and tensor's shape is: ${t.shape}`);if(!this.dynamicSize&&e.length!==this.maxSize)throw new Error(`TensorArray's size is not equal to the size of lengths (${this.maxSize} vs. ${e.length}), and the TensorArray is not marked as dynamically resizeable`);const s=0===n?0:t.size/n,a=[];l((()=>{t=c(t,[1,n,s]);for(let n=0;n<e.length;++n){const o=[0,0===n?0:r[n-1],0],i=[1,e[n],s];a[n]=c(h(t,o,i),this.elementShape)}return a}));const o=[];for(let t=0;t<e.length;t++)o[t]=t;this.writeMany(o,a)}}class wi{get id(){return this.idTensor.id}constructor(e,t,n,r=-1){this.tensors=e,this.elementShape=t,this.elementDtype=n,null!=e&&e.forEach((e=>{if(n!==e.dtype)throw new Error(`Invalid data types; op elements ${n}, but list elements ${e.dtype}`);yi(t,e.shape,"TensorList shape mismatch: "),a(e)})),this.idTensor=s(0),this.maxNumElements=r,a(this.idTensor)}copy(){return new wi([...this.tensors],this.elementShape,this.elementDtype)}clearAndClose(e){this.tensors.forEach((t=>{null!=e&&e.has(t.id)||t.dispose()})),this.tensors.length=0,this.idTensor.dispose()}size(){return this.tensors.length}stack(e,t,n=-1){if(t!==this.elementDtype)throw new Error(`Invalid data types; op elements ${t}, but list elements ${this.elementDtype}`);if(-1!==n&&this.tensors.length!==n)throw new Error(`Operation expected a list with ${n} elements but got a list with ${this.tensors.length} elements.`);yi(e,this.elementShape,"TensorList shape mismatch: ");const r=bi(this.elementShape,this.tensors,e);return l((()=>{const e=this.tensors.map((e=>c(e,r)));return i(e,0)}))}popBack(e,t){if(t!==this.elementDtype)throw new Error(`Invalid data types; op elements ${t}, but list elements ${this.elementDtype}`);if(0===this.size())throw new Error("Trying to pop from an empty list.");const n=bi(this.elementShape,this.tensors,e),r=this.tensors.pop();return r.kept=!1,yi(r.shape,e,"TensorList shape mismatch: "),c(r,n)}pushBack(e){if(e.dtype!==this.elementDtype)throw new Error(`Invalid data types; op elements ${e.dtype}, but list elements ${this.elementDtype}`);if(yi(e.shape,this.elementShape,"TensorList shape mismatch: "),this.maxNumElements===this.size())throw new Error("Trying to push element into a full list.");a(e),this.tensors.push(e)}resize(e){if(e<0)throw new Error(`TensorListResize expects size to be non-negative. Got: ${e}`);if(-1!==this.maxNumElements&&e>this.maxNumElements)throw new Error(`TensorListResize input size ${e} is greater maxNumElement ${this.maxNumElements}.`);const t=new wi([],this.elementShape,this.elementDtype,this.maxNumElements);t.tensors.length=e;for(let n=0;n<Math.min(this.tensors.length,e);++n)t.tensors[n]=this.tensors[n];return t}getItem(e,t,n){if(n!==this.elementDtype)throw new Error(`Invalid data types; op elements ${n}, but list elements ${this.elementDtype}`);if(e<0||e>this.tensors.length)throw new Error(`Trying to access element ${e} in a list with ${this.tensors.length} elements.`);if(null==this.tensors[e])throw new Error(`element at index ${e} is null.`);yi(this.tensors[e].shape,t,"TensorList shape mismatch: ");const r=bi(this.elementShape,this.tensors,t);return c(this.tensors[e],r)}setItem(e,t){if(t.dtype!==this.elementDtype)throw new Error(`Invalid data types; op elements ${t.dtype}, but list elements ${this.elementDtype}`);if(e<0||-1!==this.maxNumElements&&e>=this.maxNumElements)throw new Error(`Trying to set element ${e} in a list with max ${this.maxNumElements} elements.`);yi(this.elementShape,t.shape,"TensorList shape mismatch: "),a(t),null!=this.tensors[e]&&(this.tensors[e].kept=!1),this.tensors[e]=t}gather(e,t,n){if(t!==this.elementDtype)throw new Error(`Invalid data types; op elements ${t}, but list elements ${this.elementDtype}`);yi(this.elementShape,n,"TensorList shape mismatch: "),e=e.slice(0,this.size());const r=bi(this.elementShape,this.tensors,n);return 0===e.length?o([],[0].concat(r)):l((()=>{const t=e.map((e=>c(this.tensors[e],r)));return i(t,0)}))}concat(e,t){if(e&&e!==this.elementDtype)throw new Error(`TensorList dtype is ${this.elementDtype} but concat requested dtype ${e}`);yi(this.elementShape,t,"TensorList shape mismatch: ");const n=bi(this.elementShape,this.tensors,t);return 0===this.size()?o([],[0].concat(n)):l((()=>{const e=this.tensors.map((e=>c(e,n)));return u(e,0)}))}}const ki=async(e,t,n)=>{switch(e.op){case"If":case"StatelessIf":{const r=T("thenBranch",e,t,n),s=T("elseBranch",e,t,n),a=T("cond",e,t,n),o=T("args",e,t,n);return(await a.data())[0]?n.functionMap[r].executeFunctionAsync(o,n.tensorArrayMap,n.tensorListMap):n.functionMap[s].executeFunctionAsync(o,n.tensorArrayMap,n.tensorListMap)}case"While":case"StatelessWhile":{const r=T("body",e,t,n),s=T("cond",e,t,n),a=T("args",e,t,n),o=await n.functionMap[s].executeFunctionAsync(a,n.tensorArrayMap,n.tensorListMap),i=a.map((e=>e.id));let u=await o[0].data();o.forEach((e=>{e.kept||-1!==i.indexOf(e.id)||e.dispose()}));let p=a;for(;u[0];){const e=p;p=await n.functionMap[r].executeFunctionAsync(p,n.tensorArrayMap,n.tensorListMap);const t=p.map((e=>e.id));e.forEach((e=>{e.kept||-1!==i.indexOf(e.id)||-1!==t.indexOf(e.id)||e.dispose()}));const a=await n.functionMap[s].executeFunctionAsync(p,n.tensorArrayMap,n.tensorListMap);u=await a[0].data(),a.forEach((e=>{e.kept||-1!==i.indexOf(e.id)||-1!==t.indexOf(e.id)||e.dispose()}))}return p}case"LoopCond":return[D(T("pred",e,t,n))];case"Switch":{const r=T("pred",e,t,n);let s=T("data",e,t,n);return s.kept||(s=D(s)),(await r.data())[0]?[void 0,s]:[s,void 0]}case"Merge":{const r=e.inputNames.find((e=>void 0!==v(e,t,n)));if(r){return[D(v(r,t,n))]}return}case"Enter":{const r=T("frameName",e,t,n),s=T("tensor",e,t,n);return n.enterFrame(r),[D(s)]}case"Exit":{const r=T("tensor",e,t,n);return n.exitFrame(),[D(r)]}case"NextIteration":{const r=T("tensor",e,t,n);return n.nextIteration(),[D(r)]}case"TensorArrayV3":{const r=T("size",e,t,n),a=T("dtype",e,t,n),o=T("elementShape",e,t,n),i=T("dynamicSize",e,t,n),u=T("clearAfterRead",e,t,n),p=T("identicalElementShapes",e,t,n),l=T("name",e,t,n),c=new xi(l,a,r,o,p,i,u);return n.addTensorArray(c),[c.idTensor,s(1)]}case"TensorArrayWriteV3":{const r=T("tensorArrayId",e,t,n),s=T("index",e,t,n),a=T("tensor",e,t,n),o=n.getTensorArray(r.id);return o.write(s,a),[o.idTensor]}case"TensorArrayReadV3":{const r=T("tensorArrayId",e,t,n),s=T("index",e,t,n);return[n.getTensorArray(r.id).read(s)]}case"TensorArrayGatherV3":{const r=T("tensorArrayId",e,t,n),s=T("indices",e,t,n),a=T("dtype",e,t,n);return[n.getTensorArray(r.id).gather(s,a)]}case"TensorArrayScatterV3":{const r=T("tensorArrayId",e,t,n),s=T("indices",e,t,n),a=T("tensor",e,t,n),o=n.getTensorArray(r.id);return o.scatter(s,a),[o.idTensor]}case"TensorArrayConcatV3":{const r=T("tensorArrayId",e,t,n),s=n.getTensorArray(r.id),a=T("dtype",e,t,n);return[s.concat(a)]}case"TensorArraySplitV3":{const r=T("tensorArrayId",e,t,n),s=T("tensor",e,t,n),a=T("lengths",e,t,n),o=n.getTensorArray(r.id);return o.split(a,s),[o.idTensor]}case"TensorArraySizeV3":{const r=T("tensorArrayId",e,t,n),a=n.getTensorArray(r.id);return[s(a.size(),"int32")]}case"TensorArrayCloseV3":{const r=T("tensorArrayId",e,t,n),s=n.getTensorArray(r.id);return s.clearAndClose(),[s.idTensor]}case"TensorListSetItem":{const r=T("tensorListId",e,t,n),s=T("index",e,t,n),a=T("tensor",e,t,n),o=n.getTensorList(r.id);return o.setItem(s,a),[o.idTensor]}case"TensorListGetItem":{const r=T("tensorListId",e,t,n),s=T("index",e,t,n),a=T("elementShape",e,t,n),o=T("elementDType",e,t,n);return[n.getTensorList(r.id).getItem(s,a,o)]}case"TensorListScatterV2":case"TensorListScatter":{const r=T("indices",e,t,n),s=function(e,t,n,r){if(t.length!==e.shape[0])throw new Error(`Expected len(indices) == tensor.shape[0], but saw: ${t.length} vs. ${e.shape[0]}`);const s=Math.max(...t);if(null!=r&&-1!==r&&s>=r)throw new Error(`Max index must be < array size (${s}  vs. ${r})`);const a=new wi([],n,e.dtype,r),o=p(e,0);return t.forEach(((e,t)=>{a.setItem(e,o[t])})),a}(T("tensor",e,t,n),r,T("elementShape",e,t,n),T("numElements",e,t,n));return n.addTensorList(s),[s.idTensor]}case"TensorListReserve":case"EmptyTensorList":{const r=T("elementShape",e,t,n),s=T("elementDType",e,t,n);let a;a="TensorListReserve"===e.op?"numElements":"maxNumElements";const o=T(a,e,t,n),i=function(e,t,n,r){return new wi([],e,t,r)}(r,s,0,"TensorListReserve"===e.op?-1:o);return n.addTensorList(i),[i.idTensor]}case"TensorListGather":{const r=T("tensorListId",e,t,n),s=T("indices",e,t,n),a=T("elementShape",e,t,n),o=T("elementDType",e,t,n);return[n.getTensorList(r.id).gather(s,o,a)]}case"TensorListStack":{const r=T("tensorListId",e,t,n),s=T("elementShape",e,t,n),a=T("elementDType",e,t,n),o=T("numElements",e,t,n);return[n.getTensorList(r.id).stack(s,a,o)]}case"TensorListFromTensor":{const r=function(e,t,n){const r=e.dtype;if(e.shape.length<1)throw new Error(`Tensor must be at least a vector, but saw shape: ${e.shape}`);if(e.dtype!==n)throw new Error(`Invalid data types; op elements ${e.dtype}, but list elements ${n}`);yi(e.shape.slice(1),t,"TensorList shape mismatch: ");const s=p(e);return new wi(s,t,r)}(T("tensor",e,t,n),T("elementShape",e,t,n),T("elementDType",e,t,n));return n.addTensorList(r),[r.idTensor]}case"TensorListConcat":case"TensorListConcatV2":{const r=T("tensorListId",e,t,n),s=n.getTensorList(r.id),a=T("dtype",e,t,n),o=T("elementShape",e,t,n);return[s.concat(a,o)]}case"TensorListPushBack":{const r=T("tensorListId",e,t,n),s=T("tensor",e,t,n),a=n.getTensorList(r.id);return a.pushBack(s),[a.idTensor]}case"TensorListPopBack":{const r=T("tensorListId",e,t,n),s=T("elementShape",e,t,n),a=T("elementDType",e,t,n);return[n.getTensorList(r.id).popBack(s,a)]}case"TensorListSplit":{const r=T("tensor",e,t,n),s=T("elementShape",e,t,n),a=function(e,t,n){let r=0;const s=t.map((e=>(r+=e,r)));if(r!==e.shape[0])throw new Error(`Expected sum of lengths to be equal to\n          tensor.shape[0], but sum of lengths is\n        ${r}, and tensor's shape is: ${e.shape}`);const a=Ni(e.shape.slice(1),n),o=0===r?0:e.size/r,i=l((()=>{const n=[];e=c(e,[1,r,o]);for(let r=0;r<t.length;++r){const i=[0,0===r?0:s[r-1],0],u=[1,t[r],o];n[r]=c(h(e,i,u),a)}return e.dispose(),n})),u=new wi([],n,e.dtype,t.length);for(let e=0;e<i.length;e++)u.setItem(e,i[e]);return u}(r,T("lengths",e,t,n),s);return n.addTensorList(a),[a.idTensor]}case"TensorListLength":{const r=T("tensorListId",e,t,n),a=n.getTensorList(r.id);return[s(a.size(),"int32")]}case"TensorListResize":{const r=T("tensorListId",e,t,n),s=T("size",e,t,n),a=n.getTensorList(r.id).resize(s);return n.addTensorList(a),[a.idTensor]}default:throw TypeError(`Node type ${e.op} is not implemented`)}};function Ti(e,t,n){const[r,s]=T("fusedOps",e,t,n),a="biasadd"===r,o=!a,i="prelu"===s,u="fusedbatchnorm"===r,p=T("numArgs",e,t,n);if(a){if(i&&2!==p)throw new Error("FusedConv2d and DepthwiseConv2d with BiasAdd and Prelu must have two extra arguments: bias and alpha.");if(!i&&a&&1!==p)throw new Error("FusedConv2d and DepthwiseConv2d with BiasAdd must have one extra argument: bias.")}if(u)throw new Error("FusedConv2d and DepthwiseConv2d with FusedBatchNorm is not supported");const l=T("strides",e,t,n),c=$(e,t,n),h=T("dataFormat",e,t,n).toUpperCase(),d=T("dilations",e,t,n);let[m,f]=T("args",e,t,n);o&&(f=m,m=void 0);return{stride:l,pad:c,dataFormat:h,dilations:d,biasArg:m,preluArg:f,activationFunc:s,leakyreluAlpha:T("leakyreluAlpha",e,t,n)}}function vi(e,t,n){return{boxes:T("boxes",e,t,n),scores:T("scores",e,t,n),maxOutputSize:T("maxOutputSize",e,t,n),iouThreshold:T("iouThreshold",e,t,n),scoreThreshold:T("scoreThreshold",e,t,n),softNmsSigma:T("softNmsSigma",e,t,n)}}class _i{get id(){return this.handle.id}constructor(e,t){this.keyDType=e,this.valueDType=t,this.handle=s(0),this.tensorMap=new Map,a(this.handle)}clearAndClose(){this.tensorMap.forEach((e=>e.dispose())),this.tensorMap.clear(),this.handle.dispose()}size(){return this.tensorMap.size}tensorSize(){return Cr(this.size(),"int32")}async import(e,t){this.checkKeyAndValueTensor(e,t);const r=await e.data();return this.tensorMap.forEach((e=>e.dispose())),this.tensorMap.clear(),l((()=>{const e=p(t),s=r.length,o=e.length;n.assert(s===o,(()=>`The number of elements doesn't match, keys has ${s} elements, the values has ${o} elements.`));for(let t=0;t<s;t++){const n=r[t],s=e[t];a(s),this.tensorMap.set(n,s)}return this.handle}))}async find(e,t){this.checkKeyAndValueTensor(e,t);const n=await e.data();return l((()=>{const e=[];for(let r=0;r<n.length;r++){const s=n[r],a=this.findWithDefault(s,t);e.push(a)}return i(e)}))}findWithDefault(e,t){const n=this.tensorMap.get(e);return null!=n?n:t}checkKeyAndValueTensor(e,t){if(e.dtype!==this.keyDType)throw new Error(`Expect key dtype ${this.keyDType}, but got ${e.dtype}`);if(t.dtype!==this.valueDType)throw new Error(`Expect value dtype ${this.valueDType}, but got ${t.dtype}`)}}function Si(t,r,s,a,o=e.tidy){const i=((e,t,r)=>{switch(e.category){case"arithmetic":return o((()=>((e,t,n,r=fi)=>{switch(e.op){case"BiasAdd":case"AddV2":case"Add":return[r.add(T("a",e,t,n),T("b",e,t,n))];case"AddN":return[r.addN(T("tensors",e,t,n))];case"FloorMod":case"Mod":return[r.mod(T("a",e,t,n),T("b",e,t,n))];case"Mul":return[r.mul(T("a",e,t,n),T("b",e,t,n))];case"RealDiv":case"Div":return[r.div(T("a",e,t,n),T("b",e,t,n))];case"DivNoNan":return[r.divNoNan(T("a",e,t,n),T("b",e,t,n))];case"FloorDiv":return[r.floorDiv(T("a",e,t,n),T("b",e,t,n))];case"Sub":return[r.sub(T("a",e,t,n),T("b",e,t,n))];case"Minimum":return[r.minimum(T("a",e,t,n),T("b",e,t,n))];case"Maximum":return[r.maximum(T("a",e,t,n),T("b",e,t,n))];case"Pow":return[r.pow(T("a",e,t,n),T("b",e,t,n))];case"SquaredDifference":return[r.squaredDifference(T("a",e,t,n),T("b",e,t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"basic_math":return o((()=>((e,t,n,r=fi)=>{switch(e.op){case"Abs":case"ComplexAbs":return[r.abs(T("x",e,t,n))];case"Acos":return[r.acos(T("x",e,t,n))];case"Acosh":return[r.acosh(T("x",e,t,n))];case"Asin":return[r.asin(T("x",e,t,n))];case"Asinh":return[r.asinh(T("x",e,t,n))];case"Atan":return[r.atan(T("x",e,t,n))];case"Atan2":return[r.atan2(T("x",e,t,n),T("y",e,t,n))];case"Atanh":return[r.atanh(T("x",e,t,n))];case"Ceil":return[r.ceil(T("x",e,t,n))];case"Complex":return[r.complex(T("real",e,t,n),T("imag",e,t,n))];case"Cos":return[r.cos(T("x",e,t,n))];case"Cosh":return[r.cosh(T("x",e,t,n))];case"Elu":return[r.elu(T("x",e,t,n))];case"Erf":return[r.erf(T("x",e,t,n))];case"Exp":return[r.exp(T("x",e,t,n))];case"Expm1":return[r.expm1(T("x",e,t,n))];case"Floor":return[r.floor(T("x",e,t,n))];case"Log":return[r.log(T("x",e,t,n))];case"Log1p":return[r.log1p(T("x",e,t,n))];case"Imag":return[r.imag(T("x",e,t,n))];case"Neg":return[r.neg(T("x",e,t,n))];case"Reciprocal":return[r.reciprocal(T("x",e,t,n))];case"Real":return[r.real(T("x",e,t,n))];case"Relu":return[r.relu(T("x",e,t,n))];case"Round":return[r.round(T("x",e,t,n))];case"Selu":return[r.selu(T("x",e,t,n))];case"Sigmoid":return[r.sigmoid(T("x",e,t,n))];case"Sin":return[r.sin(T("x",e,t,n))];case"Sign":return[r.sign(T("x",e,t,n))];case"Sinh":return[r.sinh(T("x",e,t,n))];case"Softplus":return[r.softplus(T("x",e,t,n))];case"Sqrt":return[r.sqrt(T("x",e,t,n))];case"Square":return[r.square(T("x",e,t,n))];case"Tanh":return[r.tanh(T("x",e,t,n))];case"Tan":return[r.tan(T("x",e,t,n))];case"ClipByValue":return[r.clipByValue(T("x",e,t,n),T("clipValueMin",e,t,n),T("clipValueMax",e,t,n))];case"Relu6":return[r.relu6(T("x",e,t,n))];case"Rsqrt":return[r.rsqrt(v(e.inputNames[0],t,n))];case"Prod":return[r.prod(T("x",e,t,n),T("axes",e,t,n))];case"LeakyRelu":return[r.leakyRelu(T("x",e,t,n),T("alpha",e,t,n))];case"Prelu":return[r.prelu(T("x",e,t,n),T("alpha",e,t,n))];case"IsNan":return[r.isNaN(v(e.inputNames[0],t,n))];case"IsInf":return[r.isInf(v(e.inputNames[0],t,n))];case"IsFinite":return[r.isFinite(v(e.inputNames[0],t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"control":return ki(e,t,r);case"convolution":return o((()=>((e,t,n,r=fi)=>{switch(e.op){case"Conv1D":{const s=T("stride",e,t,n),a=T("pad",e,t,n),o=T("dataFormat",e,t,n).toUpperCase(),i=T("dilation",e,t,n);return[r.conv1d(T("x",e,t,n),T("filter",e,t,n),s,a,o,i)]}case"Conv2D":{const s=T("strides",e,t,n),a=$(e,t,n),o=T("dataFormat",e,t,n).toUpperCase(),i=T("dilations",e,t,n);return[r.conv2d(T("x",e,t,n),T("filter",e,t,n),[s[1],s[2]],a,o,[i[1],i[2]])]}case"_FusedConv2D":{const{stride:s,pad:a,dataFormat:o,dilations:i,biasArg:u,preluArg:p,activationFunc:l,leakyreluAlpha:c}=Ti(e,t,n);return[r.fused.conv2d({x:T("x",e,t,n),filter:T("filter",e,t,n),strides:[s[1],s[2]],pad:a,dataFormat:o,dilations:[i[1],i[2]],bias:u,activation:l,preluActivationWeights:p,leakyreluAlpha:c})]}case"FusedDepthwiseConv2dNative":{const{stride:s,pad:a,dataFormat:o,dilations:i,biasArg:u,preluArg:p,activationFunc:l,leakyreluAlpha:c}=Ti(e,t,n);return[r.fused.depthwiseConv2d({x:T("x",e,t,n),filter:T("filter",e,t,n),strides:[s[1],s[2]],pad:a,dataFormat:o,dilations:[i[1],i[2]],bias:u,activation:l,preluActivationWeights:p,leakyreluAlpha:c})]}case"Conv2DBackpropInput":case"Conv2dTranspose":{const s=T("outputShape",e,t,n),a=T("strides",e,t,n),o=$(e,t,n);return[r.conv2dTranspose(T("x",e,t,n),T("filter",e,t,n),s,[a[1],a[2]],o)]}case"DepthwiseConv2dNative":case"DepthwiseConv2d":{const s=T("strides",e,t,n),a=$(e,t,n),o=T("dilations",e,t,n),i=T("dataFormat",e,t,n).toUpperCase();return[r.depthwiseConv2d(T("input",e,t,n),T("filter",e,t,n),[s[1],s[2]],a,i,[o[1],o[2]])]}case"Conv3D":{const s=T("strides",e,t,n),a=T("pad",e,t,n),o=T("dataFormat",e,t,n).toUpperCase(),i=T("dilations",e,t,n);return[r.conv3d(T("x",e,t,n),T("filter",e,t,n),[s[1],s[2],s[3]],a,o,[i[1],i[2],i[3]])]}case"AvgPool":{const s=T("strides",e,t,n),a=T("pad",e,t,n),o=T("kernelSize",e,t,n);return[r.avgPool(T("x",e,t,n),[o[1],o[2]],[s[1],s[2]],a)]}case"MaxPool":{const s=T("strides",e,t,n),a=T("pad",e,t,n),o=T("kernelSize",e,t,n);return[r.maxPool(T("x",e,t,n),[o[1],o[2]],[s[1],s[2]],a)]}case"MaxPoolWithArgmax":{const s=T("strides",e,t,n),a=T("pad",e,t,n),o=T("kernelSize",e,t,n),i=T("includeBatchInIndex",e,t,n),{result:u,indexes:p}=r.maxPoolWithArgmax(T("x",e,t,n),[o[1],o[2]],[s[1],s[2]],a,i);return[u,p]}case"AvgPool3D":{const s=T("strides",e,t,n),a=T("pad",e,t,n),o=T("kernelSize",e,t,n);return[r.avgPool3d(T("x",e,t,n),[o[1],o[2],o[3]],[s[1],s[2],s[3]],a)]}case"MaxPool3D":{const s=T("strides",e,t,n),a=T("pad",e,t,n),o=T("kernelSize",e,t,n);return[r.maxPool3d(T("x",e,t,n),[o[1],o[2],o[3]],[s[1],s[2],s[3]],a)]}case"Dilation2D":{const s=T("strides",e,t,n),a=T("pad",e,t,n),o=T("dilations",e,t,n),i=s[1],u=s[2],p=o[1],l=o[2];return[r.dilation2d(T("x",e,t,n),T("filter",e,t,n),[i,u],a,[p,l],"NHWC")]}default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"creation":return o((()=>((e,t,n,r=fi)=>{switch(e.op){case"Fill":{const s=T("shape",e,t,n),a=T("dtype",e,t,n),o=T("value",e,t,n);return[r.fill(s,o,a)]}case"LinSpace":{const s=T("start",e,t,n),a=T("stop",e,t,n),o=T("num",e,t,n);return[r.linspace(s,a,o)]}case"Multinomial":{const s=T("logits",e,t,n),a=T("numSamples",e,t,n),o=T("seed",e,t,n);return[r.multinomial(s,a,o)]}case"OneHot":{const s=T("indices",e,t,n),a=T("depth",e,t,n),o=T("onValue",e,t,n),i=T("offValue",e,t,n),u=T("dtype",e,t,n);return[r.oneHot(s,a,o,i,u)]}case"Ones":return[r.ones(T("shape",e,t,n),T("dtype",e,t,n))];case"OnesLike":return[r.onesLike(T("x",e,t,n))];case"RandomStandardNormal":return[r.randomStandardNormal(T("shape",e,t,n),T("dtype",e,t,n),T("seed",e,t,n))];case"RandomUniform":return[r.randomUniform(T("shape",e,t,n),T("minval",e,t,n),T("maxval",e,t,n),T("dtype",e,t,n))];case"Range":{const s=T("start",e,t,n),a=T("stop",e,t,n),o=T("step",e,t,n);return[r.range(s,a,o,T("dtype",e,t,n))]}case"TruncatedNormal":{const s=T("shape",e,t,n),a=T("mean",e,t,n),o=T("stdDev",e,t,n),i=T("seed",e,t,n);return[r.truncatedNormal(s,a,o,T("dtype",e,t,n),i)]}case"Zeros":return[r.zeros(T("shape",e,t,n),T("dtype",e,t,n))];case"ZerosLike":return[r.zerosLike(T("x",e,t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"dynamic":return(async(e,t,n,r,s=fi)=>{switch(e.op){case"NonMaxSuppressionV5":{const{boxes:r,scores:a,maxOutputSize:o,iouThreshold:i,scoreThreshold:u,softNmsSigma:p}=vi(e,t,n),l=await s.image.nonMaxSuppressionWithScoreAsync(r,a,o,i,u,p);return[l.selectedIndices,l.selectedScores]}case"NonMaxSuppressionV4":{const{boxes:r,scores:a,maxOutputSize:o,iouThreshold:i,scoreThreshold:u}=vi(e,t,n),p=T("padToMaxOutputSize",e,t,n),l=await s.image.nonMaxSuppressionPaddedAsync(r,a,o,i,u,p);return[l.selectedIndices,l.validOutputs]}case"NonMaxSuppressionV3":case"NonMaxSuppressionV2":{const{boxes:r,scores:a,maxOutputSize:o,iouThreshold:i,scoreThreshold:u}=vi(e,t,n);return[await s.image.nonMaxSuppressionAsync(r,a,o,i,u)]}case"Where":{const r=s.cast(T("condition",e,t,n),"bool"),a=[await s.whereAsync(r)];return r.dispose(),a}case"ListDiff":return s.setdiff1dAsync(T("x",e,t,n),T("y",e,t,n));default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r);case"evaluation":return o((()=>((e,t,n,r=fi)=>{switch(e.op){case"LowerBound":{const s=T("sortedSequence",e,t,n),a=T("values",e,t,n);return[r.lowerBound(s,a)]}case"TopKV2":{const s=T("x",e,t,n),a=T("k",e,t,n),o=T("sorted",e,t,n),i=r.topk(s,a,o);return[i.values,i.indices]}case"UpperBound":{const s=T("sortedSequence",e,t,n),a=T("values",e,t,n);return[r.upperBound(s,a)]}case"Unique":{const s=T("x",e,t,n),a=r.unique(s);return[a.values,a.indices]}case"UniqueV2":{const s=T("x",e,t,n),a=T("axis",e,t,n),o=r.unique(s,a);return[o.values,o.indices]}default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"image":return o((()=>((e,t,n,r=fi)=>{switch(e.op){case"ResizeBilinear":{const s=T("images",e,t,n),a=T("size",e,t,n),o=T("alignCorners",e,t,n),i=T("halfPixelCenters",e,t,n);return[r.image.resizeBilinear(s,[a[0],a[1]],o,i)]}case"ResizeNearestNeighbor":{const s=T("images",e,t,n),a=T("size",e,t,n),o=T("alignCorners",e,t,n),i=T("halfPixelCenters",e,t,n);return[r.image.resizeNearestNeighbor(s,[a[0],a[1]],o,i)]}case"CropAndResize":{const s=T("image",e,t,n),a=T("boxes",e,t,n),o=T("boxInd",e,t,n),i=T("cropSize",e,t,n),u=T("method",e,t,n),p=T("extrapolationValue",e,t,n);return[r.image.cropAndResize(s,a,o,i,u,p)]}case"ImageProjectiveTransformV3":{const s=T("images",e,t,n),a=T("transforms",e,t,n),o=T("outputShape",e,t,n),i=T("fillValue",e,t,n),u=T("interpolation",e,t,n),p=T("fillMode",e,t,n);return[r.image.transform(s,a,u.toLowerCase(),p.toLowerCase(),i,o)]}default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"graph":return o((()=>((e,t,n,r=fi)=>{switch(e.op){case"Const":return t[e.name];case"PlaceholderWithDefault":const s=T("default",e,t,n);return[v(e.name,t,n)||s];case"Placeholder":return[v(e.name,t,n)];case"Identity":case"StopGradient":case"FakeQuantWithMinMaxVars":case"Snapshot":return[D(T("x",e,t,n))];case"IdentityN":return T("x",e,t,n).map((e=>D(e)));case"Shape":return[r.tensor1d(T("x",e,t,n).shape,"int32")];case"ShapeN":return T("x",e,t,n).map((e=>r.tensor1d(e.shape)));case"Size":return[r.scalar(T("x",e,t,n).size,"int32")];case"Rank":return[r.scalar(T("x",e,t,n).rank,"int32")];case"NoOp":return[r.scalar(1)];case"Print":const a=T("x",e,t,n),o=T("data",e,t,n),i=T("message",e,t,n),u=T("summarize",e,t,n);console.warn("The graph has a tf.print() operation,usually used for debugging, which slows down performance."),console.log(i);for(let e=0;e<o.length;e++)console.log(Array.prototype.slice.call(o[e].dataSync()).slice(0,u));return[a];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"logical":return o((()=>((e,t,n,r=fi)=>{switch(e.op){case"Equal":return[r.equal(T("a",e,t,n),T("b",e,t,n))];case"NotEqual":return[r.notEqual(T("a",e,t,n),T("b",e,t,n))];case"Greater":return[r.greater(T("a",e,t,n),T("b",e,t,n))];case"GreaterEqual":return[r.greaterEqual(T("a",e,t,n),T("b",e,t,n))];case"Less":return[r.less(T("a",e,t,n),T("b",e,t,n))];case"LessEqual":return[r.lessEqual(T("a",e,t,n),T("b",e,t,n))];case"LogicalAnd":return[r.logicalAnd(T("a",e,t,n),T("b",e,t,n))];case"LogicalNot":return[r.logicalNot(T("a",e,t,n))];case"LogicalOr":return[r.logicalOr(T("a",e,t,n),T("b",e,t,n))];case"Select":case"SelectV2":return[r.where(T("condition",e,t,n),T("a",e,t,n),T("b",e,t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"matrices":return o((()=>((e,t,n,r=fi)=>{switch(e.op){case"BatchMatMul":case"BatchMatMulV2":case"MatMul":return[r.matMul(T("a",e,t,n),T("b",e,t,n),T("transposeA",e,t,n),T("transposeB",e,t,n))];case"Einsum":return[r.einsum(T("equation",e,t,n),...T("tensors",e,t,n))];case"Transpose":return[r.transpose(T("x",e,t,n),T("perm",e,t,n))];case"_FusedMatMul":const[s,a]=T("fusedOps",e,t,n),o="biasadd"===s,i="prelu"===a,u=T("numArgs",e,t,n),p=T("leakyreluAlpha",e,t,n);if(o){if(i&&2!==u)throw new Error("Fused MatMul with BiasAdd and Prelu must have two extra arguments: bias and alpha.");if(!i&&1!==u)throw new Error("Fused MatMul with BiasAdd must have one extra argument: bias.")}const[l,c]=T("args",e,t,n);return[r.fused.matMul({a:T("a",e,t,n),b:T("b",e,t,n),transposeA:T("transposeA",e,t,n),transposeB:T("transposeB",e,t,n),bias:l,activation:a,preluActivationWeights:c,leakyreluAlpha:p})];case"MatrixBandPart":return[r.linalg.bandPart(T("a",e,t,n),T("numLower",e,t,n),T("numUpper",e,t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"normalization":return o((()=>((e,t,n,r=fi)=>{switch(e.op){case"EuclideanNorm":return[r.euclideanNorm(T("x",e,t,n),T("axis",e,t,n),T("keepDims",e,t,n))];case"FusedBatchNorm":case"FusedBatchNormV2":case"FusedBatchNormV3":return[r.batchNorm(T("x",e,t,n),T("mean",e,t,n),T("variance",e,t,n),T("offset",e,t,n),T("scale",e,t,n),T("epsilon",e,t,n))];case"LRN":return[r.localResponseNormalization(T("x",e,t,n),T("radius",e,t,n),T("bias",e,t,n),T("alpha",e,t,n),T("beta",e,t,n))];case"Softmax":return[r.softmax(T("x",e,t,n))];case"LogSoftmax":return[r.logSoftmax(T("x",e,t,n))];case"SparseToDense":return[r.sparseToDense(T("sparseIndices",e,t,n),T("outputShape",e,t,n),T("sparseValues",e,t,n),T("defaultValue",e,t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"ragged":return o((()=>((e,t,n,r=fi)=>{switch(e.op){case"RaggedGather":{const{outputNestedSplits:s,outputDenseValues:a}=r.raggedGather(T("paramsNestedSplits",e,t,n),T("paramsDenseValues",e,t,n),T("indices",e,t,n),T("outputRaggedRank",e,t,n));return s.concat(a)}case"RaggedRange":{const{rtNestedSplits:s,rtDenseValues:a}=r.raggedRange(T("starts",e,t,n),T("limits",e,t,n),T("splits",e,t,n));return[s,a]}case"RaggedTensorToTensor":return[r.raggedTensorToTensor(T("shape",e,t,n),T("values",e,t,n),T("defaultValue",e,t,n),T("rowPartitionTensors",e,t,n),T("rowPartitionTypes",e,t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"reduction":return o((()=>((e,t,n,r=fi)=>{switch(e.op){case"Max":{const s=T("axis",e,t,n),a=T("keepDims",e,t,n);return[r.max(T("x",e,t,n),s,a)]}case"Mean":{const s=T("axis",e,t,n),a=T("keepDims",e,t,n);return[r.mean(T("x",e,t,n),s,a)]}case"Min":{const s=T("axis",e,t,n),a=T("keepDims",e,t,n);return[r.min(T("x",e,t,n),s,a)]}case"Sum":{const s=T("axis",e,t,n),a=T("keepDims",e,t,n);return[r.sum(T("x",e,t,n),s,a)]}case"All":{const s=T("axis",e,t,n),a=T("keepDims",e,t,n);return[r.all(T("x",e,t,n),s,a)]}case"Any":{const s=T("axis",e,t,n),a=T("keepDims",e,t,n);return[r.any(T("x",e,t,n),s,a)]}case"ArgMax":{const s=T("axis",e,t,n);return[r.argMax(T("x",e,t,n),s)]}case"ArgMin":{const s=T("axis",e,t,n);return[r.argMin(T("x",e,t,n),s)]}case"Prod":{const s=T("axis",e,t,n),a=T("keepDims",e,t,n);return[r.prod(T("x",e,t,n),s,a)]}case"Cumprod":{const s=T("axis",e,t,n),a=T("exclusive",e,t,n),o=T("reverse",e,t,n);return[r.cumprod(T("x",e,t,n),s,a,o)]}case"Cumsum":{const s=T("axis",e,t,n),a=T("exclusive",e,t,n),o=T("reverse",e,t,n);return[r.cumsum(T("x",e,t,n),s,a,o)]}case"Bincount":const s=T("x",e,t,n),a=T("weights",e,t,n),o=T("size",e,t,n);return[r.bincount(s,a,o)];case"DenseBincount":{const s=T("x",e,t,n),a=T("weights",e,t,n),o=T("size",e,t,n),i=T("binaryOutput",e,t,n);return[r.denseBincount(s,a,o,i)]}default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"slice_join":return o((()=>((e,t,r,s=fi)=>{switch(e.op){case"ConcatV2":case"Concat":{const n=T("n",e,t,r),a=T("axis",e,t,r);let o=T("tensors",e,t,r);return o=o.slice(0,n),[s.concat(o,a)]}case"Gather":{const n=T("x",e,t,r),a=T("indices",e,t,r);return[s.gather(n,s.cast(a,"int32"),0)]}case"GatherV2":{const n=T("axis",e,t,r),a=T("batchDims",e,t,r),o=T("x",e,t,r),i=T("indices",e,t,r);return[s.gather(o,s.cast(i,"int32"),n,a)]}case"Reverse":{const n=T("dims",e,t,r),a=[];for(let e=0;e<n.length;e++)n[e]&&a.push(e);const o=T("x",e,t,r);return[s.reverse(o,a)]}case"ReverseV2":{const n=T("axis",e,t,r),a=T("x",e,t,r);return[s.reverse(a,n)]}case"Slice":{const n=T("begin",e,t,r),a=T("size",e,t,r);return[s.slice(T("x",e,t,r),n,a)]}case"StridedSlice":{const n=T("begin",e,t,r),a=T("end",e,t,r),o=T("strides",e,t,r),i=T("beginMask",e,t,r),u=T("endMask",e,t,r),p=T("ellipsisMask",e,t,r),l=T("newAxisMask",e,t,r),c=T("shrinkAxisMask",e,t,r),h=T("x",e,t,r);return[s.stridedSlice(h,n,a,o,i,u,p,l,c)]}case"Pack":return l((()=>{const a=T("axis",e,t,r),o=T("tensors",e,t,r),i=o[0].shape,u=s.squeeze(o[0]).shape,p=o.map((e=>{const t=n.arraysEqual(e.shape,i);if(!t&&!n.arraysEqual(s.squeeze(e).shape,u))throw new Error("the input tensors shape does not match");return t?e:s.reshape(e,i)}));return[s.stack(p,a)]}));case"Unpack":{const n=T("axis",e,t,r),a=T("tensor",e,t,r);return s.unstack(a,n)}case"Tile":{const n=T("reps",e,t,r);return[s.tile(T("x",e,t,r),n)]}case"Split":case"SplitV":{const n=T("axis",e,t,r),a=T("numOrSizeSplits",e,t,r),o=T("x",e,t,r);return s.split(o,a,n)}case"ScatterNd":{const n=T("indices",e,t,r),a=T("values",e,t,r),o=T("shape",e,t,r);return[s.scatterND(n,a,o)]}case"GatherNd":{const n=T("x",e,t,r),a=T("indices",e,t,r);return[s.gatherND(n,a)]}case"SparseToDense":{const n=T("sparseIndices",e,t,r),a=T("outputShape",e,t,r),o=T("sparseValues",e,t,r),i=T("defaultValue",e,t,r);return[s.sparseToDense(n,o,a,o.dtype===i.dtype?i:s.cast(i,o.dtype))]}case"TensorScatterUpdate":{const n=T("indices",e,t,r),a=T("values",e,t,r),o=T("tensor",e,t,r);return[s.tensorScatterUpdate(o,n,a)]}default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"sparse":return o((()=>((e,t,n,r=fi)=>{switch(e.op){case"SparseFillEmptyRows":{const{outputIndices:s,outputValues:a,emptyRowIndicator:o,reverseIndexMap:i}=r.sparse.sparseFillEmptyRows(T("indices",e,t,n),T("values",e,t,n),T("denseShape",e,t,n),T("defaultValue",e,t,n));return[s,a,o,i]}case"SparseReshape":{const{outputIndices:s,outputShape:a}=r.sparse.sparseReshape(T("inputIndices",e,t,n),T("inputShape",e,t,n),T("newShape",e,t,n));return[s,a]}case"SparseSegmentMean":return[r.sparse.sparseSegmentMean(T("data",e,t,n),T("indices",e,t,n),T("segmentIds",e,t,n))];case"SparseSegmentSum":return[r.sparse.sparseSegmentSum(T("data",e,t,n),T("indices",e,t,n),T("segmentIds",e,t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"spectral":return o((()=>((e,t,n,r=fi)=>{switch(e.op){case"FFT":return[r.fft(T("x",e,t,n))];case"IFFT":return[r.ifft(T("x",e,t,n))];case"RFFT":return[r.rfft(T("x",e,t,n))];case"IRFFT":return[r.irfft(T("x",e,t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"string":return o((()=>((e,t,n,r=fi)=>{switch(e.op){case"StaticRegexReplace":return[r.string.staticRegexReplace(T("input",e,t,n),T("pattern",e,t,n),T("rewrite",e,t,n),T("replaceGlobal",e,t,n))];case"StringNGrams":{const{nGrams:s,nGramsSplits:a}=r.string.stringNGrams(T("data",e,t,n),T("dataSplits",e,t,n),T("separator",e,t,n),T("nGramWidths",e,t,n),T("leftPad",e,t,n),T("rightPad",e,t,n),T("padWidth",e,t,n),T("preserveShortSequences",e,t,n));return[s,a]}case"StringSplit":{const{indices:s,values:a,shape:o}=r.string.stringSplit(T("input",e,t,n),T("delimiter",e,t,n),T("skipEmpty",e,t,n));return[s,a,o]}case"StringToHashBucketFast":return[r.string.stringToHashBucketFast(T("input",e,t,n),T("numBuckets",e,t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"transformation":return o((()=>((e,t,n,r=fi)=>{switch(e.op){case"Cast":return[r.cast(T("x",e,t,n),T("dtype",e,t,n))];case"ExpandDims":{const s=T("axis",e,t,n);return[r.expandDims(T("x",e,t,n),s)]}case"Squeeze":{const s=T("axis",e,t,n);return[r.squeeze(T("x",e,t,n),s)]}case"Reshape":return[r.reshape(T("x",e,t,n),T("shape",e,t,n))];case"MirrorPad":return[r.mirrorPad(T("x",e,t,n),T("padding",e,t,n),T("mode",e,t,n))];case"PadV2":case"Pad":return[r.pad(T("x",e,t,n),T("padding",e,t,n),T("constantValue",e,t,n))];case"SpaceToBatchND":{const s=T("blockShape",e,t,n),a=T("paddings",e,t,n);return[r.spaceToBatchND(T("x",e,t,n),s,a)]}case"BatchToSpaceND":{const s=T("blockShape",e,t,n),a=T("crops",e,t,n);return[r.batchToSpaceND(T("x",e,t,n),s,a)]}case"DepthToSpace":{const s=T("blockSize",e,t,n),a=T("dataFormat",e,t,n).toUpperCase();return[r.depthToSpace(T("x",e,t,n),s,a)]}case"BroadcastTo":return[r.broadcastTo(T("x",e,t,n),T("shape",e,t,n))];case"BroadcastArgs":return[r.broadcastArgs(T("s0",e,t,n),T("s1",e,t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"hash_table":return(async(e,t,n,r)=>{switch(e.op){case"HashTable":case"HashTableV2":{const s=r.getHashTableHandleByName(e.name);if(null!=s)return[s];{const s=T("keyDType",e,t,n),a=T("valueDType",e,t,n),o=new _i(s,a);return r.addHashTable(e.name,o),[o.handle]}}case"InitializeTable":case"InitializeTableV2":case"LookupTableImport":case"LookupTableImportV2":{const s=T("tableHandle",e,t,n,r),a=T("keys",e,t,n),o=T("values",e,t,n),i=r.getHashTableById(s.id);return[await i.import(a,o)]}case"LookupTableFind":case"LookupTableFindV2":{const s=T("tableHandle",e,t,n,r),a=T("keys",e,t,n),o=T("defaultValue",e,t,n),i=r.getHashTableById(s.id);return[await i.find(a,o)]}case"LookupTableSize":case"LookupTableSizeV2":{const s=T("tableHandle",e,t,n,r);return[r.getHashTableById(s.id).tensorSize()]}default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r,a);case"custom":const s=w(e.op);if(s&&s.customExecutor)return s.customExecutor(new ce(e,t,r));throw TypeError(`Custom op ${e.op} is not registered.`);default:throw TypeError(`Unknown op '${e.op}'. File an issue at https://github.com/tensorflow/tfjs/issues so we can add it, or register a custom execution with tf.registerOp()`)}})(t,r,s);return e.util.isPromise(i)?i.then((e=>[].concat(e))):[].concat(i)}class Ei{constructor(e={},t={},n={},r={},s){this.weightMap=e,this.tensorArrayMap=t,this.tensorListMap=n,this.functionMap=r,this.parseNodeNameCache=s,this.rootContext={id:0,frameName:"",iterationId:0},this.contexts=[this.rootContext],this.lastId=0,this.generateCurrentContextIds()}newFrame(e,t){return{id:e,frameName:t,iterationId:0}}set currentContext(e){this.contexts!==e&&(this.contexts=e,this.generateCurrentContextIds())}get currentContext(){return this.contexts}get currentContextId(){return this._currentContextIds[0]}get currentContextIds(){return this._currentContextIds}generateCurrentContextIds(){const e=[];for(let t=0;t<this.contexts.length-1;t++){const n=this.contexts.slice(0,this.contexts.length-t);e.push(this.contextIdforContexts(n))}e.push(""),this._currentContextIds=e}contextIdforContexts(e){return e?e.map((e=>0===e.id&&0===e.iterationId?"":`${e.frameName}-${e.iterationId}`)).join("/"):""}enterFrame(e){this.contexts&&(this.lastId++,this.contexts=this.contexts.slice(),this.contexts.push(this.newFrame(this.lastId,e)),this._currentContextIds.unshift(this.contextIdforContexts(this.contexts)))}exitFrame(){if(!(this.contexts&&this.contexts.length>1))throw new Error("Cannot exit frame, the context is empty");this.contexts=this.contexts.slice(),this.contexts.splice(-1),this.currentContextIds.shift()}nextIteration(){if(!(this.contexts&&this.contexts.length>0))throw new Error("Cannot increase frame iteration, the context is empty");{this.contexts=this.contexts.slice(),this.lastId++;const e=Object.assign({},this.contexts[this.contexts.length-1]);e.iterationId+=1,e.id=this.lastId,this.contexts.splice(-1,1,e),this._currentContextIds.splice(0,1,this.contextIdforContexts(this.contexts))}}getWeight(e){return this.weightMap[e]}addTensorArray(e){this.tensorArrayMap[e.id]=e}getTensorArray(e){return this.tensorArrayMap[e]}addTensorList(e){this.tensorListMap[e.id]=e}getTensorList(e){return this.tensorListMap[e]}dispose(e){for(const t in this.tensorArrayMap)this.tensorArrayMap[t].clearAndClose(e);for(const t in this.tensorListMap)this.tensorListMap[t].clearAndClose(e)}}function Ii(e,t,n,r){const s=new Set,a=[];let o=null,i=null;const u=new Set,p=new Set(Object.keys(e).map((e=>I(e)[0])));r=r||[];const l=new Set(r.map((e=>I(e.name)[0]))),c=[...t];for(;c.length>0;){const e=c.pop();(Ci(e)||Fi(e)||Ri(e))&&null==o&&(o=e,i=o.children.map((e=>e.name)).filter((e=>s.has(e)))),s.add(e.name),null==n[e.name]&&(p.has(e.name)||l.has(e.name)||(0!==e.inputs.length?e.inputs.forEach((e=>{u.has(e.name)||(u.add(e.name),c.push(e))})):a.push(e.name)))}return{inputs:e,outputs:t,usedNodes:s,missingInputs:a,dynamicNode:o,syncInputs:i}}function $i(e,t){const{usedNodes:n,inputs:r}=t,s=Object.keys(r).map((e=>I(e)[0])).map((t=>e.nodes[t])),a=e.initNodes||[],o=e=>n.has("string"==typeof e?e:e.name);function i(e){return[...new Map(e.map((e=>[e.name,e]))).values()]}const u=i([...s,...e.weights,...a]).filter(o),p=i([...u,...Object.values(e.nodes)]).filter(o),l=new Map(p.map((e=>[e.name,e]))),c={};for(const e of p){c[e.name]=c[e.name]||0;for(const t of e.children)o(t)||(c[t.name]=Number.POSITIVE_INFINITY),c[t.name]=(c[t.name]||0)+1}const h=Object.entries(c).filter((([,e])=>0===e)).map((([e])=>e)),d=[...h];for(;h.length>0;){const e=h.pop(),t=l.get(e);for(const e of t.children.filter(o))0==--c[e.name]&&(d.push(e.name),h.push(e.name))}const m=function(e,t){const n=new Map(e.map((e=>[e.name,e]))),r=t.map((e=>e.name)),s=new Set(r);for(;r.length>0;){const e=r.pop(),t=n.get(e);for(const e of t.children)n.has(e.name)&&!s.has(e.name)&&(s.add(e.name),r.push(e.name))}return e.filter((e=>s.has(e.name)))}(d.map((e=>l.get(e))),u);return function(e,t){const n=new Map(e.map(((e,t)=>[e.name,t]))),r=new Set(t.map((e=>e.name))),s=e=>r.has("string"==typeof e?e:e.name),a=new Set(e.map((e=>e.name))),o=e=>a.has("string"==typeof e?e:e.name);for(const t of e){for(const e of t.children.filter(o)){if(!n.has(e.name))throw new Di(`Child ${e.name} of node ${t.name} is unreachable.`);if(n.get(t.name)>n.get(e.name))throw new Di(`Node ${t.name} is scheduled to run after its child ${e.name}.`)}if(!s(t))for(const e of t.inputs){if(!n.has(e.name))throw new Di(`Input ${e.name} of node ${t.name} is unreachable.`);if(n.get(e.name)>n.get(t.name))throw new Di(`Node ${t.name} is scheduled to run before its input ${e.name}.`)}}}(m,u),m}class Di extends Error{constructor(e){super(`NodesExecutionOrderError: ${e}`)}}const Ai=new Set(["Switch","Merge","Enter","Exit","NextIteration","StatelessIf","StatelessWhile","if","While"]),Oi=new Set(["NonMaxSuppressionV2","NonMaxSuppressionV3","NonMaxSuppressionV5","Where"]),Mi=new Set(["HashTable","HashTableV2","LookupTableImport","LookupTableImportV2","LookupTableFind","LookupTableFindV2","LookupTableSize","LookupTableSizeV2"]);function Ci(e){return Ai.has(e.op)}function Fi(e){return Oi.has(e.op)}function Ri(e){return Mi.has(e.op)}class zi{get weightIds(){return this.parent?this.parent.weightIds:this._weightIds}get functionExecutorMap(){return this.parent?this.parent.functionExecutorMap:this._functionExecutorMap}get weightMap(){return this.parent?this.parent.weightMap:this._weightMap}set weightMap(e){const t=Object.keys(e).map((t=>e[t].map((e=>e.id))));this._weightIds=[].concat(...t),this._weightMap=e}set resourceManager(e){this._resourceManager=e}get inputs(){return this._inputs.map((e=>({name:e.name,shape:e.attrParams.shape?e.attrParams.shape.value:void 0,dtype:e.attrParams.dtype?e.attrParams.dtype.value:void 0})))}get outputs(){return this._outputs.map((e=>({name:e.name,shape:e.attrParams.shape?e.attrParams.shape.value:void 0,dtype:e.attrParams.dtype?e.attrParams.dtype.value:void 0})))}get inputNodes(){return this._inputs.map((e=>e.signatureKey||e.name))}get outputNodes(){return this._outputs.map((e=>{const t=e.signatureKey||e.name;return e.defaultOutput?`${t}:${e.defaultOutput}`:t}))}get functions(){return Object.keys(this._functions).reduce(((e,t)=>(e[t]=this._functions[t].signature,e)),{})}constructor(e,t){this.graph=e,this.parent=t,this.compiledMap=new Map,this.parseNodeNameCache=new Map,this._weightMap={},this.SEPARATOR=",",this._functions={},this._functionExecutorMap={},this.keepIntermediateTensors=!1,this._outputs=e.outputs,this._inputs=e.inputs,this._initNodes=e.initNodes,this._signature=e.signature,this._functions=e.functions,null!=e.functions&&Object.keys(e.functions).forEach((t=>{this._functionExecutorMap[t]=new zi(e.functions[t],this)}))}getCompilationKey(e,t){const n=e.map((e=>e.name)).sort(),r=t.map((e=>e.name)).sort();return n.join(this.SEPARATOR)+"--"+r.join(this.SEPARATOR)}compile(e,t){const n=Ii(e,t,this.weightMap,this._initNodes),{missingInputs:r,dynamicNode:s,syncInputs:a}=n;if(null!=s)throw new Error(`This execution contains the node '${s.name}', which has the dynamic op '${s.op}'. Please use model.executeAsync() instead. Alternatively, to avoid the dynamic ops, specify the inputs [${a}]`);if(r.length>0){const n=t.map((e=>e.name)),s=Object.keys(e);throw new Error(`Cannot compute the outputs [${n}] from the provided inputs [${s}]. Missing the following inputs: [${r}]`)}const o=$i(this.graph,n),i=function(e){const t=new Map(e.map(((e,t)=>[e.name,t]))),n=Number.MAX_SAFE_INTEGER,r=e.map(((e,t)=>Ci(e)?n:t)),s=e=>{const n=r[t.get(e.name)];return null==n?-1:n},a=e.map(((e,t)=>e.children.map(s).reduce(((e,t)=>Math.max(e,t)),r[t]))),o=new Map;for(let t=0;t<e.length;++t){const r=a[t];if(r===n)continue;const s=e[t],i=e[r];o.has(i.name)||o.set(i.name,[]),o.get(i.name).push(s)}return o}(o);return{orderedNodes:o,nodeLiveUntilMap:i}}cloneAndKeepTensor(e){if(null==e)return null;const t=e.clone();return a(t),t}cloneTensorList(e){if(!e)return null;const t=e.map((e=>this.cloneAndKeepTensor(e)));return t}cloneTensorMap(e){return Object.fromEntries(Object.entries(e).map((([e,t])=>[e,this.cloneTensorList(t)])))}execute(e,r){this.disposeIntermediateTensors(),e=this.mapInputs(e);const s=Object.keys(e).sort();this.checkInputs(e),this.checkInputShapeAndType(e),r=this.mapOutputs(r),this.checkOutputs(r);const a=s.map((e=>this.graph.nodes[I(e)[0]])),o=r.map((e=>I(e)[0])),i=new Set(o);let u=o.map((e=>this.graph.nodes[e]));0===u.length&&(u=this._outputs);const p=this.getCompilationKey(a,u);let c=this.compiledMap.get(p);null==c&&(c=this.compile(e,u),this.compiledMap.set(p,c));try{this.keepIntermediateTensors=t().getBool("KEEP_INTERMEDIATE_TENSORS")}catch(e){this.keepIntermediateTensors=!1,console.warn(e.message)}const h={},d={};return l((()=>{const t=new Ei(this.weightMap,h,d,this.functionExecutorMap,this.parseNodeNameCache),s=Object.assign({},this.weightMap);this.keepIntermediateTensors&&(this.clonedTensorsMap=this.cloneTensorMap(this.weightMap)),Object.keys(e).forEach((n=>{const[r,a]=I(n,t),o=[];o[a]=e[n],s[r]=o,this.keepIntermediateTensors&&(this.clonedTensorsMap[r]=this.cloneTensorList(o))}));const a=this.getFrozenTensorIds(s),{orderedNodes:o,nodeLiveUntilMap:u}=c;for(const e of o){if(s[e.name])continue;const r=Si(e,s,t,this._resourceManager);if(n.isPromise(r))throw new Error(`The execution of the op '${e.op}' returned a promise. Please use model.executeAsync() instead.`);s[e.name]=r,this.keepIntermediateTensors&&(this.clonedTensorsMap[e.name]=this.cloneTensorList(r)),this.checkTensorForDisposalWithNodeLiveUntilInfo(e,s,t,a,i,u.get(e.name))}return null==this.parent&&t.dispose(a),r.map((e=>v(e,s,t)))}))}getFrozenTensorIds(e){const t=[].concat.apply([],Object.keys(e).map((t=>e[t])).map((e=>e.map((e=>e.id)))));return new Set(t)}checkTensorForDisposal(e,t,n,r,s,a,o){if(!Ci(t)&&!a.has(e)){for(const r of n[e])null!=r&&(o[r.id]=(o[r.id]||0)+t.children.length);for(const e of t.inputs){if(Ci(e))continue;const t=_(e.name,n,r);if(null!=t)for(const e of t){if(!e||e.kept||s.has(e.id))continue;const t=o[e.id];1===t?(e.dispose(),delete o[e.id]):null!=t&&o[e.id]--}}}}checkTensorForDisposalWithNodeLiveUntilInfo(e,t,n,r,s,a){function o(e){return Ci(e)||s.has(e.name)}if(!Ci(e)&&null!=a)for(const e of a){if(o(e))continue;const s=_(e.name,t,n);for(const e of s)!e||e.kept||r.has(e.id)||e.dispose()}}async executeAsync(e,t){return this._executeAsync(e,t)}disposeIntermediateTensors(){this.clonedTensorsMap&&(Object.values(this.clonedTensorsMap).forEach((e=>{for(const t of e)t&&!t.isDisposed&&t.dispose()})),this.clonedTensorsMap=null)}getIntermediateTensors(){return this.clonedTensorsMap}async _executeAsync(e,n,r=!1,s={},a={}){this.disposeIntermediateTensors(),r||(e=this.mapInputs(e),this.checkInputs(e),this.checkInputShapeAndType(e),n=this.mapOutputs(n),this.checkOutputs(n));try{this.keepIntermediateTensors=t().getBool("KEEP_INTERMEDIATE_TENSORS")}catch(e){this.keepIntermediateTensors=!1,console.warn(e.message)}const o=new Ei(this.weightMap,s,a,this.functionExecutorMap,this.parseNodeNameCache);this.keepIntermediateTensors&&(this.clonedTensorsMap=this.cloneTensorMap(this.weightMap));const i=await this.executeWithControlFlow(e,o,n,r),u=n.map((e=>v(e,i,o))),p=u.map((e=>e.id)),l=Object.keys(e).map((t=>e[t].id)),c=new Set([...p,...l,...this.weightIds]);return Object.values(i).forEach((e=>{e.forEach((e=>{!e||e.isDisposed||c.has(e.id)||e.dispose()}))})),null==this.parent&&o.dispose(c),u}async executeFunctionAsync(e,t,n){const r=e.reduce(((e,t,n)=>(e[this.inputs[n].name]=t,e)),{});return this._executeAsync(r,this.outputNodes,!0,t,n)}async executeWithControlFlow(e,t,n,r){const s=Object.keys(e),a=s.map((e=>this.graph.nodes[I(e)[0]])),o=n.map((e=>I(e)[0])),i=new Set(o);let u=o.map((e=>this.graph.nodes[e]));0===u.length&&(u=this._outputs);const{usedNodes:p,missingInputs:l,dynamicNode:c,syncInputs:h}=Ii(e,u,this.weightMap,this._initNodes),d=[...a,...this.graph.weights,...this._initNodes||[]].map((e=>({node:e,contexts:t.currentContext}))),m=Object.assign({},this.weightMap);Object.keys(e).forEach((t=>{const[n,r]=I(t),s=[];s[r]=e[t],m[n]=s}));const f={},y=this.getFrozenTensorIds(m),g={};for(;d.length>0;){const e=this.processStack(a,d,t,m,g,y,i,f,p);await Promise.all(e)}null!=c||r||console.warn("This model execution did not contain any nodes with control flow or dynamic output shapes. You can use model.execute() instead.");const b=u.filter((e=>!Ci(e)&&!v(e.name,m,t))).map((e=>e.name));if(b.length>0){let e="";throw null!=c&&(e=`Alternatively, to avoid the dynamic ops, use model.execute() and specify the inputs [${h}]`),new Error(`Cannot compute the outputs [${b}] from the provided inputs [${s}]. Consider providing the following inputs: [${l}]. ${e}`)}return m}processStack(e,t,r,s,a,o,i,u,p){const l=[];for(;t.length>0;){const e=t.pop();r.currentContext=e.contexts;let c="";if("Enter"===e.node.op&&T("isConstant",e.node,s,r)&&([c]=S(e.node.name,r)),null==s[e.node.name]){const h=Si(e.node,s,r,this._resourceManager);c||([c]=S(e.node.name,r));const d=r.currentContext;n.isPromise(h)?l.push(h.then((n=>(s[c]=n,this.keepIntermediateTensors&&(this.clonedTensorsMap[c]=this.cloneTensorList(n)),r.currentContext=d,this.checkTensorForDisposal(c,e.node,s,r,o,i,u),this.processChildNodes(e.node,t,r,s,a,p),n)))):(s[c]=h,this.keepIntermediateTensors&&(this.clonedTensorsMap[c]=this.cloneTensorList(h)),this.checkTensorForDisposal(c,e.node,s,r,o,i,u),this.processChildNodes(e.node,t,r,s,a,p))}else this.processChildNodes(e.node,t,r,s,a,p)}return l}processChildNodes(e,t,n,r,s,a){e.children.forEach((e=>{const[o]=S(e.name,n);!s[o]&&a.has(e.name)&&("Merge"===e.op?e.inputNames.some((e=>!!v(e,r,n)))&&(s[o]=!0,t.push({contexts:n.currentContext,node:e})):e.inputNames.every((e=>!!v(e,r,n)))&&(s[o]=!0,t.push({contexts:n.currentContext,node:e})))}))}dispose(){Object.keys(this.weightMap).forEach((e=>this.weightMap[e].forEach((e=>e.dispose()))))}checkInputShapeAndType(e){Object.keys(e).forEach((t=>{const r=e[t],[s]=I(t),a=this.graph.nodes[s];if(a.attrParams.shape&&a.attrParams.shape.value){const e=a.attrParams.shape.value,t=e.length===r.shape.length&&r.shape.every(((t,n)=>-1===e[n]||e[n]===t));n.assert(t,(()=>`The shape of dict['${a.name}'] provided in model.execute(dict) must be [${e}], but was [${r.shape}]`))}a.attrParams.dtype&&a.attrParams.dtype.value&&n.assert(r.dtype===a.attrParams.dtype.value,(()=>`The dtype of dict['${a.name}'] provided in model.execute(dict) must be ${a.attrParams.dtype.value}, but was ${r.dtype}`))}))}mapInputs(e){var t,n;const r={};for(const s in e){const a=null===(n=null===(t=this._signature)||void 0===t?void 0:t.inputs)||void 0===n?void 0:n[s];null!=a?r[a.name]=e[s]:r[s]=e[s]}return r}checkInputs(e){const t=Object.keys(e).filter((e=>{const[t]=I(e);return null==this.graph.nodes[t]}));if(t.length>0)throw new Error(`The dict provided in model.execute(dict) has keys: [${t}] that are not part of graph`)}mapOutputs(e){return e.map((e=>{var t,n;const r=null===(n=null===(t=this._signature)||void 0===t?void 0:t.outputs)||void 0===n?void 0:n[e];return null!=r?r.name:e}),{})}checkOutputs(e){e.forEach((e=>{const[t]=I(e);if(!this.graph.nodes[t])throw new Error(`The output '${e}' is not found in the graph`)}))}}class Vi{constructor(e={},t={}){this.hashTableNameToHandle=e,this.hashTableMap=t}addHashTable(e,t){this.hashTableNameToHandle[e]=t.handle,this.hashTableMap[t.id]=t}getHashTableHandleByName(e){return this.hashTableNameToHandle[e]}getHashTableById(e){return this.hashTableMap[e]}dispose(){for(const e in this.hashTableMap)this.hashTableMap[e].clearAndClose(),delete this.hashTableMap[e];for(const e in this.hashTableNameToHandle)this.hashTableNameToHandle[e].dispose(),delete this.hashTableNameToHandle[e]}}class Li{get modelVersion(){return this.version}get inputNodes(){return this.executor.inputNodes}get outputNodes(){return this.executor.outputNodes}get inputs(){return this.executor.inputs}get outputs(){return this.executor.outputs}get weights(){return this.executor.weightMap}get metadata(){return this.artifacts.userDefinedMetadata}get modelSignature(){return this.signature}get modelStructuredOutputKeys(){return this.structuredOutputKeys}constructor(e,t={},n=d){this.modelUrl=e,this.loadOptions=t,this.version="n/a",this.io=n,null==t&&(this.loadOptions={}),this.resourceManager=new Vi}findIOHandler(){const e=this.modelUrl;if(null!=e.load)this.handler=e;else if(null!=this.loadOptions.requestInit)this.handler=this.io.browserHTTPRequest(e,this.loadOptions);else{const t=this.io.getLoadHandlers(e,this.loadOptions);if(0===t.length)t.push(this.io.browserHTTPRequest(e,this.loadOptions));else if(t.length>1)throw new Error(`Found more than one (${t.length}) load handlers for URL '${[e]}'`);this.handler=t[0]}}load(){if(this.findIOHandler(),null==this.handler.load)throw new Error("Cannot proceed with model loading because the IOHandler provided does not have the `load` method implemented.");const e=this.handler.load();return n.isPromise(e)?e.then((e=>this.loadSync(e))):this.loadSync(e)}loadSync(e){this.artifacts=e;const t=this.artifacts.modelTopology;let n=this.artifacts.signature;if(null!=this.artifacts.userDefinedMetadata){const e=this.artifacts.userDefinedMetadata;null!=e.signature&&(n=e.signature),null!=e.structuredOutputKeys&&(this.structuredOutputKeys=e.structuredOutputKeys)}this.signature=n,this.version=`${t.versions.producer}.${t.versions.minConsumer}`;const r=this.io.decodeWeights(this.artifacts.weightData,this.artifacts.weightSpecs);if(this.executor=new zi(Q.Instance.transformGraph(t,this.signature)),this.executor.weightMap=this.convertTensorMapToTensorsMap(r),this.executor.resourceManager=this.resourceManager,null!=e.modelInitializer&&null!=e.modelInitializer.node){const t=Q.Instance.transformGraph(e.modelInitializer);this.initializer=new zi(t),this.initializer.weightMap=this.executor.weightMap,this.initializer.resourceManager=this.resourceManager,this.initializerSignature=e.initializerSignature}return!0}async save(e,t){if("string"==typeof e){const t=this.io.getSaveHandlers(e);if(0===t.length)throw new Error(`Cannot find any save handlers for URL '${e}'`);if(t.length>1)throw new Error(`Found more than one (${t.length}) save handlers for URL '${e}'`);e=t[0]}if(null==e.save)throw new Error("GraphModel.save() cannot proceed because the IOHandler provided does not have the `save` attribute defined.");return e.save(this.artifacts)}addStructuredOutputNames(e){if(this.structuredOutputKeys){const t={};return(e instanceof m?[e]:e).forEach(((e,n)=>t[this.structuredOutputKeys[n]]=e)),t}return e}predict(e,t){const n=this.execute(e,this.outputNodes);return this.addStructuredOutputNames(n)}async predictAsync(e,t){const n=await this.executeAsync(e,this.outputNodes);return this.addStructuredOutputNames(n)}normalizeInputs(e){var t;if(!(e instanceof m||Array.isArray(e))){const n=null===(t=this.signature)||void 0===t?void 0:t.inputs;if(null!=n)for(const t in n){const r=n[t];null!=r.resourceId&&(e[t]=this.resourceIdToCapturedInput[r.resourceId])}return e}e=Array.isArray(e)?e:[e];const n=Object.keys(this.resourceIdToCapturedInput).length;if(e.length+n!==this.inputNodes.length)throw new Error(`Input tensor count mismatch, the graph model has ${this.inputNodes.length-n} non-resource placeholders, while there are ${e.length} input tensors provided.`);let r=0;return this.inputNodes.reduce(((t,n)=>{var s,a,o;const i=null===(o=null===(a=null===(s=this.signature)||void 0===s?void 0:s.inputs)||void 0===a?void 0:a[n])||void 0===o?void 0:o.resourceId;return t[n]=null!=i?this.resourceIdToCapturedInput[i]:e[r++],t}),{})}normalizeOutputs(e){return e=e||this.outputNodes,Array.isArray(e)?e:[e]}executeInitializerGraph(){return null==this.initializer?[]:null==this.initializerSignature?this.initializer.execute({},[]):this.initializer.execute({},Object.keys(this.initializerSignature.outputs))}async executeInitializerGraphAsync(){return null==this.initializer?[]:null==this.initializerSignature?this.initializer.executeAsync({},[]):this.initializer.executeAsync({},Object.keys(this.initializerSignature.outputs))}setResourceIdToCapturedInput(e){if(this.resourceIdToCapturedInput={},this.initializerSignature){const t=this.initializerSignature.outputs,n=Object.keys(t);for(let r=0;r<n.length;r++){const s=t[n[r]];this.resourceIdToCapturedInput[s.resourceId]=e[r]}}}execute(e,t){null==this.resourceIdToCapturedInput&&this.setResourceIdToCapturedInput(this.executeInitializerGraph()),e=this.normalizeInputs(e),t=this.normalizeOutputs(t);const n=this.executor.execute(e,t);return n.length>1?n:n[0]}async executeAsync(e,t){null==this.resourceIdToCapturedInput&&this.setResourceIdToCapturedInput(await this.executeInitializerGraphAsync()),e=this.normalizeInputs(e),t=this.normalizeOutputs(t);const n=await this.executor.executeAsync(e,t);return n.length>1?n:n[0]}getIntermediateTensors(){return this.executor.getIntermediateTensors()}disposeIntermediateTensors(){this.executor.disposeIntermediateTensors()}convertTensorMapToTensorsMap(e){return Object.keys(e).reduce(((t,n)=>(t[n]=[e[n]],t)),{})}dispose(){this.executor.dispose(),this.initializer&&(this.initializer.dispose(),this.resourceIdToCapturedInput&&f(this.resourceIdToCapturedInput)),this.resourceManager.dispose()}}async function Bi(e,t={},n=d){if(null==e)throw new Error("modelUrl in loadGraphModel() cannot be null. Please provide a url or an IOHandler that loads the model");null==t&&(t={}),t.fromTFHub&&"string"==typeof e&&(e=function(e){e.endsWith("/")||(e+="/");return`${e}model.json?tfjs-format=file`}(e));const r=new Li(e,t,n);return await r.load(),r}function Pi(e){if(null==e)throw new Error("modelUrl in loadGraphModelSync() cannot be null. Please provide model artifacts or an IOHandler that loads the model");let t;if(e instanceof Array){const[n,r]=e;if(!n)throw new Error("modelJSON must be the first element of the array");if(!(r&&r instanceof ArrayBuffer))throw new Error("An ArrayBuffer of weights must be the second element of the array");if(!("modelTopology"in n))throw new Error("Model JSON is missing 'modelTopology'");if(!("weightsManifest"in n))throw new Error("Model JSON is missing 'weightsManifest'");const s=d.getWeightSpecs(n.weightsManifest),a=d.getModelArtifactsForJSONSync(n,s,r);t=d.fromMemorySync(a)}else if("load"in e)t=e;else{if(!("modelTopology"in e&&"weightSpecs"in e&&"weightData"in e))throw new Error("Unknown model format");t=d.fromMemorySync(e)}const n=new Li(t);return n.load(),n}const Ki="4.4.0";export{Li as GraphModel,k as deregisterOp,Bi as loadGraphModel,Pi as loadGraphModelSync,x as registerOp,Ki as version_converter};
//# sourceMappingURL=tf-converter.fesm.min.js.map
